define(["require", "exports"], function (require, exports) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.jsonLoadValue = exports.jsonDumpValue = void 0;
    function jsonDumpValue(obj) {
        Object.keys(obj)
            .filter(function (key) { return obj[key] instanceof Object; })
            .forEach(function (key) { return obj[key] = JSON.stringify(obj[key]); });
        return obj;
    }
    exports.jsonDumpValue = jsonDumpValue;
    function jsonLoadValue(obj) {
        Object.keys(obj)
            .filter(function (key) { return typeof obj[key] == 'string'; })
            .filter(function (key) { return obj[key].startsWith('[') || obj[key].startsWith('{'); })
            .forEach(function (key) { return obj[key] = JSON.parse(obj[key]); });
        return obj;
    }
    exports.jsonLoadValue = jsonLoadValue;
});
