define(["require", "exports"], function (require, exports) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.isEmptyObject = exports.deepCopy = exports.removeEmtryAttributes = exports.assign = void 0;
    function assign(destination) {
        var sources = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            sources[_i - 1] = arguments[_i];
        }
        sources.forEach(function (source) { return Object.keys(source).forEach(function (key) { return destination[key] = source[key]; }); });
        return destination;
    }
    exports.assign = assign;
    function removeEmtryAttributes(obj) {
        Object.keys(obj).forEach(function (key) {
            var val = obj[key];
            if (val === null || val === undefined) {
                delete obj[key];
            }
        });
    }
    exports.removeEmtryAttributes = removeEmtryAttributes;
    function deepCopy(obj) {
        var dup;
        if (typeof (obj) == 'object') {
            if (obj == null) {
                dup = null;
            }
            else if (Array.isArray(obj)) {
                dup = new Array();
                obj.forEach(function (item) { return dup.push(deepCopy(item)); });
            }
            else {
                dup = new Object();
                Object.keys(obj).forEach(function (key) { return dup[key] = deepCopy(obj[key]); });
            }
            return dup;
        }
        else {
            return obj;
        }
    }
    exports.deepCopy = deepCopy;
    function isEmptyObject(obj) {
        return Object.keys(obj).length === 0;
    }
    exports.isEmptyObject = isEmptyObject;
});
