var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
define(["require", "exports"], function (require, exports) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.setDescendentProp = exports.getDescendentProp = exports.strip = void 0;
    function strip(str, chars) {
        chars = chars.replace('[', '\\[').replace(']', '\\]');
        var regex = new RegExp("(^[" + chars + "]+|[" + chars + "]+$)", 'g');
        return str.replace(regex, '');
    }
    exports.strip = strip;
    function getDescendentProp(obj, path) {
        var e_1, _a;
        var nodes = strip(path, '.').split('.').filter(function (n) { return n != ''; });
        try {
            for (var nodes_1 = __values(nodes), nodes_1_1 = nodes_1.next(); !nodes_1_1.done; nodes_1_1 = nodes_1.next()) {
                var node = nodes_1_1.value;
                obj = obj[node];
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (nodes_1_1 && !nodes_1_1.done && (_a = nodes_1.return)) _a.call(nodes_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return obj;
    }
    exports.getDescendentProp = getDescendentProp;
    function setDescendentProp(obj, path, value) {
        var e_2, _a;
        var originObj = obj;
        var nodes = strip(path, '.').split('.').filter(function (n) { return n != ''; });
        if (nodes.length == 0) {
            return value;
        }
        try {
            for (var _b = __values(nodes.slice(0, -1)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var node = _c.value;
                obj = obj[node];
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_2) throw e_2.error; }
        }
        obj[nodes[nodes.length - 1]] = value;
        return originObj;
    }
    exports.setDescendentProp = setDescendentProp;
});
