var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
define(["require", "exports", "chord/base/common/json"], function (require, exports, json_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.makeRadio = exports.makePodcast = exports.makeEpisode = exports.makeUserProfile = exports.makeCollection = exports.makeArtist = exports.makeAlbum = exports.makeSong = exports.makeAudio = exports.toBoolean = exports.toNumber = void 0;
    function toNumber(obj) {
        if (obj.type == 'song') {
            var disable = obj.disable;
            if (disable === null) {
                obj.disable = 0;
            }
            if (disable === undefined) {
                obj.disable = 0;
            }
            if (typeof disable === 'boolean') {
                obj.disable = obj.disable + 0;
            }
        }
        var like = obj.like;
        if (like === null) {
            obj.like = 0;
        }
        if (like === undefined) {
            obj.like = 0;
        }
        if (typeof obj.like === 'boolean') {
            obj.like = obj.like + 0;
        }
    }
    exports.toNumber = toNumber;
    function toBoolean(obj) {
        if (obj.type == 'song') {
            var disable = obj.disable;
            if (disable === null) {
                obj.disable = false;
            }
            if (disable === undefined) {
                obj.disable = false;
            }
            if (typeof disable === 'number') {
                obj.disable = !!disable;
            }
        }
        var like = obj.like;
        if (like === null) {
            obj.like = false;
        }
        if (like === undefined) {
            obj.like = false;
        }
        if (typeof obj.like === 'number') {
            obj.like = !!like;
        }
    }
    exports.toBoolean = toBoolean;
    function makeAudio(info) {
        var audio = __assign({}, info);
        delete audio.songId;
        // audio url must be token freshly
        audio.url = null;
        return audio;
    }
    exports.makeAudio = makeAudio;
    function makeSong(info) {
        var song = __assign({}, info);
        json_1.jsonLoadValue(song);
        toBoolean(song);
        return song;
    }
    exports.makeSong = makeSong;
    function makeAlbum(info) {
        var album = __assign({}, info);
        // Get songs use LibraryDatabase.libraryAlbumSongs
        album.songs = [];
        json_1.jsonLoadValue(album);
        toBoolean(album);
        return album;
    }
    exports.makeAlbum = makeAlbum;
    function makeArtist(info) {
        var artist = __assign({}, info);
        json_1.jsonLoadValue(artist);
        artist.songs = [];
        artist.albums = [];
        toBoolean(artist);
        return artist;
    }
    exports.makeArtist = makeArtist;
    function makeCollection(info) {
        var collection = __assign({}, info);
        json_1.jsonLoadValue(collection);
        collection.songs = [];
        toBoolean(collection);
        return collection;
    }
    exports.makeCollection = makeCollection;
    function makeUserProfile(info) {
        var userProfile = __assign({}, info);
        json_1.jsonLoadValue(userProfile);
        userProfile.songs = [];
        userProfile.albums = [];
        userProfile.favoriteCollections = [];
        userProfile.createdCollections = [];
        userProfile.followers = [];
        userProfile.followings = [];
        toBoolean(userProfile);
        return userProfile;
    }
    exports.makeUserProfile = makeUserProfile;
    function makeEpisode(info) {
        var episode = __assign({}, info);
        json_1.jsonLoadValue(episode);
        toBoolean(episode);
        return episode;
    }
    exports.makeEpisode = makeEpisode;
    function makePodcast(info) {
        var podcast = __assign({}, info);
        // Get songs use LibraryDatabase.podcastEpisodes
        podcast.episodes = [];
        json_1.jsonLoadValue(podcast);
        toBoolean(podcast);
        return podcast;
    }
    exports.makePodcast = makePodcast;
    function makeRadio(info) {
        var radio = __assign({}, info);
        json_1.jsonLoadValue(radio);
        radio.episodes = [];
        radio.podcasts = [];
        radio.favoritePodcasts = [];
        radio.followers = [];
        radio.followings = [];
        toBoolean(radio);
        return radio;
    }
    exports.makeRadio = makeRadio;
});
