define(["require", "exports", "chord/library/data/tables/schemes/util"], function (require, exports, util_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.fixTable = exports.makeTable = void 0;
    var TABLE_NAME = 'audio';
    var TABLE_COLUMNS = [
        ['songId', 'text'],
        ['format', 'text'],
        ['size', 'integer'],
        ['kbps', 'integer'],
        ['url', 'text'],
        ['path', 'text'],
    ];
    var ADDONS = 'primary key (songId, format, size)';
    function makeTable(db) {
        var tableSql = util_1.makeTableSql(TABLE_NAME, TABLE_COLUMNS, ADDONS);
        db.exec(tableSql);
    }
    exports.makeTable = makeTable;
    function fixTable(db) {
        util_1.addMissColumns(TABLE_NAME, TABLE_COLUMNS, db);
    }
    exports.fixTable = fixTable;
});
