define(["require", "exports", "chord/library/data/tables/schemes/util"], function (require, exports, util_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.fixTable = exports.makeTable = void 0;
    var TABLE_NAME = 'episode';
    var TABLE_COLUMNS = [
        ['id', 'integer primary key asc'],
        ['episodeId', 'text unique on conflict ignore'],
        ['type', 'text'],
        ['origin', 'text'],
        ['episodeOriginalId', 'text'],
        ['episodeMid', 'text'],
        ['episodeMediaMid', 'text'],
        ['url', 'text'],
        ['episodeName', 'text'],
        ['subTitle', 'text'],
        // json array
        ['people', 'text'],
        ['podcastId', 'text'],
        ['podcastOriginalId', 'text'],
        ['podcastMid', 'text'],
        ['podcastName', 'text'],
        ['podcastCoverUrl', 'text'],
        ['podcastCoverPath', 'text'],
        ['radioId', 'text'],
        ['radioOriginalId', 'text'],
        ['radioMid', 'text'],
        ['radioName', 'text'],
        ['radioCoverUrl', 'text'],
        ['radioCoverPath', 'text'],
        ['composer', 'text'],
        ['lyricUrl', 'text'],
        ['lyricPath', 'text'],
        ['track', 'integer'],
        // json array
        ['genres', 'text'],
        // json array
        ['styles', 'text'],
        // json array
        ['tags', 'text'],
        ['description', 'text'],
        ['duration', 'integer'],
        ['releaseDate', 'integer'],
        // audios store at audio', 'table
        // ['audios', 'text'],
        ['disable', 'integer'],
        ['playCountWeb', 'integer'],
        ['playCount', 'integer'],
        ['likeCount', 'integer'],
        ['like', 'integer'],
    ];
    var ADDONS = null;
    function makeTable(db) {
        var tableSql = util_1.makeTableSql(TABLE_NAME, TABLE_COLUMNS, ADDONS);
        db.exec(tableSql);
    }
    exports.makeTable = makeTable;
    function fixTable(db) {
        util_1.addMissColumns(TABLE_NAME, TABLE_COLUMNS, db);
    }
    exports.fixTable = fixTable;
});
