define(["require", "exports", "chord/library/data/tables/schemes/util"], function (require, exports, util_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.fixTable = exports.makeTable = void 0;
    var TABLE_NAME = 'library_user_profile';
    var TABLE_COLUMNS = [
        ['id', 'integer primary key asc'],
        ['userId', 'text unique on conflict ignore'],
        ['type', 'text'],
        ['origin', 'text'],
        ['userOriginalId', 'text'],
        // for qq music
        ['userMid', 'text'],
        ['url', 'text'],
        ['userName', 'text'],
        ['userAvatarUrl', 'text'],
        ['userAvatarPath', 'text'],
        ['followerCount', 'integer'],
        ['followingCount', 'integer'],
        // json array: ["userId"] or []
        ['followers', 'text'],
        // json array: ["userId"] or []
        ['followings', 'text'],
        ['listenCount', 'integer'],
        ['songCount', 'integer'],
        ['artistCount', 'integer'],
        ['albumCount', 'integer'],
        ['createdCollectionCount', 'integer'],
        ['favoriteCollectionCount', 'integer'],
        // json array: ["songId"] or []
        ['songs', 'text'],
        // json array: ["artistId"] or []
        ['artists', 'text'],
        // json array: ["albumId"] or []
        ['albums', 'text'],
        // json array: ["collectionId"] or []
        ['createdCollections', 'text'],
        // json array: ["collectionId"] or []
        ['favoriteCollections', 'text'],
        ['description', 'text'],
        ['like', 'integer'],
        ['addAt', 'integer'],
    ];
    var ADDONS = null;
    function makeTable(db) {
        var tableSql = util_1.makeTableSql(TABLE_NAME, TABLE_COLUMNS, ADDONS);
        db.exec(tableSql);
    }
    exports.makeTable = makeTable;
    function fixTable(db) {
        util_1.addMissColumns(TABLE_NAME, TABLE_COLUMNS, db);
    }
    exports.fixTable = fixTable;
});
