define(["require", "exports", "chord/library/data/tables/schemes/util"], function (require, exports, util_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.fixTable = exports.makeTable = void 0;
    var TABLE_NAME = 'song';
    var TABLE_COLUMNS = [
        ['id', 'integer primary key asc'],
        ['songId', 'text unique on conflict ignore'],
        ['type', 'text'],
        ['origin', 'text'],
        ['songOriginalId', 'text'],
        ['songMid', 'text'],
        ['songMediaMid', 'text'],
        ['url', 'text'],
        ['songName', 'text'],
        ['subTitle', 'text'],
        // json array
        ['songWriters', 'text'],
        // json array
        ['singers', 'text'],
        ['albumId', 'text'],
        ['albumOriginalId', 'text'],
        ['albumMid', 'text'],
        ['albumName', 'text'],
        ['albumCoverUrl', 'text'],
        ['albumCoverPath', 'text'],
        ['artistId', 'text'],
        ['artistOriginalId', 'text'],
        ['artistMid', 'text'],
        ['artistName', 'text'],
        ['artistAvatarUrl', 'text'],
        ['artistAvatarPath', 'text'],
        ['composer', 'text'],
        ['lyricUrl', 'text'],
        ['lyricPath', 'text'],
        ['track', 'integer'],
        ['cdSerial', 'integer'],
        // json array
        ['genres', 'text'],
        // json array
        ['styles', 'text'],
        // json array
        ['tags', 'text'],
        ['description', 'text'],
        ['duration', 'integer'],
        ['releaseDate', 'integer'],
        // audios store at audio', 'table
        // ['audios', 'text'],
        ['disable', 'integer'],
        ['playCountWeb', 'integer'],
        ['playCount', 'integer'],
        ['likeCount', 'integer'],
        ['like', 'integer'],
    ];
    var ADDONS = null;
    function makeTable(db) {
        var tableSql = util_1.makeTableSql(TABLE_NAME, TABLE_COLUMNS, ADDONS);
        db.exec(tableSql);
    }
    exports.makeTable = makeTable;
    function fixTable(db) {
        util_1.addMissColumns(TABLE_NAME, TABLE_COLUMNS, db);
    }
    exports.fixTable = fixTable;
});
