var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
define(["require", "exports", "chord/base/common/assert"], function (require, exports, assert_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.addMissColumns = exports.makeTableSql = void 0;
    var TABLE_SCHEME_SQL = function (tableName, columns, addons) { return "\ncreate table if not exists " + tableName + " (\n    " + columns + (!!addons ? ',' : '') + "\n    " + (!!addons ? addons : '') + "\n)\n"; };
    function makeTableSql(name, columns, addons) {
        var e_1, _a;
        assert_1.ok(columns.length);
        var cols = '';
        try {
            for (var columns_1 = __values(columns), columns_1_1 = columns_1.next(); !columns_1_1.done; columns_1_1 = columns_1.next()) {
                var _b = __read(columns_1_1.value, 2), col = _b[0], desc = _b[1];
                cols += col + " " + desc + ",\n";
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (columns_1_1 && !columns_1_1.done && (_a = columns_1.return)) _a.call(columns_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        cols = cols.slice(0, -2);
        return TABLE_SCHEME_SQL(name, cols, addons);
    }
    exports.makeTableSql = makeTableSql;
    function addMissColumns(tableName, columns, db) {
        var tableScheme = db.prepare("PRAGMA table_info(" + tableName + ")").all();
        var cols = new Set(tableScheme.map(function (info) { return info.name; }));
        columns
            .filter(function (_a) {
            var _b = __read(_a, 2), col = _b[0], desc = _b[1];
            return !cols.has(col);
        })
            .forEach(function (_a) {
            var _b = __read(_a, 2), col = _b[0], desc = _b[1];
            var sql = "ALTER TABLE " + tableName + " ADD COLUMN " + col + " " + desc;
            db.exec(sql);
        });
    }
    exports.addMissColumns = addMissColumns;
});
