var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
define(["require", "exports", "chord/music/common/origin", "chord/base/node/crypto", "chord/preference/configuration/app", "chord/music/xiami/api", "chord/music/netease/api", "chord/music/qq/api", "chord/music/qianqian/api", "chord/music/migu/api", "chord/music/kuwo/api", "chord/base/common/lru", "chord/preference/configuration/user", "chord/music/core/parser", "chord/base/common/algorithms"], function (require, exports, origin_1, crypto_1, app_1, api_1, api_2, api_3, api_4, api_5, api_6, lru_1, user_1, parser_1, algorithms_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.musicApi = exports.Music = void 0;
    var Music = /** @class */ (function () {
        function Music() {
            // initiate xiami api
            var xiamiApi = new api_1.AliMusicApi();
            xiamiApi.setUserId('1');
            this.xiamiApi = xiamiApi;
            // initiate netease api
            this.neteaseApi = new api_2.NeteaseMusicApi();
            // initiate qq api
            this.qqApi = new api_3.QQMusicApi();
            // initiate qianqian api
            this.qianqianApi = new api_4.QianQianApi();
            // initiate migu api
            this.miguApi = new api_5.MiguMusicApi();
            // initiate kuwo api
            this.kuwoApi = new api_6.KuwoMusicApi();
            // set user configuration
            var userConfig = user_1.userConfiguration.getConfig();
            this.setAccount(userConfig.xiami && userConfig.xiami.account);
            this.setAccount(userConfig.netease && userConfig.netease.account);
            this.setAccount(userConfig.qq && userConfig.qq.account);
        }
        Music.prototype.isOriginOn = function (origin) {
            var config = app_1.appConfiguration.getConfig();
            return config.origins[origin];
        };
        /**
         * Clean one music api
         */
        Music.prototype.clean = function (origin) {
            switch (origin) {
                case origin_1.ORIGIN.xiami:
                    this.xiamiApi = new api_1.AliMusicApi();
                    this.xiamiApi.setUserId('1');
                    break;
                case origin_1.ORIGIN.netease:
                    this.neteaseApi = new api_2.NeteaseMusicApi();
                    break;
                case origin_1.ORIGIN.qq:
                    this.qqApi = new api_3.QQMusicApi();
                    break;
                case origin_1.ORIGIN.qianqian:
                    this.qianqianApi = new api_4.QianQianApi();
                    break;
                case origin_1.ORIGIN.migu:
                    this.miguApi = new api_5.MiguMusicApi();
                    break;
                case origin_1.ORIGIN.kuwo:
                    this.kuwoApi = new api_6.KuwoMusicApi();
                    break;
                default:
                    // Here will never be occured.
                    throw new Error("[ERROR] [Music.clean] Here will never be occured. [args]: " + origin);
            }
        };
        /**
         * audioId is Chord's audio id, not audio original id
         */
        Music.prototype.audios = function (songId, supKbps) {
            return __awaiter(this, void 0, void 0, function () {
                var h, result, originType, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            h = crypto_1.md5("music.core.api.audios(" + songId + ")");
                            result = lru_1.cache30.get(h);
                            if (result)
                                return [2 /*return*/, result];
                            originType = origin_1.getOrigin(songId);
                            _a = originType.origin;
                            switch (_a) {
                                case origin_1.ORIGIN.xiami: return [3 /*break*/, 1];
                                case origin_1.ORIGIN.netease: return [3 /*break*/, 3];
                                case origin_1.ORIGIN.qq: return [3 /*break*/, 5];
                                case origin_1.ORIGIN.qianqian: return [3 /*break*/, 7];
                                case origin_1.ORIGIN.migu: return [3 /*break*/, 9];
                                case origin_1.ORIGIN.kuwo: return [3 /*break*/, 11];
                            }
                            return [3 /*break*/, 13];
                        case 1: return [4 /*yield*/, this.xiamiApi.audios(originType.id, supKbps)];
                        case 2:
                            result = _b.sent();
                            return [3 /*break*/, 14];
                        case 3: return [4 /*yield*/, this.neteaseApi.audios(originType.id, supKbps)];
                        case 4:
                            result = _b.sent();
                            return [3 /*break*/, 14];
                        case 5: return [4 /*yield*/, this.qqApi.audios(originType.id, supKbps)];
                        case 6:
                            result = _b.sent();
                            return [3 /*break*/, 14];
                        case 7: return [4 /*yield*/, this.qianqianApi.audios(originType.id, supKbps)];
                        case 8:
                            result = _b.sent();
                            return [3 /*break*/, 14];
                        case 9: return [4 /*yield*/, this.miguApi.audios(originType.id, supKbps)];
                        case 10:
                            result = _b.sent();
                            return [3 /*break*/, 14];
                        case 11: return [4 /*yield*/, this.kuwoApi.audios(originType.id, supKbps)];
                        case 12:
                            result = _b.sent();
                            return [3 /*break*/, 14];
                        case 13: 
                        // Here will never be occured.
                        throw new Error("[ERROR] [Music.audio] Here will never be occured. [args]: " + songId);
                        case 14:
                            lru_1.cache30.set(h, result);
                            return [2 /*return*/, result];
                    }
                });
            });
        };
        /**
         * songId is Chord's song id, not song original id
         */
        Music.prototype.song = function (songId) {
            return __awaiter(this, void 0, void 0, function () {
                var h, result, song, originType, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            h = crypto_1.md5("music.core.api.song(" + songId + ")");
                            result = lru_1.cache12.get(h);
                            result = parser_1.makeItem(result);
                            if (result)
                                return [2 /*return*/, result];
                            originType = origin_1.getOrigin(songId);
                            _a = originType.origin;
                            switch (_a) {
                                case origin_1.ORIGIN.xiami: return [3 /*break*/, 1];
                                case origin_1.ORIGIN.netease: return [3 /*break*/, 3];
                                case origin_1.ORIGIN.qq: return [3 /*break*/, 5];
                                case origin_1.ORIGIN.qianqian: return [3 /*break*/, 7];
                                case origin_1.ORIGIN.migu: return [3 /*break*/, 9];
                                case origin_1.ORIGIN.kuwo: return [3 /*break*/, 11];
                            }
                            return [3 /*break*/, 13];
                        case 1: return [4 /*yield*/, this.xiamiApi.song(originType.id)];
                        case 2:
                            song = _b.sent();
                            return [3 /*break*/, 14];
                        case 3: return [4 /*yield*/, this.neteaseApi.song(originType.id)];
                        case 4:
                            song = _b.sent();
                            return [3 /*break*/, 14];
                        case 5: return [4 /*yield*/, this.qqApi.song(originType.id)];
                        case 6:
                            song = _b.sent();
                            return [3 /*break*/, 14];
                        case 7: return [4 /*yield*/, this.qianqianApi.song(originType.id)];
                        case 8:
                            song = _b.sent();
                            return [3 /*break*/, 14];
                        case 9: return [4 /*yield*/, this.miguApi.song(originType.id)];
                        case 10:
                            song = _b.sent();
                            return [3 /*break*/, 14];
                        case 11: return [4 /*yield*/, this.kuwoApi.song(originType.id)];
                        case 12:
                            song = _b.sent();
                            return [3 /*break*/, 14];
                        case 13: 
                        // Here will never be occured.
                        throw new Error("[ERROR] [Music.song] Here will never be occured. [args]: " + songId);
                        case 14:
                            result = parser_1.makeItem(song);
                            lru_1.cache12.set(h, result);
                            return [2 /*return*/, result];
                    }
                });
            });
        };
        Music.prototype.lyric = function (songId, song) {
            return __awaiter(this, void 0, void 0, function () {
                var h, result, lyric, originType, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            h = crypto_1.md5("music.core.api.lyric(" + songId + ")");
                            result = lru_1.cache12.get(h);
                            if (result)
                                return [2 /*return*/, result];
                            originType = origin_1.getOrigin(songId);
                            _a = originType.origin;
                            switch (_a) {
                                case origin_1.ORIGIN.xiami: return [3 /*break*/, 1];
                                case origin_1.ORIGIN.netease: return [3 /*break*/, 3];
                                case origin_1.ORIGIN.qq: return [3 /*break*/, 5];
                                case origin_1.ORIGIN.qianqian: return [3 /*break*/, 7];
                                case origin_1.ORIGIN.migu: return [3 /*break*/, 9];
                                case origin_1.ORIGIN.kuwo: return [3 /*break*/, 11];
                            }
                            return [3 /*break*/, 13];
                        case 1: return [4 /*yield*/, this.xiamiApi.lyric(originType.id, song)];
                        case 2:
                            lyric = _b.sent();
                            return [3 /*break*/, 14];
                        case 3: return [4 /*yield*/, this.neteaseApi.lyric(originType.id)];
                        case 4:
                            lyric = _b.sent();
                            return [3 /*break*/, 14];
                        case 5: return [4 /*yield*/, this.qqApi.lyric(originType.id, song.songMid)];
                        case 6:
                            lyric = _b.sent();
                            return [3 /*break*/, 14];
                        case 7: return [4 /*yield*/, this.qianqianApi.lyric(originType.id, song)];
                        case 8:
                            lyric = _b.sent();
                            return [3 /*break*/, 14];
                        case 9: return [4 /*yield*/, this.miguApi.lyric(originType.id)];
                        case 10:
                            lyric = _b.sent();
                            return [3 /*break*/, 14];
                        case 11: return [4 /*yield*/, this.kuwoApi.lyric(originType.id)];
                        case 12:
                            lyric = _b.sent();
                            return [3 /*break*/, 14];
                        case 13: 
                        // Here will never be occured.
                        throw new Error("[ERROR] [Music.lyric] Here will never be occured. [args]: " + songId);
                        case 14:
                            result = lyric;
                            lru_1.cache12.set(h, result);
                            return [2 /*return*/, result];
                    }
                });
            });
        };
        /**
         * artistId is Chord's artist id, not artist original id
         */
        Music.prototype.artist = function (artistId) {
            return __awaiter(this, void 0, void 0, function () {
                var h, result, artist, originType, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            h = crypto_1.md5("music.core.api.artist(" + artistId + ")");
                            result = lru_1.cache12.get(h);
                            result = parser_1.makeItem(result);
                            if (result)
                                return [2 /*return*/, result];
                            originType = origin_1.getOrigin(artistId);
                            _a = originType.origin;
                            switch (_a) {
                                case origin_1.ORIGIN.xiami: return [3 /*break*/, 1];
                                case origin_1.ORIGIN.netease: return [3 /*break*/, 3];
                                case origin_1.ORIGIN.qq: return [3 /*break*/, 5];
                                case origin_1.ORIGIN.qianqian: return [3 /*break*/, 7];
                                case origin_1.ORIGIN.migu: return [3 /*break*/, 9];
                                case origin_1.ORIGIN.kuwo: return [3 /*break*/, 11];
                            }
                            return [3 /*break*/, 13];
                        case 1: return [4 /*yield*/, this.xiamiApi.artist(originType.id)];
                        case 2:
                            artist = _b.sent();
                            return [3 /*break*/, 14];
                        case 3: return [4 /*yield*/, this.neteaseApi.artist(originType.id)];
                        case 4:
                            artist = _b.sent();
                            return [3 /*break*/, 14];
                        case 5: return [4 /*yield*/, this.qqApi.artist(originType.id)];
                        case 6:
                            artist = _b.sent();
                            return [3 /*break*/, 14];
                        case 7: return [4 /*yield*/, this.qianqianApi.artist(originType.id)];
                        case 8:
                            artist = _b.sent();
                            return [3 /*break*/, 14];
                        case 9: return [4 /*yield*/, this.miguApi.artist(originType.id)];
                        case 10:
                            artist = _b.sent();
                            return [3 /*break*/, 14];
                        case 11: return [4 /*yield*/, this.kuwoApi.artist(originType.id)];
                        case 12:
                            artist = _b.sent();
                            return [3 /*break*/, 14];
                        case 13: 
                        // Here will never be occured.
                        throw new Error("[ERROR] [Music.artist] Here will never be occured. [args]: " + artistId);
                        case 14:
                            result = parser_1.makeItem(artist);
                            lru_1.cache12.set(h, result);
                            return [2 /*return*/, result];
                    }
                });
            });
        };
        /**
         * artistId is Chord's artist id, not artist original id
         */
        Music.prototype.artistSongs = function (artistId, offset, limit) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var h, result, songs, originType, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            h = crypto_1.md5("music.core.api.artistSongs(" + artistId + ", " + offset + ", " + limit + ")");
                            result = lru_1.cache12.get(h);
                            result = parser_1.makeItems(result);
                            if (result)
                                return [2 /*return*/, result];
                            songs = [];
                            originType = origin_1.getOrigin(artistId);
                            _a = originType.origin;
                            switch (_a) {
                                case origin_1.ORIGIN.xiami: return [3 /*break*/, 1];
                                case origin_1.ORIGIN.netease: return [3 /*break*/, 3];
                                case origin_1.ORIGIN.qq: return [3 /*break*/, 5];
                                case origin_1.ORIGIN.qianqian: return [3 /*break*/, 7];
                                case origin_1.ORIGIN.migu: return [3 /*break*/, 9];
                                case origin_1.ORIGIN.kuwo: return [3 /*break*/, 11];
                            }
                            return [3 /*break*/, 13];
                        case 1: return [4 /*yield*/, this.xiamiApi.artistSongs(originType.id, offset, limit)];
                        case 2:
                            songs = _b.sent();
                            return [3 /*break*/, 14];
                        case 3: return [4 /*yield*/, this.neteaseApi.artistSongs(originType.id, offset, limit)];
                        case 4:
                            songs = _b.sent();
                            return [3 /*break*/, 14];
                        case 5: return [4 /*yield*/, this.qqApi.artistSongs(originType.id, offset, limit)];
                        case 6:
                            songs = _b.sent();
                            return [3 /*break*/, 14];
                        case 7: return [4 /*yield*/, this.qianqianApi.artistSongs(originType.id, offset, limit)];
                        case 8:
                            songs = _b.sent();
                            return [3 /*break*/, 14];
                        case 9: return [4 /*yield*/, this.miguApi.artistSongs(originType.id, offset, limit)];
                        case 10:
                            songs = _b.sent();
                            return [3 /*break*/, 14];
                        case 11: return [4 /*yield*/, this.kuwoApi.artistSongs(originType.id, offset, limit)];
                        case 12:
                            songs = _b.sent();
                            return [3 /*break*/, 14];
                        case 13: 
                        // Here will never be occured.
                        throw new Error("[ERROR] [Music.artistSongs] Here will never be occured. [args]: " + artistId);
                        case 14:
                            result = parser_1.makeItems(songs);
                            lru_1.cache12.set(h, result);
                            return [2 /*return*/, result];
                    }
                });
            });
        };
        /**
         * artistId is Chord's artist id, not artist original id
         */
        Music.prototype.artistAlbums = function (artistId, offset, limit, artistMid) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var h, result, albums, originType, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            h = crypto_1.md5("music.core.api.artistAlbums(" + artistId + ", " + offset + ", " + limit + ", " + artistMid + ")");
                            result = lru_1.cache12.get(h);
                            result = parser_1.makeItems(result);
                            if (result)
                                return [2 /*return*/, result];
                            albums = [];
                            originType = origin_1.getOrigin(artistId);
                            _a = originType.origin;
                            switch (_a) {
                                case origin_1.ORIGIN.xiami: return [3 /*break*/, 1];
                                case origin_1.ORIGIN.netease: return [3 /*break*/, 3];
                                case origin_1.ORIGIN.qq: return [3 /*break*/, 5];
                                case origin_1.ORIGIN.qianqian: return [3 /*break*/, 7];
                                case origin_1.ORIGIN.migu: return [3 /*break*/, 9];
                                case origin_1.ORIGIN.kuwo: return [3 /*break*/, 11];
                            }
                            return [3 /*break*/, 13];
                        case 1: return [4 /*yield*/, this.xiamiApi.artistAlbums(originType.id, offset, limit)];
                        case 2:
                            albums = _b.sent();
                            return [3 /*break*/, 14];
                        case 3: return [4 /*yield*/, this.neteaseApi.artistAlbums(originType.id, offset, limit)];
                        case 4:
                            albums = _b.sent();
                            return [3 /*break*/, 14];
                        case 5: return [4 /*yield*/, this.qqApi.artistAlbums(artistMid, offset, limit)];
                        case 6:
                            albums = _b.sent();
                            return [3 /*break*/, 14];
                        case 7: return [4 /*yield*/, this.qianqianApi.artistAlbums(originType.id, offset, limit)];
                        case 8:
                            albums = _b.sent();
                            return [3 /*break*/, 14];
                        case 9: return [4 /*yield*/, this.miguApi.artistAlbums(originType.id, offset, limit)];
                        case 10:
                            albums = _b.sent();
                            return [3 /*break*/, 14];
                        case 11: return [4 /*yield*/, this.kuwoApi.artistAlbums(originType.id, offset, limit)];
                        case 12:
                            albums = _b.sent();
                            return [3 /*break*/, 14];
                        case 13: 
                        // Here will never be occured.
                        throw new Error("[ERROR] [Music.artistAlbums] Here will never be occured. [args]: " + artistId);
                        case 14:
                            result = parser_1.makeItems(albums);
                            lru_1.cache12.set(h, result);
                            return [2 /*return*/, result];
                    }
                });
            });
        };
        /**
         * albumId is Chord's album id, not album original id
         */
        Music.prototype.album = function (albumId) {
            return __awaiter(this, void 0, void 0, function () {
                var h, result, album, originType, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            h = crypto_1.md5("music.core.api.album(" + albumId + ")");
                            result = lru_1.cache12.get(h);
                            result = parser_1.makeItem(result);
                            if (result)
                                return [2 /*return*/, result];
                            originType = origin_1.getOrigin(albumId);
                            _a = originType.origin;
                            switch (_a) {
                                case origin_1.ORIGIN.xiami: return [3 /*break*/, 1];
                                case origin_1.ORIGIN.netease: return [3 /*break*/, 3];
                                case origin_1.ORIGIN.qq: return [3 /*break*/, 5];
                                case origin_1.ORIGIN.qianqian: return [3 /*break*/, 7];
                                case origin_1.ORIGIN.migu: return [3 /*break*/, 9];
                                case origin_1.ORIGIN.kuwo: return [3 /*break*/, 11];
                            }
                            return [3 /*break*/, 13];
                        case 1: return [4 /*yield*/, this.xiamiApi.album(originType.id)];
                        case 2:
                            album = _b.sent();
                            return [3 /*break*/, 14];
                        case 3: return [4 /*yield*/, this.neteaseApi.album(originType.id)];
                        case 4:
                            album = _b.sent();
                            return [3 /*break*/, 14];
                        case 5: return [4 /*yield*/, this.qqApi.album(originType.id)];
                        case 6:
                            album = _b.sent();
                            return [3 /*break*/, 14];
                        case 7: return [4 /*yield*/, this.qianqianApi.album(originType.id)];
                        case 8:
                            album = _b.sent();
                            return [3 /*break*/, 14];
                        case 9: return [4 /*yield*/, this.miguApi.album(originType.id)];
                        case 10:
                            album = _b.sent();
                            return [3 /*break*/, 14];
                        case 11: return [4 /*yield*/, this.kuwoApi.album(originType.id)];
                        case 12:
                            album = _b.sent();
                            return [3 /*break*/, 14];
                        case 13: 
                        // Here will never be occured.
                        throw new Error("[ERROR] [Music.album] Here will never be occured. [args]: " + albumId);
                        case 14:
                            result = parser_1.makeItem(album);
                            lru_1.cache12.set(h, result);
                            return [2 /*return*/, result];
                    }
                });
            });
        };
        /**
         * collectionId is Chord's collection id, not collection original id
         */
        Music.prototype.collection = function (collectionId, offset, limit) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 1000; }
            return __awaiter(this, void 0, void 0, function () {
                var h, result, collection, originType, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            h = crypto_1.md5("music.core.api.collection(" + collectionId + ", " + offset + ", " + limit + ")");
                            result = lru_1.cache12.get(h);
                            result = parser_1.makeItem(result);
                            if (result)
                                return [2 /*return*/, result];
                            originType = origin_1.getOrigin(collectionId);
                            _a = originType.origin;
                            switch (_a) {
                                case origin_1.ORIGIN.xiami: return [3 /*break*/, 1];
                                case origin_1.ORIGIN.netease: return [3 /*break*/, 3];
                                case origin_1.ORIGIN.qq: return [3 /*break*/, 5];
                                case origin_1.ORIGIN.qianqian: return [3 /*break*/, 7];
                                case origin_1.ORIGIN.migu: return [3 /*break*/, 9];
                                case origin_1.ORIGIN.kuwo: return [3 /*break*/, 11];
                            }
                            return [3 /*break*/, 13];
                        case 1: return [4 /*yield*/, this.xiamiApi.collection(originType.id, offset, limit)];
                        case 2:
                            collection = _b.sent();
                            return [3 /*break*/, 14];
                        case 3: return [4 /*yield*/, this.neteaseApi.collection(originType.id)];
                        case 4:
                            collection = _b.sent();
                            return [3 /*break*/, 14];
                        case 5: return [4 /*yield*/, this.qqApi.collection(originType.id, offset, limit)];
                        case 6:
                            collection = _b.sent();
                            return [3 /*break*/, 14];
                        case 7: return [4 /*yield*/, this.qianqianApi.collection(originType.id, offset, limit)];
                        case 8:
                            collection = _b.sent();
                            return [3 /*break*/, 14];
                        case 9: return [4 /*yield*/, this.miguApi.collection(originType.id, offset, limit)];
                        case 10:
                            collection = _b.sent();
                            return [3 /*break*/, 14];
                        case 11: return [4 /*yield*/, this.kuwoApi.collection(originType.id, offset, limit)];
                        case 12:
                            collection = _b.sent();
                            return [3 /*break*/, 14];
                        case 13: 
                        // Here will never be occured.
                        throw new Error("[ERROR] [Music.collection] Here will never be occured. [args]: " + collectionId);
                        case 14:
                            result = parser_1.makeItem(collection);
                            lru_1.cache12.set(h, result);
                            return [2 /*return*/, result];
                    }
                });
            });
        };
        /**
         * xiami searching based on page
         */
        Music.prototype.searchSongs = function (keyword, offset, limit) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var h, result, list, items;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            h = crypto_1.md5("music.core.api.searchSongs(" + keyword + ", " + offset + ", " + limit + ")");
                            result = lru_1.cache12.get(h);
                            result = parser_1.makeItems(result);
                            if (result)
                                return [2 /*return*/, result];
                            return [4 /*yield*/, Promise.all([
                                    !this.isOriginOn(origin_1.ORIGIN.xiami) ? [] : this.xiamiApi.searchSongs(keyword, offset + 1, limit),
                                    !this.isOriginOn(origin_1.ORIGIN.netease) ? [] : this.neteaseApi.searchSongs(keyword, offset * limit, limit),
                                    !this.isOriginOn(origin_1.ORIGIN.qq) ? [] : this.qqApi.searchSongs(keyword, offset * limit, limit),
                                    !this.isOriginOn(origin_1.ORIGIN.qianqian) ? [] : this.qianqianApi.searchSongs(keyword, offset * limit, limit),
                                    !this.isOriginOn(origin_1.ORIGIN.migu) ? [] : this.miguApi.searchSongs(keyword, offset * limit, limit),
                                    !this.isOriginOn(origin_1.ORIGIN.kuwo) ? [] : this.kuwoApi.searchSongs(keyword, offset + 1, limit),
                                ])];
                        case 1:
                            list = _a.sent();
                            items = algorithms_1.insertMerge(list);
                            result = parser_1.makeItems(items);
                            lru_1.cache12.set(h, result);
                            return [2 /*return*/, result];
                    }
                });
            });
        };
        Music.prototype.searchArtists = function (keyword, offset, limit) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var h, result, list, items;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            h = crypto_1.md5("music.core.api.searchArtists(" + keyword + ", " + offset + ", " + limit + ")");
                            result = lru_1.cache12.get(h);
                            result = parser_1.makeItems(result);
                            if (result)
                                return [2 /*return*/, result];
                            return [4 /*yield*/, Promise.all([
                                    !this.isOriginOn(origin_1.ORIGIN.xiami) ? [] : this.xiamiApi.searchArtists(keyword, offset + 1, limit),
                                    !this.isOriginOn(origin_1.ORIGIN.netease) ? [] : this.neteaseApi.searchArtists(keyword, offset * limit, limit),
                                    !this.isOriginOn(origin_1.ORIGIN.qianqian) ? [] : this.qianqianApi.searchArtists(keyword, offset * limit, limit),
                                    !this.isOriginOn(origin_1.ORIGIN.migu) ? [] : this.miguApi.searchArtists(keyword, offset * limit, limit),
                                    !this.isOriginOn(origin_1.ORIGIN.kuwo) ? [] : this.kuwoApi.searchArtists(keyword, offset + 1, limit),
                                ])];
                        case 1:
                            list = _a.sent();
                            items = algorithms_1.insertMerge(list);
                            result = parser_1.makeItems(items);
                            lru_1.cache12.set(h, result);
                            return [2 /*return*/, result];
                    }
                });
            });
        };
        Music.prototype.searchAlbums = function (keyword, offset, limit) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var h, result, list, items;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            h = crypto_1.md5("music.core.api.searchAlbums(" + keyword + ", " + offset + ", " + limit + ")");
                            result = lru_1.cache12.get(h);
                            result = parser_1.makeItems(result);
                            if (result)
                                return [2 /*return*/, result];
                            return [4 /*yield*/, Promise.all([
                                    !this.isOriginOn(origin_1.ORIGIN.xiami) ? [] : this.xiamiApi.searchAlbums(keyword, offset + 1, limit),
                                    !this.isOriginOn(origin_1.ORIGIN.netease) ? [] : this.neteaseApi.searchAlbums(keyword, offset * limit, limit),
                                    !this.isOriginOn(origin_1.ORIGIN.qq) ? [] : this.qqApi.searchAlbums(keyword, offset * limit, limit),
                                    !this.isOriginOn(origin_1.ORIGIN.qianqian) ? [] : this.qianqianApi.searchAlbums(keyword, offset * limit, limit),
                                    !this.isOriginOn(origin_1.ORIGIN.migu) ? [] : this.miguApi.searchAlbums(keyword, offset * limit, limit),
                                    !this.isOriginOn(origin_1.ORIGIN.kuwo) ? [] : this.kuwoApi.searchAlbums(keyword, offset + 1, limit),
                                ])];
                        case 1:
                            list = _a.sent();
                            items = algorithms_1.insertMerge(list);
                            result = parser_1.makeItems(items);
                            lru_1.cache12.set(h, result);
                            return [2 /*return*/, result];
                    }
                });
            });
        };
        Music.prototype.searchCollections = function (keyword, offset, limit) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var h, result, list, items;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            h = crypto_1.md5("music.core.api.searchCollections(" + keyword + ", " + offset + ", " + limit + ")");
                            result = lru_1.cache12.get(h);
                            result = parser_1.makeItems(result);
                            if (result)
                                return [2 /*return*/, result];
                            return [4 /*yield*/, Promise.all([
                                    !this.isOriginOn(origin_1.ORIGIN.xiami) ? [] : this.xiamiApi.searchCollections(keyword, offset + 1, limit),
                                    !this.isOriginOn(origin_1.ORIGIN.netease) ? [] : this.neteaseApi.searchCollections(keyword, offset * limit, limit),
                                    !this.isOriginOn(origin_1.ORIGIN.qq) ? [] : this.qqApi.searchCollections(keyword, offset * limit, limit),
                                    !this.isOriginOn(origin_1.ORIGIN.qianqian) ? [] : this.qianqianApi.searchCollections(keyword, offset * limit, limit),
                                    !this.isOriginOn(origin_1.ORIGIN.migu) ? [] : this.miguApi.searchCollections(keyword, offset * limit, limit),
                                    !this.isOriginOn(origin_1.ORIGIN.kuwo) ? [] : this.kuwoApi.searchCollections(keyword, offset + 1, limit),
                                ])];
                        case 1:
                            list = _a.sent();
                            items = algorithms_1.insertMerge(list);
                            result = parser_1.makeItems(items);
                            lru_1.cache12.set(h, result);
                            return [2 /*return*/, result];
                    }
                });
            });
        };
        Music.prototype.albumListOptions = function (origin) {
            return __awaiter(this, void 0, void 0, function () {
                var h, result, items, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            h = crypto_1.md5("music.core.api.albumListOptions(" + origin + ")");
                            result = lru_1.cache12.get(h);
                            if (result)
                                return [2 /*return*/, result];
                            _a = origin;
                            switch (_a) {
                                case origin_1.ORIGIN.xiami: return [3 /*break*/, 1];
                                case origin_1.ORIGIN.netease: return [3 /*break*/, 3];
                                case origin_1.ORIGIN.qq: return [3 /*break*/, 4];
                            }
                            return [3 /*break*/, 6];
                        case 1: return [4 /*yield*/, this.xiamiApi.albumListOptions()];
                        case 2:
                            items = _b.sent();
                            return [3 /*break*/, 7];
                        case 3:
                            items = [];
                            return [3 /*break*/, 7];
                        case 4: return [4 /*yield*/, this.qqApi.albumListOptions()];
                        case 5:
                            items = _b.sent();
                            return [3 /*break*/, 7];
                        case 6: 
                        // Here will never be occured.
                        throw new Error("[ERROR] [Music.albumListOptions] Here will never be occured. [args]: " + origin);
                        case 7:
                            result = items;
                            lru_1.cache12.set(h, result);
                            return [2 /*return*/, result];
                    }
                });
            });
        };
        Music.prototype.albumList = function (origin, order, area, genre, type, year, company, offset, limit) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var h, result, items, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            h = crypto_1.md5("music.core.api.albumList(" + origin + ", " + order + ", " + area + ", " + genre + ", " + type + ", " + year + ", " + company + ", " + offset + ", " + limit + ")");
                            result = lru_1.cache12.get(h);
                            result = parser_1.makeItems(result);
                            if (result)
                                return [2 /*return*/, result];
                            _a = origin;
                            switch (_a) {
                                case origin_1.ORIGIN.xiami: return [3 /*break*/, 1];
                                case origin_1.ORIGIN.netease: return [3 /*break*/, 3];
                                case origin_1.ORIGIN.qq: return [3 /*break*/, 4];
                            }
                            return [3 /*break*/, 6];
                        case 1: return [4 /*yield*/, this.xiamiApi.albumList(Number.parseInt(order), Number.parseInt(area), Number.parseInt(genre), Number.parseInt(year), Number.parseInt(type), offset, limit)];
                        case 2:
                            items = _b.sent();
                            return [3 /*break*/, 7];
                        case 3:
                            items = [];
                            return [3 /*break*/, 7];
                        case 4: return [4 /*yield*/, this.qqApi.albumList(Number.parseInt(order), Number.parseInt(area), Number.parseInt(genre), Number.parseInt(type), Number.parseInt(year), Number.parseInt(company), offset, limit)];
                        case 5:
                            items = _b.sent();
                            return [3 /*break*/, 7];
                        case 6: 
                        // Here will never be occured.
                        throw new Error("[ERROR] [Music.albumList] Here will never be occured. [args]: " + origin + ", " + order + ", " + area + ", " + genre + ", " + type + ", " + year + ", " + company + ", " + offset + ", " + limit);
                        case 7:
                            result = parser_1.makeItems(items);
                            lru_1.cache12.set(h, result);
                            return [2 /*return*/, result];
                    }
                });
            });
        };
        Music.prototype.collectionListOrders = function (origin) {
            var items;
            switch (origin) {
                case origin_1.ORIGIN.xiami:
                    items = this.xiamiApi.collectionListOrders();
                    break;
                case origin_1.ORIGIN.netease:
                    items = this.neteaseApi.collectionListOrders();
                    break;
                case origin_1.ORIGIN.qq:
                    items = this.qqApi.collectionListOrders();
                    break;
                default:
                    // Here will never be occured.
                    throw new Error("[ERROR] [Music.collectionListOrders] Here will never be occured. [args]: " + origin);
            }
            return items;
        };
        Music.prototype.collectionListOptions = function (origin) {
            return __awaiter(this, void 0, void 0, function () {
                var h, result, items, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            h = crypto_1.md5("music.core.api.collectionListOptions(" + origin + ")");
                            result = lru_1.cache12.get(h);
                            if (result)
                                return [2 /*return*/, result];
                            _a = origin;
                            switch (_a) {
                                case origin_1.ORIGIN.xiami: return [3 /*break*/, 1];
                                case origin_1.ORIGIN.netease: return [3 /*break*/, 3];
                                case origin_1.ORIGIN.qq: return [3 /*break*/, 5];
                            }
                            return [3 /*break*/, 7];
                        case 1: return [4 /*yield*/, this.xiamiApi.collectionListOptions()];
                        case 2:
                            items = _b.sent();
                            return [3 /*break*/, 8];
                        case 3: return [4 /*yield*/, this.neteaseApi.collectionListOptions()];
                        case 4:
                            items = _b.sent();
                            return [3 /*break*/, 8];
                        case 5: return [4 /*yield*/, this.qqApi.collectionListOptions()];
                        case 6:
                            items = _b.sent();
                            return [3 /*break*/, 8];
                        case 7: 
                        // Here will never be occured.
                        throw new Error("[ERROR] [Music.collectionListOptions] Here will never be occured. [args]: " + origin);
                        case 8:
                            result = items;
                            lru_1.cache12.set(h, result);
                            return [2 /*return*/, result];
                    }
                });
            });
        };
        Music.prototype.collectionList = function (origin, keyword, order, offset, limit) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var h, result, items, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            h = crypto_1.md5("music.core.api.collectionList(" + origin + ", " + keyword + ", " + order + ", " + offset + ", " + limit + ")");
                            result = lru_1.cache12.get(h);
                            result = parser_1.makeItems(result);
                            if (result)
                                return [2 /*return*/, result];
                            _a = origin;
                            switch (_a) {
                                case origin_1.ORIGIN.xiami: return [3 /*break*/, 1];
                                case origin_1.ORIGIN.netease: return [3 /*break*/, 3];
                                case origin_1.ORIGIN.qq: return [3 /*break*/, 5];
                            }
                            return [3 /*break*/, 7];
                        case 1: return [4 /*yield*/, this.xiamiApi.collectionList(keyword, order, offset, limit)];
                        case 2:
                            items = _b.sent();
                            return [3 /*break*/, 8];
                        case 3: return [4 /*yield*/, this.neteaseApi.collectionList(keyword, order, offset, limit)];
                        case 4:
                            items = _b.sent();
                            return [3 /*break*/, 8];
                        case 5: return [4 /*yield*/, this.qqApi.collectionList(order, keyword, offset, limit)];
                        case 6:
                            items = _b.sent();
                            return [3 /*break*/, 8];
                        case 7: 
                        // Here will never be occured.
                        throw new Error("[ERROR] [Music.collectionList] Here will never be occured. [args]: " + origin + ", " + keyword + ", " + order + ", " + offset + ", " + limit);
                        case 8:
                            result = parser_1.makeItems(items);
                            lru_1.cache12.set(h, result);
                            return [2 /*return*/, result];
                    }
                });
            });
        };
        Music.prototype.artistList = function (origin, area, genre, gender, index, offset, limit) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 40; }
            return __awaiter(this, void 0, void 0, function () {
                var h, result, items, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            h = crypto_1.md5("music.core.api.artistList(" + origin + ", " + area + ", " + genre + ", " + gender + ", " + index + ", " + offset + ", " + limit + ")");
                            result = lru_1.cache12.get(h);
                            if (origin == origin_1.ORIGIN.xiami) {
                                result[0] = parser_1.makeItems(result[0]);
                            }
                            else {
                                result = parser_1.makeItems(result);
                            }
                            if (result)
                                return [2 /*return*/, result];
                            _a = origin;
                            switch (_a) {
                                case origin_1.ORIGIN.xiami: return [3 /*break*/, 1];
                                case origin_1.ORIGIN.netease: return [3 /*break*/, 3];
                                case origin_1.ORIGIN.qq: return [3 /*break*/, 5];
                            }
                            return [3 /*break*/, 7];
                        case 1: return [4 /*yield*/, this.xiamiApi.artistList(area, genre, gender, offset, limit)];
                        case 2:
                            items = _b.sent();
                            items[0] = parser_1.makeItems(items[0]);
                            return [3 /*break*/, 8];
                        case 3: return [4 /*yield*/, this.neteaseApi.artistList(genre, index, offset, limit)];
                        case 4:
                            items = _b.sent();
                            items = parser_1.makeItems(items);
                            return [3 /*break*/, 8];
                        case 5: return [4 /*yield*/, this.qqApi.artistList(area, genre, gender, index, offset, limit)];
                        case 6:
                            items = _b.sent();
                            items = parser_1.makeItems(items);
                            return [3 /*break*/, 8];
                        case 7: 
                        // Here will never be occured.
                        throw new Error("[ERROR] [Music.artistList] Here will never be occured. [args]: " + origin + ", " + area + ", " + genre + ", " + gender + ", " + index + ", " + offset + ", " + limit);
                        case 8:
                            lru_1.cache12.set(h, result);
                            return [2 /*return*/, result];
                    }
                });
            });
        };
        Music.prototype.newSongs = function (origin, offset, limit) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var h, result, items, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            h = crypto_1.md5("music.core.api.newSongs(" + origin + ", " + offset + ", " + limit + ")");
                            result = lru_1.cache12.get(h);
                            result = parser_1.makeItems(result);
                            if (result)
                                return [2 /*return*/, result];
                            _a = origin;
                            switch (_a) {
                                case origin_1.ORIGIN.xiami: return [3 /*break*/, 1];
                                case origin_1.ORIGIN.netease: return [3 /*break*/, 3];
                                case origin_1.ORIGIN.qq: return [3 /*break*/, 5];
                            }
                            return [3 /*break*/, 7];
                        case 1: return [4 /*yield*/, this.xiamiApi.newSongs(offset, limit)];
                        case 2:
                            items = _b.sent();
                            return [3 /*break*/, 8];
                        case 3: return [4 /*yield*/, this.neteaseApi.newSongs(offset, limit)];
                        case 4:
                            items = _b.sent();
                            return [3 /*break*/, 8];
                        case 5: return [4 /*yield*/, this.qqApi.newSongs(offset, limit)];
                        case 6:
                            items = _b.sent();
                            return [3 /*break*/, 8];
                        case 7: 
                        // Here will never be occured.
                        throw new Error("[ERROR] [Music.newSongs] Here will never be occured. [args]: " + origin);
                        case 8:
                            result = parser_1.makeItems(items);
                            lru_1.cache12.set(h, result);
                            return [2 /*return*/, result];
                    }
                });
            });
        };
        Music.prototype.newAlbums = function (origin, offset, limit) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var h, result, items, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            h = crypto_1.md5("music.core.api.newAlbums(" + origin + ", " + offset + ", " + limit + ")");
                            result = lru_1.cache12.get(h);
                            result = parser_1.makeItems(result);
                            if (result)
                                return [2 /*return*/, result];
                            _a = origin;
                            switch (_a) {
                                case origin_1.ORIGIN.xiami: return [3 /*break*/, 1];
                                case origin_1.ORIGIN.netease: return [3 /*break*/, 3];
                                case origin_1.ORIGIN.qq: return [3 /*break*/, 5];
                            }
                            return [3 /*break*/, 7];
                        case 1: return [4 /*yield*/, this.xiamiApi.newAlbums(offset, limit)];
                        case 2:
                            items = _b.sent();
                            return [3 /*break*/, 8];
                        case 3: return [4 /*yield*/, this.neteaseApi.newAlbums(offset, limit)];
                        case 4:
                            items = _b.sent();
                            return [3 /*break*/, 8];
                        case 5: return [4 /*yield*/, this.qqApi.newAlbums(offset, limit)];
                        case 6:
                            items = _b.sent();
                            return [3 /*break*/, 8];
                        case 7: 
                        // Here will never be occured.
                        throw new Error("[ERROR] [Music.newAlbums] Here will never be occured. [args]: " + origin);
                        case 8:
                            result = parser_1.makeItems(items);
                            lru_1.cache12.set(h, result);
                            return [2 /*return*/, result];
                    }
                });
            });
        };
        Music.prototype.newCollections = function (origin, offset, limit) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var h, result, items, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            h = crypto_1.md5("music.core.api.newCollections(" + origin + ", " + offset + ", " + limit + ")");
                            result = lru_1.cache12.get(h);
                            if (result)
                                return [2 /*return*/, result];
                            _a = origin;
                            switch (_a) {
                                case origin_1.ORIGIN.xiami: return [3 /*break*/, 1];
                                case origin_1.ORIGIN.netease: return [3 /*break*/, 3];
                                case origin_1.ORIGIN.qq: return [3 /*break*/, 5];
                            }
                            return [3 /*break*/, 7];
                        case 1: return [4 /*yield*/, this.xiamiApi.newCollections(offset, limit)];
                        case 2:
                            items = _b.sent();
                            return [3 /*break*/, 8];
                        case 3: return [4 /*yield*/, this.neteaseApi.newCollections(offset, limit)];
                        case 4:
                            items = _b.sent();
                            return [3 /*break*/, 8];
                        case 5: return [4 /*yield*/, this.qqApi.newCollections(offset, limit)];
                        case 6:
                            items = _b.sent();
                            return [3 /*break*/, 8];
                        case 7: 
                        // Here will never be occured.
                        throw new Error("[ERROR] [Music.newCollections] Here will never be occured. [args]: " + origin);
                        case 8:
                            result = parser_1.makeItems(items);
                            lru_1.cache12.set(h, result);
                            return [2 /*return*/, result];
                    }
                });
            });
        };
        Music.prototype.login = function (origin, accountName, password) {
            return __awaiter(this, void 0, void 0, function () {
                var account, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            _a = origin;
                            switch (_a) {
                                case origin_1.ORIGIN.xiami: return [3 /*break*/, 1];
                                case origin_1.ORIGIN.netease: return [3 /*break*/, 3];
                                case origin_1.ORIGIN.qq: return [3 /*break*/, 5];
                            }
                            return [3 /*break*/, 7];
                        case 1: return [4 /*yield*/, this.xiamiApi.login(accountName, password)];
                        case 2:
                            account = _b.sent();
                            this.xiamiApi.setAccount(account);
                            return [3 /*break*/, 8];
                        case 3: return [4 /*yield*/, this.neteaseApi.login(accountName, password)];
                        case 4:
                            account = _b.sent();
                            // account = await this.neteaseApi.login();
                            this.neteaseApi.setAccount(account);
                            return [3 /*break*/, 8];
                        case 5: return [4 /*yield*/, this.qqApi.login()];
                        case 6:
                            account = _b.sent();
                            this.qqApi.setAccount(account);
                            return [3 /*break*/, 8];
                        case 7: 
                        // Here will never be occured.
                        throw new Error("[ERROR] [Music.login] Here will never be occured. [args]: " + origin + ", " + accountName);
                        case 8: return [2 /*return*/, account];
                    }
                });
            });
        };
        /**
         * Check whether logined
         */
        Music.prototype.logined = function (origin) {
            switch (origin) {
                case origin_1.ORIGIN.xiami:
                    return this.xiamiApi.logined();
                case origin_1.ORIGIN.netease:
                    return this.neteaseApi.logined();
                case origin_1.ORIGIN.qq:
                    return this.qqApi.logined();
                default:
                    // Here will never be occured.
                    throw new Error("[ERROR] [Music.logined] Here will never be occured. [args]: " + origin);
            }
        };
        Music.prototype.setAccount = function (account) {
            if (!account) {
                return;
            }
            var origin = account.user.origin;
            switch (origin) {
                case origin_1.ORIGIN.xiami:
                    this.xiamiApi.setAccount(account);
                    break;
                case origin_1.ORIGIN.netease:
                    this.neteaseApi.setAccount(account);
                    break;
                case origin_1.ORIGIN.qq:
                    this.qqApi.setAccount(account);
                    break;
                default:
                    // Here will never be occured.
                    throw new Error("[ERROR] [Music.login] Here will never be occured. [args]: " + origin + ", " + account);
            }
        };
        /**
         * here, the userId is IUserProfile.userId
         */
        Music.prototype.userProfile = function (userId, userMid, userName) {
            return __awaiter(this, void 0, void 0, function () {
                var h, result, userProfile, originType, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            h = crypto_1.md5("music.core.api.userProfile(" + userId + ", " + userMid + ", " + userName + ")");
                            result = lru_1.cache12.get(h);
                            result = parser_1.makeItem(result);
                            if (result)
                                return [2 /*return*/, result];
                            originType = origin_1.getOrigin(userId);
                            _a = originType.origin;
                            switch (_a) {
                                case origin_1.ORIGIN.xiami: return [3 /*break*/, 1];
                                case origin_1.ORIGIN.netease: return [3 /*break*/, 3];
                                case origin_1.ORIGIN.qq: return [3 /*break*/, 5];
                                case origin_1.ORIGIN.qianqian: return [3 /*break*/, 7];
                            }
                            return [3 /*break*/, 9];
                        case 1: return [4 /*yield*/, this.xiamiApi.userProfile(originType.id)];
                        case 2:
                            userProfile = _b.sent();
                            return [3 /*break*/, 10];
                        case 3: return [4 /*yield*/, this.neteaseApi.userProfile(originType.id)];
                        case 4:
                            userProfile = _b.sent();
                            return [3 /*break*/, 10];
                        case 5: return [4 /*yield*/, this.qqApi.userProfile(userId && userMid)];
                        case 6:
                            userProfile = _b.sent();
                            return [3 /*break*/, 10];
                        case 7: return [4 /*yield*/, this.qianqianApi.userProfile(userName)];
                        case 8:
                            userProfile = _b.sent();
                            return [3 /*break*/, 10];
                        case 9: 
                        // Here will never be occured.
                        throw new Error("[ERROR] [Music.login] Here will never be occured. [args]: " + userId);
                        case 10:
                            result = parser_1.makeItem(userProfile);
                            lru_1.cache12.set(h, result);
                            return [2 /*return*/, result];
                    }
                });
            });
        };
        /**
         * here, the userId is IUserProfile.userId
         */
        Music.prototype.userFavoriteSongs = function (userId, offset, limit, userMid) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var h, result, songs, originType, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            h = crypto_1.md5("music.core.api.userFavoriteSongs(" + userId + ", " + offset + ", " + limit + ", " + userMid + ")");
                            result = lru_1.cache12.get(h);
                            result = parser_1.makeItems(result);
                            if (result)
                                return [2 /*return*/, result];
                            originType = origin_1.getOrigin(userId);
                            _a = originType.origin;
                            switch (_a) {
                                case origin_1.ORIGIN.xiami: return [3 /*break*/, 1];
                                case origin_1.ORIGIN.netease: return [3 /*break*/, 3];
                                case origin_1.ORIGIN.qq: return [3 /*break*/, 5];
                                case origin_1.ORIGIN.qianqian: return [3 /*break*/, 7];
                            }
                            return [3 /*break*/, 9];
                        case 1: return [4 /*yield*/, this.xiamiApi.userFavoriteSongs(originType.id, offset, limit)];
                        case 2:
                            songs = _b.sent();
                            return [3 /*break*/, 10];
                        case 3: return [4 /*yield*/, this.neteaseApi.userFavoriteSongs(originType.id, offset, limit)];
                        case 4:
                            songs = _b.sent();
                            return [3 /*break*/, 10];
                        case 5: return [4 /*yield*/, this.qqApi.userFavoriteSongs(userMid, offset, limit)];
                        case 6:
                            songs = _b.sent();
                            return [3 /*break*/, 10];
                        case 7: return [4 /*yield*/, this.qianqianApi.userFavoriteSongs(originType.id, offset, limit)];
                        case 8:
                            songs = _b.sent();
                            return [3 /*break*/, 10];
                        case 9: 
                        // Here will never be occured.
                        throw new Error("[ERROR] [Music.userFavoriteSongs] Here will never be occured. [args]: " + userId);
                        case 10:
                            result = parser_1.makeItems(songs);
                            lru_1.cache12.set(h, result);
                            return [2 /*return*/, result];
                    }
                });
            });
        };
        Music.prototype.userFavoriteAlbums = function (userId, offset, limit, userMid) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var h, result, albums, originType, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            h = crypto_1.md5("music.core.api.userFavoriteAlbums(" + userId + ", " + offset + ", " + limit + ", " + userMid + ")");
                            result = lru_1.cache12.get(h);
                            result = parser_1.makeItems(result);
                            if (result)
                                return [2 /*return*/, result];
                            originType = origin_1.getOrigin(userId);
                            _a = originType.origin;
                            switch (_a) {
                                case origin_1.ORIGIN.xiami: return [3 /*break*/, 1];
                                case origin_1.ORIGIN.netease: return [3 /*break*/, 3];
                                case origin_1.ORIGIN.qq: return [3 /*break*/, 4];
                                case origin_1.ORIGIN.qianqian: return [3 /*break*/, 6];
                            }
                            return [3 /*break*/, 8];
                        case 1: return [4 /*yield*/, this.xiamiApi.userFavoriteAlbums(originType.id, offset, limit)];
                        case 2:
                            albums = _b.sent();
                            return [3 /*break*/, 9];
                        case 3:
                            albums = [];
                            return [3 /*break*/, 9];
                        case 4: return [4 /*yield*/, this.qqApi.userFavoriteAlbums(userMid, offset, limit)];
                        case 5:
                            albums = _b.sent();
                            return [3 /*break*/, 9];
                        case 6: return [4 /*yield*/, this.qianqianApi.userFavoriteAlbums(originType.id, offset, limit)];
                        case 7:
                            albums = _b.sent();
                            return [3 /*break*/, 9];
                        case 8: 
                        // Here will never be occured.
                        throw new Error("[ERROR] [Music.userFavoriteAlbums] Here will never be occured. [args]: " + userId);
                        case 9:
                            result = parser_1.makeItems(albums);
                            lru_1.cache12.set(h, result);
                            return [2 /*return*/, result];
                    }
                });
            });
        };
        Music.prototype.userFavoriteArtists = function (userId, offset, limit, userMid) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var h, result, artists, originType, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            h = crypto_1.md5("music.core.api.userFavoriteArtists(" + userId + ", " + offset + ", " + limit + ", " + userMid + ")");
                            result = lru_1.cache12.get(h);
                            result = parser_1.makeItems(result);
                            if (result)
                                return [2 /*return*/, result];
                            originType = origin_1.getOrigin(userId);
                            _a = originType.origin;
                            switch (_a) {
                                case origin_1.ORIGIN.xiami: return [3 /*break*/, 1];
                                case origin_1.ORIGIN.netease: return [3 /*break*/, 3];
                                case origin_1.ORIGIN.qq: return [3 /*break*/, 5];
                                case origin_1.ORIGIN.qianqian: return [3 /*break*/, 7];
                            }
                            return [3 /*break*/, 9];
                        case 1: return [4 /*yield*/, this.xiamiApi.userFavoriteArtists(originType.id, offset, limit)];
                        case 2:
                            artists = _b.sent();
                            return [3 /*break*/, 10];
                        case 3: return [4 /*yield*/, this.neteaseApi.userFavoriteArtists(originType.id, offset, limit)];
                        case 4:
                            artists = _b.sent();
                            return [3 /*break*/, 10];
                        case 5: return [4 /*yield*/, this.qqApi.userFavoriteArtists(userMid, offset, limit)];
                        case 6:
                            artists = _b.sent();
                            return [3 /*break*/, 10];
                        case 7: return [4 /*yield*/, this.qianqianApi.userFavoriteArtists(originType.id, offset, limit)];
                        case 8:
                            artists = _b.sent();
                            return [3 /*break*/, 10];
                        case 9: 
                        // Here will never be occured.
                        throw new Error("[ERROR] [Music.userFavoriteArtists] Here will never be occured. [args]: " + userId);
                        case 10:
                            result = parser_1.makeItems(artists);
                            lru_1.cache12.set(h, result);
                            return [2 /*return*/, result];
                    }
                });
            });
        };
        Music.prototype.userFavoriteCollections = function (userId, offset, limit, userMid) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var h, result, collections, originType, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            h = crypto_1.md5("music.core.api.userFavoriteCollections(" + userId + ", " + offset + ", " + limit + ", " + userMid + ")");
                            result = lru_1.cache12.get(h);
                            result = parser_1.makeItems(result);
                            if (result)
                                return [2 /*return*/, result];
                            originType = origin_1.getOrigin(userId);
                            _a = originType.origin;
                            switch (_a) {
                                case origin_1.ORIGIN.xiami: return [3 /*break*/, 1];
                                case origin_1.ORIGIN.netease: return [3 /*break*/, 3];
                                case origin_1.ORIGIN.qq: return [3 /*break*/, 5];
                                case origin_1.ORIGIN.qianqian: return [3 /*break*/, 7];
                            }
                            return [3 /*break*/, 9];
                        case 1: return [4 /*yield*/, this.xiamiApi.userFavoriteCollections(originType.id, offset, limit)];
                        case 2:
                            collections = _b.sent();
                            return [3 /*break*/, 10];
                        case 3: return [4 /*yield*/, this.neteaseApi.userFavoriteCollections(originType.id, offset, limit)];
                        case 4:
                            collections = _b.sent();
                            return [3 /*break*/, 10];
                        case 5: return [4 /*yield*/, this.qqApi.userFavoriteCollections(userMid, offset, limit)];
                        case 6:
                            collections = _b.sent();
                            return [3 /*break*/, 10];
                        case 7: return [4 /*yield*/, this.qianqianApi.userFavoriteCollections(originType.id, offset, limit)];
                        case 8:
                            collections = _b.sent();
                            return [3 /*break*/, 10];
                        case 9: 
                        // Here will never be occured.
                        throw new Error("[ERROR] [Music.userFavoriteCollections] Here will never be occured. [args]: " + userId);
                        case 10:
                            result = parser_1.makeItems(collections);
                            lru_1.cache12.set(h, result);
                            return [2 /*return*/, result];
                    }
                });
            });
        };
        Music.prototype.userCreatedCollections = function (userId, offset, limit, userMid) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var h, result, collections, originType, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            h = crypto_1.md5("music.core.api.userCreatedCollections(" + userId + ", " + offset + ", " + limit + ", " + userMid + ")");
                            result = lru_1.cache12.get(h);
                            result = parser_1.makeItems(result);
                            if (result)
                                return [2 /*return*/, result];
                            originType = origin_1.getOrigin(userId);
                            _a = originType.origin;
                            switch (_a) {
                                case origin_1.ORIGIN.xiami: return [3 /*break*/, 1];
                                case origin_1.ORIGIN.netease: return [3 /*break*/, 3];
                                case origin_1.ORIGIN.qq: return [3 /*break*/, 4];
                                case origin_1.ORIGIN.qianqian: return [3 /*break*/, 6];
                            }
                            return [3 /*break*/, 8];
                        case 1: return [4 /*yield*/, this.xiamiApi.userCreatedCollections(originType.id, offset, limit)];
                        case 2:
                            collections = _b.sent();
                            return [3 /*break*/, 9];
                        case 3:
                            collections = [];
                            return [3 /*break*/, 9];
                        case 4: return [4 /*yield*/, this.qqApi.userCreatedCollections(userMid, offset, limit)];
                        case 5:
                            collections = _b.sent();
                            return [3 /*break*/, 9];
                        case 6: return [4 /*yield*/, this.qianqianApi.userCreatedCollections(originType.id, offset, limit)];
                        case 7:
                            collections = _b.sent();
                            return [3 /*break*/, 9];
                        case 8: 
                        // Here will never be occured.
                        throw new Error("[ERROR] [Music.userCreatedCollections] Here will never be occured. [args]: " + userId);
                        case 9:
                            result = parser_1.makeItems(collections);
                            lru_1.cache12.set(h, result);
                            return [2 /*return*/, result];
                    }
                });
            });
        };
        Music.prototype.userFollowings = function (userId, offset, limit, userMid) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var h, result, userProfiles, originType, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            h = crypto_1.md5("music.core.api.userFollowings(" + userId + ", " + offset + ", " + limit + ", " + userMid + ")");
                            result = lru_1.cache12.get(h);
                            result = parser_1.makeItems(result);
                            if (result)
                                return [2 /*return*/, result];
                            originType = origin_1.getOrigin(userId);
                            _a = originType.origin;
                            switch (_a) {
                                case origin_1.ORIGIN.xiami: return [3 /*break*/, 1];
                                case origin_1.ORIGIN.netease: return [3 /*break*/, 3];
                                case origin_1.ORIGIN.qq: return [3 /*break*/, 5];
                                case origin_1.ORIGIN.qianqian: return [3 /*break*/, 7];
                            }
                            return [3 /*break*/, 9];
                        case 1: return [4 /*yield*/, this.xiamiApi.userFollowings(originType.id, offset, limit)];
                        case 2:
                            userProfiles = _b.sent();
                            return [3 /*break*/, 10];
                        case 3: return [4 /*yield*/, this.neteaseApi.userFollowings(originType.id, offset, limit)];
                        case 4:
                            userProfiles = _b.sent();
                            return [3 /*break*/, 10];
                        case 5: return [4 /*yield*/, this.qqApi.userFollowings(userMid, offset, limit)];
                        case 6:
                            userProfiles = _b.sent();
                            return [3 /*break*/, 10];
                        case 7: return [4 /*yield*/, this.qianqianApi.userFollowings(originType.id, offset, limit)];
                        case 8:
                            userProfiles = _b.sent();
                            return [3 /*break*/, 10];
                        case 9: 
                        // Here will never be occured.
                        throw new Error("[ERROR] [Music.userFollowings] Here will never be occured. [args]: " + userId);
                        case 10:
                            result = parser_1.makeItems(userProfiles);
                            lru_1.cache12.set(h, result);
                            return [2 /*return*/, result];
                    }
                });
            });
        };
        Music.prototype.userFollowers = function (userId, offset, limit, userMid) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var h, result, userProfiles, originType, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            h = crypto_1.md5("music.core.api.userFollowers(" + userId + ", " + offset + ", " + limit + ", " + userMid + ")");
                            result = lru_1.cache12.get(h);
                            result = parser_1.makeItems(result);
                            if (result)
                                return [2 /*return*/, result];
                            originType = origin_1.getOrigin(userId);
                            _a = originType.origin;
                            switch (_a) {
                                case origin_1.ORIGIN.xiami: return [3 /*break*/, 1];
                                case origin_1.ORIGIN.netease: return [3 /*break*/, 3];
                                case origin_1.ORIGIN.qq: return [3 /*break*/, 5];
                                case origin_1.ORIGIN.qianqian: return [3 /*break*/, 7];
                            }
                            return [3 /*break*/, 9];
                        case 1: return [4 /*yield*/, this.xiamiApi.userFollowers(originType.id, offset, limit)];
                        case 2:
                            userProfiles = _b.sent();
                            return [3 /*break*/, 10];
                        case 3: return [4 /*yield*/, this.neteaseApi.userFollowers(originType.id, offset, limit)];
                        case 4:
                            userProfiles = _b.sent();
                            return [3 /*break*/, 10];
                        case 5: return [4 /*yield*/, this.qqApi.userFollowers(userMid, offset, limit)];
                        case 6:
                            userProfiles = _b.sent();
                            return [3 /*break*/, 10];
                        case 7: return [4 /*yield*/, this.qianqianApi.userFollowers(originType.id, offset, limit)];
                        case 8:
                            userProfiles = _b.sent();
                            return [3 /*break*/, 10];
                        case 9: 
                        // Here will never be occured.
                        throw new Error("[ERROR] [Music.userFollowers] Here will never be occured. [args]: " + userId);
                        case 10:
                            result = parser_1.makeItems(userProfiles);
                            lru_1.cache12.set(h, result);
                            return [2 /*return*/, result];
                    }
                });
            });
        };
        Music.prototype.userLikeOrDislike = function (funcName, itemId, itemMid) {
            return __awaiter(this, void 0, void 0, function () {
                var result, originType, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            originType = origin_1.getOrigin(itemId);
                            _a = originType.origin;
                            switch (_a) {
                                case origin_1.ORIGIN.xiami: return [3 /*break*/, 1];
                                case origin_1.ORIGIN.netease: return [3 /*break*/, 3];
                                case origin_1.ORIGIN.qq: return [3 /*break*/, 5];
                            }
                            return [3 /*break*/, 7];
                        case 1: return [4 /*yield*/, this.xiamiApi[funcName](originType.id, itemMid)];
                        case 2:
                            result = _b.sent();
                            return [3 /*break*/, 8];
                        case 3: return [4 /*yield*/, this.neteaseApi[funcName](originType.id, itemMid)];
                        case 4:
                            result = _b.sent();
                            return [3 /*break*/, 8];
                        case 5: return [4 /*yield*/, this.qqApi[funcName](originType.id, itemMid)];
                        case 6:
                            result = _b.sent();
                            return [3 /*break*/, 8];
                        case 7: 
                        // Here will never be occured.
                        throw new Error("[ERROR] [Music.userLikeOrDislike] Here will never be occured. [args]: " + funcName + " " + itemId);
                        case 8: return [2 /*return*/, result];
                    }
                });
            });
        };
        Music.prototype.userLikeSong = function (itemId, itemMid) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, this.userLikeOrDislike('userLikeSong', itemId, itemMid)];
                });
            });
        };
        Music.prototype.userLikeArtist = function (itemId, itemMid) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, this.userLikeOrDislike('userLikeArtist', itemId, itemMid)];
                });
            });
        };
        Music.prototype.userLikeAlbum = function (itemId, itemMid) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, this.userLikeOrDislike('userLikeAlbum', itemId, itemMid)];
                });
            });
        };
        Music.prototype.userLikeCollection = function (itemId, itemMid) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, this.userLikeOrDislike('userLikeCollection', itemId, itemMid)];
                });
            });
        };
        Music.prototype.userLikeUserProfile = function (itemId, itemMid) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, this.userLikeOrDislike('userLikeUserProfile', itemId, itemMid)];
                });
            });
        };
        Music.prototype.userDislikeSong = function (itemId, itemMid) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, this.userLikeOrDislike('userDislikeSong', itemId, itemMid)];
                });
            });
        };
        Music.prototype.userDislikeArtist = function (itemId, itemMid) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, this.userLikeOrDislike('userDislikeArtist', itemId, itemMid)];
                });
            });
        };
        Music.prototype.userDislikeAlbum = function (itemId, itemMid) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, this.userLikeOrDislike('userDislikeAlbum', itemId, itemMid)];
                });
            });
        };
        Music.prototype.userDislikeCollection = function (itemId, itemMid) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, this.userLikeOrDislike('userDislikeCollection', itemId, itemMid)];
                });
            });
        };
        Music.prototype.userDislikeUserProfile = function (itemId, itemMid) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, this.userLikeOrDislike('userDislikeUserProfile', itemId, itemMid)];
                });
            });
        };
        Music.prototype.playLog = function (songId, seek, songMid) {
            return __awaiter(this, void 0, void 0, function () {
                var result, originType, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            originType = origin_1.getOrigin(songId);
                            _a = originType.origin;
                            switch (_a) {
                                case origin_1.ORIGIN.xiami: return [3 /*break*/, 1];
                                case origin_1.ORIGIN.netease: return [3 /*break*/, 3];
                                case origin_1.ORIGIN.qq: return [3 /*break*/, 5];
                                case origin_1.ORIGIN.qianqian: return [3 /*break*/, 7];
                                case origin_1.ORIGIN.migu: return [3 /*break*/, 7];
                                case origin_1.ORIGIN.kuwo: return [3 /*break*/, 7];
                            }
                            return [3 /*break*/, 8];
                        case 1: return [4 /*yield*/, this.xiamiApi.playLog(originType.id, seek)];
                        case 2:
                            result = _b.sent();
                            return [3 /*break*/, 9];
                        case 3: return [4 /*yield*/, this.neteaseApi.playLog(originType.id, seek)];
                        case 4:
                            result = _b.sent();
                            return [3 /*break*/, 9];
                        case 5: return [4 /*yield*/, this.qqApi.playLog(originType.id, seek, songMid)];
                        case 6:
                            result = _b.sent();
                            return [3 /*break*/, 9];
                        case 7: return [3 /*break*/, 9];
                        case 8: 
                        // Here will never be occured.
                        throw new Error("[ERROR] [Music.playLog] Here will never be occured. [args]: " + songId + " " + seek);
                        case 9: return [2 /*return*/, result];
                    }
                });
            });
        };
        Music.prototype.recommendSongs = function (origin, offset, limit) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var h, result, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            h = crypto_1.md5("music.core.api.recommendSongs(" + origin + ", " + offset + ", " + limit + ")");
                            result = lru_1.cache12.get(h);
                            result = parser_1.makeItems(result);
                            if (result)
                                return [2 /*return*/, result];
                            _a = origin;
                            switch (_a) {
                                case origin_1.ORIGIN.xiami: return [3 /*break*/, 1];
                                case origin_1.ORIGIN.netease: return [3 /*break*/, 3];
                                case origin_1.ORIGIN.qq: return [3 /*break*/, 5];
                            }
                            return [3 /*break*/, 7];
                        case 1: return [4 /*yield*/, this.xiamiApi.recommendSongs(offset, limit)];
                        case 2:
                            result = _b.sent();
                            return [3 /*break*/, 8];
                        case 3: return [4 /*yield*/, this.neteaseApi.recommendSongs(offset, limit)];
                        case 4:
                            result = _b.sent();
                            return [3 /*break*/, 8];
                        case 5: return [4 /*yield*/, this.qqApi.recommendSongs(offset, limit)];
                        case 6:
                            result = _b.sent();
                            return [3 /*break*/, 8];
                        case 7: 
                        // Here will never be occured.
                        throw new Error("[ERROR] [Music.recommendSongs] Here will never be occured. [args]: " + origin);
                        case 8:
                            result = parser_1.makeItems(result);
                            lru_1.cache12.set(h, result);
                            return [2 /*return*/, result];
                    }
                });
            });
        };
        Music.prototype.recommendCollections = function (origin, offset, limit) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var h, result, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            h = crypto_1.md5("music.core.api.recommendCollections(" + origin + ", " + offset + ", " + limit + ")");
                            result = lru_1.cache12.get(h);
                            result = parser_1.makeItems(result);
                            if (result)
                                return [2 /*return*/, result];
                            _a = origin;
                            switch (_a) {
                                case origin_1.ORIGIN.xiami: return [3 /*break*/, 1];
                                case origin_1.ORIGIN.netease: return [3 /*break*/, 3];
                                case origin_1.ORIGIN.qq: return [3 /*break*/, 5];
                            }
                            return [3 /*break*/, 7];
                        case 1: return [4 /*yield*/, this.xiamiApi.recommendCollections(offset, limit)];
                        case 2:
                            result = _b.sent();
                            return [3 /*break*/, 8];
                        case 3: return [4 /*yield*/, this.neteaseApi.recommendCollections(offset, limit)];
                        case 4:
                            result = _b.sent();
                            return [3 /*break*/, 8];
                        case 5: return [4 /*yield*/, this.qqApi.recommendCollections(offset, limit)];
                        case 6:
                            result = _b.sent();
                            return [3 /*break*/, 8];
                        case 7: 
                        // Here will never be occured.
                        throw new Error("[ERROR] [Music.recommendCollections] Here will never be occured. [args]: " + origin);
                        case 8:
                            result = parser_1.makeItems(result);
                            lru_1.cache12.set(h, result);
                            return [2 /*return*/, result];
                    }
                });
            });
        };
        Music.prototype.resizeImageUrl = function (origin, url, size) {
            if (!url) {
                return url;
            }
            switch (origin) {
                case origin_1.ORIGIN.xiami:
                    return this.xiamiApi.resizeImageUrl(url, size);
                case origin_1.ORIGIN.netease:
                    return this.neteaseApi.resizeImageUrl(url, size);
                case origin_1.ORIGIN.qq:
                    return this.qqApi.resizeImageUrl(url, size);
                case origin_1.ORIGIN.qianqian:
                    return this.qianqianApi.resizeImageUrl(url, size);
                case origin_1.ORIGIN.migu:
                    return this.miguApi.resizeImageUrl(url, size);
                case origin_1.ORIGIN.kuwo:
                    return this.kuwoApi.resizeImageUrl(url, size);
                default:
                    // Here will never be occured.
                    throw new Error("[ERROR] [Music.resizeImageUrl] Here will never be occured. [args]: " + url);
            }
        };
        /**
         * Get music items directly from urls
         */
        Music.prototype.fromURL = function (input) {
            return __awaiter(this, void 0, void 0, function () {
                var h, result, futs, chunks, chunks_1, chunks_1_1, chunk, list;
                var e_1, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            h = crypto_1.md5("music.core.api.fromURL(" + input + ")");
                            result = lru_1.cache12.get(h);
                            result = parser_1.makeItems(result);
                            if (result)
                                return [2 /*return*/, result];
                            futs = [];
                            chunks = input.split(' ');
                            try {
                                for (chunks_1 = __values(chunks), chunks_1_1 = chunks_1.next(); !chunks_1_1.done; chunks_1_1 = chunks_1.next()) {
                                    chunk = chunks_1_1.value;
                                    if (chunk.includes('xiami')) {
                                        futs.push(this.xiamiApi.fromURL(chunk));
                                    }
                                    else if (input.includes('163.com')) {
                                        futs.push(this.neteaseApi.fromURL(chunk));
                                    }
                                    else if (input.includes('qq.com')) {
                                        futs.push(this.qqApi.fromURL(chunk));
                                    }
                                    else if (input.includes('taihe.com')) {
                                        futs.push(this.qianqianApi.fromURL(chunk));
                                    }
                                    else if (input.includes('music.migu.cn')) {
                                        futs.push(this.miguApi.fromURL(chunk));
                                    }
                                    else if (input.includes('kuwo.cn')) {
                                        futs.push(this.kuwoApi.fromURL(chunk));
                                    }
                                }
                            }
                            catch (e_1_1) { e_1 = { error: e_1_1 }; }
                            finally {
                                try {
                                    if (chunks_1_1 && !chunks_1_1.done && (_a = chunks_1.return)) _a.call(chunks_1);
                                }
                                finally { if (e_1) throw e_1.error; }
                            }
                            if (futs.length == 0)
                                return [2 /*return*/, []];
                            return [4 /*yield*/, Promise.all(futs)];
                        case 1:
                            list = _b.sent();
                            result = parser_1.makeItems([].concat.apply([], __spread(list)));
                            lru_1.cache12.set(h, result);
                            return [2 /*return*/, result];
                    }
                });
            });
        };
        return Music;
    }());
    exports.Music = Music;
    exports.musicApi = new Music();
});
