var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
define(["require", "exports", "chord/platform/log/common/log", "chord/platform/utils/common/paths", "chord/base/node/random", "chord/base/common/constants", "chord/base/node/cookies", "chord/base/node/url", "chord/base/node/_request", "chord/music/common/size", "chord/music/kuwo/parser", "chord/music/kuwo/crypto"], function (require, exports, log_1, paths_1, random_1, constants_1, cookies_1, url_1, _request_1, size_1, parser_1, crypto_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.KuwoMusicApi = void 0;
    var loggerWarning = new log_1.Logger(paths_1.filenameToNodeName(__filename), log_1.LogLevel.Warning);
    var DOMAIN = 'kuwo.cn';
    var LETTERS = Array.from(constants_1.ASCII_LETTER_DIGIT);
    /**
     * Kuwo Music Api
     */
    var KuwoMusicApi = /** @class */ (function () {
        function KuwoMusicApi() {
            this.reset();
        }
        KuwoMusicApi.prototype.reset = function () {
            var csrf_token = random_1.getRandomSample(LETTERS, 12).join('');
            this.csrf_token = csrf_token;
            var cookieJar = cookies_1.makeCookieJar();
            var cookie = cookies_1.makeCookie('kw_token', csrf_token, DOMAIN);
            cookieJar.setCookie(cookie, 'http://' + DOMAIN);
            this.cookieJar = cookieJar;
        };
        /**
         * Request
         */
        KuwoMusicApi.prototype.request = function (node, apiParams, referer, domain) {
            return __awaiter(this, void 0, void 0, function () {
                var url, params, headers, options, json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            domain = domain || KuwoMusicApi.BASICURL;
                            url = domain + node;
                            params = apiParams ? url_1.querystringify(apiParams) : null;
                            headers = !!referer ? __assign(__assign({}, KuwoMusicApi.HEADERS), { Referer: referer, csrf: this.csrf_token }) : __assign(__assign({}, KuwoMusicApi.HEADERS), { Referer: KuwoMusicApi.BASICURL, csrf: this.csrf_token });
                            url = url + '?' + params;
                            options = {
                                method: 'GET',
                                url: url,
                                headers: headers,
                                jar: this.cookieJar || null,
                                gzip: true,
                                json: true,
                                resolveWithFullResponse: false,
                            };
                            return [4 /*yield*/, _request_1.request(options)];
                        case 1:
                            json = _a.sent();
                            if (!(json.code == 200 || json.status == 200)) {
                                loggerWarning.warning('[KuwoMusicApi.request] [Error]: (params, response):', options, json);
                            }
                            return [2 /*return*/, json];
                    }
                });
            });
        };
        /**
         * Request flac audio
         */
        KuwoMusicApi.prototype.request_audio_flac = function (songId) {
            return __awaiter(this, void 0, void 0, function () {
                var domain, url, apiParams, params, headers, options, info, e_1, kbps, url_2;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            domain = KuwoMusicApi.BASICURL_FLAC;
                            url = domain + KuwoMusicApi.NODE_MAP.audios_flac;
                            apiParams = {
                                f: 'kuwo',
                                q: crypto_1.encryptQuery('corp=kuwo&p2p=1&type=convert_url2&sig=0&format=flac&rid=' + songId),
                            };
                            params = url_1.querystringify(apiParams);
                            headers = {
                                'user-agent': 'okhttp/3.10.0',
                            };
                            url = url + '?' + params;
                            options = {
                                method: 'GET',
                                url: url,
                                headers: headers,
                                jar: null,
                                gzip: true,
                                resolveWithFullResponse: false,
                            };
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, _request_1.request(options)];
                        case 2:
                            info = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            e_1 = _a.sent();
                            return [2 /*return*/, null];
                        case 4:
                            if (info && info.startsWith('format=flac')) {
                                kbps = /bitrate=(\d+)/.exec(info)[1];
                                url_2 = /url=([^\s]+)/.exec(info)[1];
                                return [2 /*return*/, {
                                        kbps: Number.parseInt(kbps),
                                        url: url_2,
                                    }];
                            }
                            else {
                                return [2 /*return*/, null];
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        /**
         * Get audio urls, the songId must be number string
         */
        KuwoMusicApi.prototype.audios = function (songId, supKbps) {
            return __awaiter(this, void 0, void 0, function () {
                var br, kbps, info_1, audios_1, info, audios;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (supKbps <= 128) {
                                br = '128kmp3';
                                kbps = 128;
                            }
                            else if (supKbps <= 192) {
                                br = '192kmp3';
                                kbps = 192;
                            }
                            else if (supKbps <= 320) {
                                br = '320kmp3';
                                kbps = 320;
                            }
                            else {
                                kbps = 720;
                            }
                            if (!(supKbps > 320)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.request_audio_flac(songId)];
                        case 1:
                            info_1 = _a.sent();
                            if (info_1) {
                                audios_1 = [
                                    {
                                        format: 'flac',
                                        size: null,
                                        kbps: info_1['kbps'],
                                        url: info_1['url'],
                                        path: null,
                                    }
                                ];
                                console.log(audios_1);
                                return [2 /*return*/, audios_1];
                            }
                            else {
                                br = '320kmp3';
                                kbps = 320;
                            }
                            _a.label = 2;
                        case 2: return [4 /*yield*/, this.request(KuwoMusicApi.NODE_MAP.audios, {
                                format: 'mp3',
                                rid: songId,
                                response: 'url',
                                type: 'convert_url3',
                                br: br,
                                from: 'web',
                                t: Date.now(),
                            })];
                        case 3:
                            info = _a.sent();
                            audios = [
                                {
                                    format: 'mp3',
                                    size: null,
                                    kbps: kbps,
                                    url: info['url'],
                                    path: null,
                                }
                            ];
                            return [2 /*return*/, audios];
                    }
                });
            });
        };
        /**
         * Get a song, the songId must be number string
         */
        KuwoMusicApi.prototype.song = function (songId) {
            return __awaiter(this, void 0, void 0, function () {
                var json, info, song;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(KuwoMusicApi.NODE_MAP.song, { mid: songId })];
                        case 1:
                            json = _a.sent();
                            info = json.data;
                            song = parser_1.makeSong(info);
                            return [2 /*return*/, song];
                    }
                });
            });
        };
        KuwoMusicApi.prototype.lyric = function (songId) {
            return __awaiter(this, void 0, void 0, function () {
                var info;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(KuwoMusicApi.NODE_MAP.lyric, { musicId: songId }, null, 'http://m.kuwo.cn/')];
                        case 1:
                            info = _a.sent();
                            return [2 /*return*/, parser_1.makeLyric(songId, info.data.lrclist)];
                    }
                });
            });
        };
        /**
         * Get an album, the albumId must be number string
         */
        KuwoMusicApi.prototype.album = function (albumId) {
            return __awaiter(this, void 0, void 0, function () {
                var json, info, album;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(KuwoMusicApi.NODE_MAP.album, {
                                albumId: albumId,
                                pn: 1,
                                rn: 1000,
                            })];
                        case 1:
                            json = _a.sent();
                            info = json.data;
                            album = parser_1.makeAlbum(info);
                            return [2 /*return*/, album];
                    }
                });
            });
        };
        /**
         * Get an artist, the artistId must be number string
         */
        KuwoMusicApi.prototype.artist = function (artistId) {
            return __awaiter(this, void 0, void 0, function () {
                var json, info, artist;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(KuwoMusicApi.NODE_MAP.artist, { artistid: artistId })];
                        case 1:
                            json = _a.sent();
                            info = json.data;
                            artist = parser_1.makeArtist(info);
                            return [2 /*return*/, artist];
                    }
                });
            });
        };
        /**
         * Get songs of an artist, the artistId must be number string
         */
        KuwoMusicApi.prototype.artistSongs = function (artistId, page, size) {
            if (page === void 0) { page = 1; }
            if (size === void 0) { size = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var json, info, songs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(KuwoMusicApi.NODE_MAP.artistSongs, {
                                artistid: artistId,
                                pn: page,
                                rn: size,
                            })];
                        case 1:
                            json = _a.sent();
                            info = json.data.list;
                            songs = parser_1.makeSongs(info);
                            return [2 /*return*/, songs];
                    }
                });
            });
        };
        /**
         * Get albums of an artist, the artistId must be number string
         */
        KuwoMusicApi.prototype.artistAlbums = function (artistId, page, size) {
            if (page === void 0) { page = 1; }
            if (size === void 0) { size = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var json, info, albums;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(KuwoMusicApi.NODE_MAP.artistAlbums, {
                                artistid: artistId,
                                pn: page,
                                rn: size,
                            })];
                        case 1:
                            json = _a.sent();
                            info = json.data.albumList;
                            albums = parser_1.makeAlbums(info);
                            return [2 /*return*/, albums];
                    }
                });
            });
        };
        /**
         * Get a collection, the collectionId must be number string
         */
        KuwoMusicApi.prototype.collection = function (collectionId, page, size) {
            if (page === void 0) { page = 1; }
            if (size === void 0) { size = 100; }
            return __awaiter(this, void 0, void 0, function () {
                var json, info, collection;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(KuwoMusicApi.NODE_MAP.collection, {
                                pid: collectionId,
                                pn: page,
                                rn: size,
                            })];
                        case 1:
                            json = _a.sent();
                            info = json && json.data;
                            collection = parser_1.makeCollection(info);
                            return [2 /*return*/, collection];
                    }
                });
            });
        };
        /**
         * Search Songs
         */
        KuwoMusicApi.prototype.searchSongs = function (keyword, page, size) {
            if (page === void 0) { page = 1; }
            if (size === void 0) { size = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var json, info, songs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(KuwoMusicApi.NODE_MAP.searchSongs, {
                                key: keyword.replace(/\s+/g, '+'),
                                pn: page,
                                rn: size,
                            })];
                        case 1:
                            json = _a.sent();
                            info = json && json.data && json.data.list;
                            songs = parser_1.makeSongs(info);
                            return [2 /*return*/, songs];
                    }
                });
            });
        };
        /**
         * Search albums
         */
        KuwoMusicApi.prototype.searchAlbums = function (keyword, page, size) {
            if (page === void 0) { page = 1; }
            if (size === void 0) { size = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var json, info, albums;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(KuwoMusicApi.NODE_MAP.searchAlbums, {
                                key: keyword.replace(/\s+/g, '+'),
                                pn: page,
                                rn: size,
                            })];
                        case 1:
                            json = _a.sent();
                            info = json && json.data && json.data.albumList;
                            albums = parser_1.makeAlbums(info);
                            return [2 /*return*/, albums];
                    }
                });
            });
        };
        KuwoMusicApi.prototype.searchArtists = function (keyword, page, size) {
            if (page === void 0) { page = 1; }
            if (size === void 0) { size = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var json, info, artists;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(KuwoMusicApi.NODE_MAP.searchArtists, {
                                key: keyword.replace(/\s+/g, '+'),
                                pn: page,
                                rn: size,
                            })];
                        case 1:
                            json = _a.sent();
                            info = json && json.data && json.data.artistList;
                            artists = parser_1.makeArtists(info);
                            return [2 /*return*/, artists];
                    }
                });
            });
        };
        KuwoMusicApi.prototype.searchCollections = function (keyword, page, size) {
            if (page === void 0) { page = 1; }
            if (size === void 0) { size = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var json, info, collections;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(KuwoMusicApi.NODE_MAP.searchCollections, {
                                key: keyword.replace(/\s+/g, '+'),
                                pn: page,
                                rn: size,
                            })];
                        case 1:
                            json = _a.sent();
                            info = json && json.data && json.data.list;
                            collections = parser_1.makeCollections(info);
                            return [2 /*return*/, collections];
                    }
                });
            });
        };
        /**
         * Record played song
         */
        KuwoMusicApi.prototype.playLog = function (songId, seek) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, false];
                });
            });
        };
        KuwoMusicApi.prototype.resizeImageUrl = function (url, size) {
            return size_1.resizeImageUrl(url, size, function (url, size) {
                if (url.match('/userp')) {
                    if (size <= 150) {
                        size = 150;
                    }
                    else if (size > 150 && size <= 300) {
                        size = 300;
                    }
                    else if (size > 300 && size <= 500) {
                        size = 500;
                    }
                    else if (size > 500) {
                        size = 700;
                    }
                    url = url.replace(/_\d{3}\.jpg/, '.jpg')
                        .replace('.jpg', size.toString());
                }
                else {
                    if (size <= 120) {
                        size = 120;
                    }
                    else if (size > 120 && size <= 300) {
                        size = 300;
                    }
                    else if (size > 300) {
                        size = 500;
                    }
                    url = url.replace(/starheads\/\d{3}/, 'starheads/' + size.toString())
                        .replace(/albumcover\/\d{3}/, 'albumcover/' + size.toString());
                }
                return url;
            });
        };
        KuwoMusicApi.prototype.fromURL = function (input) {
            return __awaiter(this, void 0, void 0, function () {
                var chunks, items, chunks_1, chunks_1_1, chunk, originId, type, matchList, matchList_1, matchList_1_1, _a, re, tp, m, item, _b, e_2_1;
                var e_2, _c, e_3, _d;
                return __generator(this, function (_e) {
                    switch (_e.label) {
                        case 0:
                            chunks = input.split(' ');
                            items = [];
                            _e.label = 1;
                        case 1:
                            _e.trys.push([1, 14, 15, 16]);
                            chunks_1 = __values(chunks), chunks_1_1 = chunks_1.next();
                            _e.label = 2;
                        case 2:
                            if (!!chunks_1_1.done) return [3 /*break*/, 13];
                            chunk = chunks_1_1.value;
                            originId = void 0;
                            type = void 0;
                            matchList = [
                                // song
                                [/play_detail\/(\d+)/, 'song'],
                                // artist
                                [/singer_detail\/(\d+)/, 'artist'],
                                // album
                                [/album_detail\/(\d+)/, 'album'],
                                // collection
                                [/playlist_detail\/(\d+)/, 'collect'],
                            ];
                            try {
                                for (matchList_1 = (e_3 = void 0, __values(matchList)), matchList_1_1 = matchList_1.next(); !matchList_1_1.done; matchList_1_1 = matchList_1.next()) {
                                    _a = __read(matchList_1_1.value, 2), re = _a[0], tp = _a[1];
                                    m = re.exec(chunk);
                                    if (m) {
                                        originId = m[1];
                                        type = tp;
                                        break;
                                    }
                                }
                            }
                            catch (e_3_1) { e_3 = { error: e_3_1 }; }
                            finally {
                                try {
                                    if (matchList_1_1 && !matchList_1_1.done && (_d = matchList_1.return)) _d.call(matchList_1);
                                }
                                finally { if (e_3) throw e_3.error; }
                            }
                            if (!originId) return [3 /*break*/, 12];
                            item = void 0;
                            _b = type;
                            switch (_b) {
                                case 'song': return [3 /*break*/, 3];
                                case 'artist': return [3 /*break*/, 5];
                                case 'album': return [3 /*break*/, 7];
                                case 'collect': return [3 /*break*/, 9];
                            }
                            return [3 /*break*/, 11];
                        case 3: return [4 /*yield*/, this.song(originId)];
                        case 4:
                            item = _e.sent();
                            items.push(item);
                            return [3 /*break*/, 12];
                        case 5: return [4 /*yield*/, this.artist(originId)];
                        case 6:
                            item = _e.sent();
                            items.push(item);
                            return [3 /*break*/, 12];
                        case 7: return [4 /*yield*/, this.album(originId)];
                        case 8:
                            item = _e.sent();
                            items.push(item);
                            return [3 /*break*/, 12];
                        case 9: return [4 /*yield*/, this.collection(originId)];
                        case 10:
                            item = _e.sent();
                            items.push(item);
                            return [3 /*break*/, 12];
                        case 11: return [3 /*break*/, 12];
                        case 12:
                            chunks_1_1 = chunks_1.next();
                            return [3 /*break*/, 2];
                        case 13: return [3 /*break*/, 16];
                        case 14:
                            e_2_1 = _e.sent();
                            e_2 = { error: e_2_1 };
                            return [3 /*break*/, 16];
                        case 15:
                            try {
                                if (chunks_1_1 && !chunks_1_1.done && (_c = chunks_1.return)) _c.call(chunks_1);
                            }
                            finally { if (e_2) throw e_2.error; }
                            return [7 /*endfinally*/];
                        case 16: return [2 /*return*/, items];
                    }
                });
            });
        };
        KuwoMusicApi.HEADERS = {
            'Pragma': 'no-cache',
            'Accept-Encoding': 'gzip, deflate',
            'Accept-Language': 'zh-CN,zh;q=0.9,en;q=0.8,zh-TW;q=0.7',
            'User-Agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36',
            'Accept': '*/*',
            // Referer is needed
            // 'Referer': 'http://h.kuwo.com/collect_detail.html?id=422425970&f=&from=&ch=',
            'Connection': 'keep-alive',
            'Cache-Control': 'no-cache',
        };
        KuwoMusicApi.BASICURL = 'http://www.kuwo.cn/';
        KuwoMusicApi.BASICURL_FLAC = 'http://mobi.kuwo.cn/';
        KuwoMusicApi.NODE_MAP = {
            audios: 'url',
            audios_flac: 'mobi.s',
            // No use this song node, it does not give audio url
            song: 'api/www/music/musicInfo',
            lyric: 'newh5/singles/songinfoandlrc',
            album: 'api/www/album/albumInfo',
            artist: 'api/www/artist/artist',
            artistSongs: 'api/www/artist/artistMusic',
            artistAlbums: 'api/www/artist/artistAlbum',
            collection: 'api/www/playlist/playListInfo',
            searchSongs: 'api/www/search/searchMusicBykeyWord',
            searchAlbums: 'api/www/search/searchAlbumBykeyWord',
            searchArtists: 'api/www/search/searchArtistBykeyWord',
            searchCollections: 'api/www/search/searchPlayListBykeyWord',
        };
        return KuwoMusicApi;
    }());
    exports.KuwoMusicApi = KuwoMusicApi;
});
