var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
define(["require", "exports", "assert", "process", "mocha", "chord/music/kuwo/api"], function (require, exports, assert, process, mocha_1, api_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    var api = new api_1.KuwoMusicApi();
    var IN_CI = process.env.IN_CI;
    mocha_1.suite('music/kuwo/api', function () {
        /**
         * Net requests have some probability to be fail,
         * so we test these requests at local, missing at CI
        */
        if (IN_CI)
            return;
        mocha_1.test('audios', function () {
            return __awaiter(this, void 0, void 0, function () {
                var item;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, api.audios('7149583')];
                        case 1:
                            item = _a.sent();
                            assert.equal(item.length > 0, true);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('song', function () {
            return __awaiter(this, void 0, void 0, function () {
                var id, item;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            id = '7149583';
                            return [4 /*yield*/, api.song(id)];
                        case 1:
                            item = _a.sent();
                            assert.equal(item.songOriginalId, id);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('lyric', function () {
            return __awaiter(this, void 0, void 0, function () {
                var id, item;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            id = '60478382';
                            return [4 /*yield*/, api.lyric(id)];
                        case 1:
                            item = _a.sent();
                            assert.equal(item.songId.split('|')[2], id);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('album', function () {
            return __awaiter(this, void 0, void 0, function () {
                var id, item;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            id = '10764969';
                            return [4 /*yield*/, api.album(id)];
                        case 1:
                            item = _a.sent();
                            assert.equal(item.albumOriginalId, id);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('artist', function () {
            return __awaiter(this, void 0, void 0, function () {
                var id, item;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            id = '12033';
                            return [4 /*yield*/, api.artist(id)];
                        case 1:
                            item = _a.sent();
                            assert.equal(item.artistOriginalId, id);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('artistSongs', function () {
            return __awaiter(this, void 0, void 0, function () {
                var id, item;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            id = '12033';
                            return [4 /*yield*/, api.artistSongs(id)];
                        case 1:
                            item = _a.sent();
                            assert.equal(item.length > 0, true);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('artistAlbums', function () {
            return __awaiter(this, void 0, void 0, function () {
                var id, item;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            id = '12033';
                            return [4 /*yield*/, api.artistAlbums(id)];
                        case 1:
                            item = _a.sent();
                            assert.equal(item.length > 0, true);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('collection', function () {
            return __awaiter(this, void 0, void 0, function () {
                var id, item;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            id = '2433924200';
                            return [4 /*yield*/, api.collection(id)];
                        case 1:
                            item = _a.sent();
                            assert.equal(item.collectionOriginalId, id);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('searchSongs', function () {
            return __awaiter(this, void 0, void 0, function () {
                var item;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, api.searchSongs('linkin')];
                        case 1:
                            item = _a.sent();
                            assert.equal(item.length > 0, true);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('searchAlbums', function () {
            return __awaiter(this, void 0, void 0, function () {
                var item;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, api.searchAlbums('linkin')];
                        case 1:
                            item = _a.sent();
                            assert.equal(item.length > 0, true);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('searchArtists', function () {
            return __awaiter(this, void 0, void 0, function () {
                var item;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, api.searchArtists('linkin')];
                        case 1:
                            item = _a.sent();
                            assert.equal(item.length > 0, true);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('searchCollections', function () {
            return __awaiter(this, void 0, void 0, function () {
                var item;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, api.searchCollections('linkin')];
                        case 1:
                            item = _a.sent();
                            assert.equal(item.length > 0, true);
                            return [2 /*return*/];
                    }
                });
            });
        });
    });
});
