var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
define(["require", "exports", "chord/platform/log/common/log", "chord/platform/utils/common/paths", "chord/base/common/time", "chord/base/common/assert", "chord/base/node/url", "chord/music/common/size", "chord/base/node/cookies", "chord/base/node/_request", "chord/music/migu/crypto", "chord/music/migu/parser"], function (require, exports, log_1, paths_1, time_1, assert_1, url_1, size_1, cookies_1, _request_1, crypto_1, parser_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.MiguMusicApi = void 0;
    var loggerWarning = new log_1.Logger(paths_1.filenameToNodeName(__filename), log_1.LogLevel.Warning);
    var MiguMusicApi = /** @class */ (function () {
        function MiguMusicApi() {
            if (!this.cookieJar) {
                var cookieJar = cookies_1.makeCookieJar();
                // initiateCookies().forEach(cookie => {
                //     let domain = cookie.domain;
                //     cookieJar.setCookie(cookie, domain.startsWith('http') ? domain : 'http://' + domain);
                // });
                this.cookieJar = cookieJar;
            }
        }
        MiguMusicApi.prototype.request = function (node, params, to_enc, domain, to_json) {
            if (to_enc === void 0) { to_enc = false; }
            if (to_json === void 0) { to_json = true; }
            return __awaiter(this, void 0, void 0, function () {
                var url, headers, _a, secKey, encBuf, options, result, is_ok, message;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            url = (domain || MiguMusicApi.BASICURL) + node;
                            switch (domain) {
                                case MiguMusicApi.BASICURL_H5:
                                    headers = MiguMusicApi.HEADERS_h5;
                                    break;
                                case MiguMusicApi.BASICURL:
                                    headers = MiguMusicApi.HEADERS_WEB;
                                    break;
                                default:
                                    headers = MiguMusicApi.HEADERS_WEB;
                            }
                            if (node == MiguMusicApi.NODE_MAP.audio) {
                                headers = MiguMusicApi.HEADERS_AUDIO;
                            }
                            if (to_enc) {
                                _a = crypto_1.encrypt(JSON.stringify(params)), secKey = _a.secKey, encBuf = _a.encBuf;
                                params = {
                                    dataType: 2,
                                    data: encBuf,
                                    secKey: secKey,
                                };
                            }
                            if (params) {
                                url = url + '?' + url_1.querystringify(params);
                            }
                            options = {
                                method: 'GET',
                                url: url,
                                jar: this.cookieJar || null,
                                headers: headers,
                                gzip: true,
                                json: to_json,
                                resolveWithFullResponse: false,
                            };
                            return [4 /*yield*/, _request_1.request(options)];
                        case 1:
                            result = _b.sent();
                            assert_1.ok(result, "[ERROR] [MiguMusicApi.request]: url: " + url + ", result is " + result);
                            is_ok = true;
                            if (to_json) {
                                is_ok = ((result['returnCode'] || result['code']) == '000000') || !!result['data'] || !!result['result'] || !!result['success'];
                            }
                            if (!is_ok) {
                                loggerWarning.warning("[ERROR] [MiguMusicApi.request]: url: " + url + ", result is " + JSON.stringify(result));
                                message = result['msg'];
                                throw new Error(message);
                            }
                            return [2 /*return*/, result];
                    }
                });
            });
        };
        // flac: type = 3
        // 320kbps: type = 2
        // 40kbps: type = 1
        MiguMusicApi.prototype.audios = function (songId, supKbps) {
            return __awaiter(this, void 0, void 0, function () {
                var audios, tp, node, params, json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            audios = [];
                            _a.label = 1;
                        case 1:
                            if (!true) return [3 /*break*/, 3];
                            tp = 2;
                            if (supKbps > 320) {
                                tp = 3;
                            }
                            node = MiguMusicApi.NODE_MAP.audio;
                            params = {
                                copyrightId: songId,
                                auditionsFlag: 0,
                                type: tp,
                            };
                            return [4 /*yield*/, this.request(node, params, true)];
                        case 2:
                            json = _a.sent();
                            audios = parser_1.makeAudios(json['data']);
                            // if the audio is not flac, changing to 320kbps
                            if (audios.length > 0 && tp == 3) {
                                if (audios[0].kbps < 320) {
                                    supKbps = 320;
                                    return [3 /*break*/, 1];
                                }
                            }
                            return [3 /*break*/, 3];
                        case 3: return [2 /*return*/, audios];
                    }
                });
            });
        };
        // WARN: songId is a copyrightId of migu music
        MiguMusicApi.prototype.song = function (songId) {
            return __awaiter(this, void 0, void 0, function () {
                var node, params, json, song, song_;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            node = MiguMusicApi.NODE_MAP.song_h5;
                            params = {
                                cpid: songId,
                            };
                            return [4 /*yield*/, this.request(node, params, false, MiguMusicApi.BASICURL_H5)];
                        case 1:
                            json = _a.sent();
                            song = parser_1.makeSong(json.data);
                            // Get album info
                            node = MiguMusicApi.NODE_MAP.song;
                            params = {
                                type: 1,
                                copyrightId: songId,
                            };
                            return [4 /*yield*/, this.request(node, params)];
                        case 2:
                            json = _a.sent();
                            song_ = parser_1.makeSong(json.items && json.items[0]);
                            song.duration = song_.duration;
                            song.albumId = song_.albumId;
                            song.albumOriginalId = song_.albumOriginalId;
                            song.albumName = song_.albumName;
                            song.artistId = song_.artistId;
                            song.artistOriginalId = song_.artistOriginalId;
                            song.artistName = song_.artistName;
                            return [2 /*return*/, song];
                    }
                });
            });
        };
        MiguMusicApi.prototype.songs = function (songIds) {
            return __awaiter(this, void 0, void 0, function () {
                var node, params, json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            node = MiguMusicApi.NODE_MAP.song;
                            params = {
                                type: 1,
                                copyrightId: songIds.join(','),
                            };
                            return [4 /*yield*/, this.request(node, params)];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, parser_1.makeSongs(json.items)];
                    }
                });
            });
        };
        MiguMusicApi.prototype.lyric = function (songId) {
            return __awaiter(this, void 0, void 0, function () {
                var node, params, json, lyricInfo, transInfo;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            node = MiguMusicApi.NODE_MAP.song_h5;
                            params = {
                                cpid: songId,
                            };
                            return [4 /*yield*/, this.request(node, params, false, MiguMusicApi.BASICURL_H5)];
                        case 1:
                            json = _a.sent();
                            lyricInfo = json.data.lyricLrc;
                            transInfo = null;
                            return [2 /*return*/, parser_1.makeLyric(songId, lyricInfo, transInfo)];
                    }
                });
            });
        };
        MiguMusicApi.prototype.album = function (albumId) {
            return __awaiter(this, void 0, void 0, function () {
                var node, params, json, album, songs, song;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            node = MiguMusicApi.NODE_MAP.album;
                            params = {
                                albumId: albumId,
                            };
                            return [4 /*yield*/, this.request(node, params, false, MiguMusicApi.BASICURL_H5)];
                        case 1:
                            json = _a.sent();
                            album = parser_1.makeAlbum(json.data);
                            node = MiguMusicApi.NODE_MAP.albumSongs;
                            params = {
                                albumId: albumId,
                                type: 2,
                            };
                            return [4 /*yield*/, this.request(node, params, false)];
                        case 2:
                            json = _a.sent();
                            songs = parser_1.makeSongs(json.items).map(function (song) {
                                song.albumCoverUrl = album.albumCoverUrl;
                                return song;
                            });
                            if (songs.length > 0) {
                                song = songs[0];
                                album.artistOriginalId = song.artistOriginalId;
                                album.artistId = song.artistId;
                                album.artistName = song.artistName;
                            }
                            album.songs = songs;
                            return [2 /*return*/, album];
                    }
                });
            });
        };
        MiguMusicApi.prototype.artist = function (artistId) {
            return __awaiter(this, void 0, void 0, function () {
                var node, params, json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            node = MiguMusicApi.NODE_MAP.artist;
                            params = {
                                artistId: artistId,
                            };
                            return [4 /*yield*/, this.request(node, params, false, MiguMusicApi.BASICURL_H5)];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, parser_1.makeArtist(json.data)];
                    }
                });
            });
        };
        /**
         * There gets an artist's top 50 songs
         * It can't be more
         */
        MiguMusicApi.prototype.artistSongs = function (artistId, page, size) {
            if (page === void 0) { page = 1; }
            if (size === void 0) { size = 20; }
            return __awaiter(this, void 0, void 0, function () {
                var node, params, html, songIds;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            node = MiguMusicApi.NODE_MAP.artistSongs + '/' + artistId + '/song';
                            params = {
                                page: page,
                            };
                            return [4 /*yield*/, this.request(node, params, false, MiguMusicApi.BASICURL, false)];
                        case 1:
                            html = _a.sent();
                            songIds = parser_1.extractArtistSongIds(html);
                            return [2 /*return*/, this.songs(songIds)];
                    }
                });
            });
        };
        MiguMusicApi.prototype.artistAlbums = function (artistId, page, size) {
            if (page === void 0) { page = 1; }
            if (size === void 0) { size = 30; }
            return __awaiter(this, void 0, void 0, function () {
                var node, params, html;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            node = MiguMusicApi.NODE_MAP.artistAlbums + '/' + artistId + '/album';
                            params = {
                                page: page,
                            };
                            return [4 /*yield*/, this.request(node, params, false, MiguMusicApi.BASICURL, false)];
                        case 1:
                            html = _a.sent();
                            return [2 /*return*/, parser_1.makeArtistAlbums(html)];
                    }
                });
            });
        };
        MiguMusicApi.prototype.collection = function (collectionId, size) {
            if (size === void 0) { size = 10000; }
            return __awaiter(this, void 0, void 0, function () {
                var node, params, json, collection, pages, songs, _a, _b, page, node_1, params_1, html, e_1, songIds, songs_, e_2, e_3_1;
                var e_3, _c;
                return __generator(this, function (_d) {
                    switch (_d.label) {
                        case 0:
                            node = MiguMusicApi.NODE_MAP.collection;
                            params = {
                                onLine: 1,
                                queryChannel: 0,
                                createUserId: '221acca8-9179-4ba7-ac3f-2b0fdffed356',
                                contentCountMin: 5,
                                playListId: collectionId,
                            };
                            return [4 /*yield*/, this.request(node, params, false, MiguMusicApi.BASICURL_H5)];
                        case 1:
                            json = _d.sent();
                            collection = parser_1.makeCollection(json.playlist[0]);
                            pages = Math.ceil(collection.songCount / 20);
                            songs = [];
                            _d.label = 2;
                        case 2:
                            _d.trys.push([2, 17, 18, 19]);
                            _a = __values(__spread(Array(pages).keys())), _b = _a.next();
                            _d.label = 3;
                        case 3:
                            if (!!_b.done) return [3 /*break*/, 16];
                            page = _b.value;
                            _d.label = 4;
                        case 4:
                            if (!true) return [3 /*break*/, 15];
                            node_1 = MiguMusicApi.NODE_MAP.collectionSongs + '/' + collectionId;
                            params_1 = {
                                page: page + 1,
                            };
                            html = void 0;
                            _d.label = 5;
                        case 5:
                            _d.trys.push([5, 7, , 9]);
                            return [4 /*yield*/, this.request(node_1, params_1, false, MiguMusicApi.BASICURL, false)];
                        case 6:
                            html = _d.sent();
                            return [3 /*break*/, 9];
                        case 7:
                            e_1 = _d.sent();
                            return [4 /*yield*/, time_1.sleep(1)];
                        case 8:
                            _d.sent();
                            return [3 /*break*/, 4];
                        case 9:
                            songIds = parser_1.extractCollectionSongIds(html);
                            songs_ = void 0;
                            _d.label = 10;
                        case 10:
                            _d.trys.push([10, 12, , 14]);
                            return [4 /*yield*/, this.songs(songIds)];
                        case 11:
                            songs_ = _d.sent();
                            return [3 /*break*/, 14];
                        case 12:
                            e_2 = _d.sent();
                            return [4 /*yield*/, time_1.sleep(1)];
                        case 13:
                            _d.sent();
                            return [3 /*break*/, 4];
                        case 14:
                            songs = __spread(songs, songs_);
                            return [3 /*break*/, 15];
                        case 15:
                            _b = _a.next();
                            return [3 /*break*/, 3];
                        case 16: return [3 /*break*/, 19];
                        case 17:
                            e_3_1 = _d.sent();
                            e_3 = { error: e_3_1 };
                            return [3 /*break*/, 19];
                        case 18:
                            try {
                                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                            }
                            finally { if (e_3) throw e_3.error; }
                            return [7 /*endfinally*/];
                        case 19:
                            ;
                            collection.songs = songs;
                            return [2 /*return*/, collection];
                    }
                });
            });
        };
        /**
         * Search
         *
         * data params:
         * @type:
         * 2: song
         * 1: artist
         * 4: album
         * 5: mv
         * 6: collection
         */
        MiguMusicApi.prototype.search = function (type, keyword, page, size) {
            if (page === void 0) { page = 1; }
            if (size === void 0) { size = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var node, params, json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            node = MiguMusicApi.NODE_MAP.search;
                            params = {
                                rows: size,
                                type: type,
                                keyword: keyword,
                                pgc: page,
                            };
                            return [4 /*yield*/, this.request(node, params, false, MiguMusicApi.BASICURL_H5)];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, json];
                    }
                });
            });
        };
        /**
         * Search songs
         *
         * type = 2
         */
        MiguMusicApi.prototype.searchSongs = function (keyword, page, size) {
            if (page === void 0) { page = 1; }
            if (size === void 0) { size = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.search(2, keyword, page, size)];
                        case 1:
                            json = _a.sent();
                            if (!json['musics']) {
                                return [2 /*return*/, []];
                            }
                            return [2 /*return*/, parser_1.makeSongs(json['musics'] || [])];
                    }
                });
            });
        };
        /**
         * Search albums
         * type = 4
         */
        MiguMusicApi.prototype.searchAlbums = function (keyword, page, size) {
            if (page === void 0) { page = 1; }
            if (size === void 0) { size = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.search(4, keyword, page, size)];
                        case 1:
                            json = _a.sent();
                            if (!json['albums']) {
                                return [2 /*return*/, []];
                            }
                            return [2 /*return*/, parser_1.makeAlbums(json['albums'] || [])];
                    }
                });
            });
        };
        /**
         * Search artists
         *
         * type = 1
         */
        MiguMusicApi.prototype.searchArtists = function (keyword, page, size) {
            if (page === void 0) { page = 1; }
            if (size === void 0) { size = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.search(1, keyword, page, size)];
                        case 1:
                            json = _a.sent();
                            if (!json['artists']) {
                                return [2 /*return*/, []];
                            }
                            return [2 /*return*/, parser_1.makeArtists(json['artists'] || [])];
                    }
                });
            });
        };
        /**
         * Search collections
         * type = 6
         */
        MiguMusicApi.prototype.searchCollections = function (keyword, page, size) {
            if (page === void 0) { page = 1; }
            if (size === void 0) { size = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.search(6, keyword, page, size)];
                        case 1:
                            json = _a.sent();
                            if (!json['songLists']) {
                                return [2 /*return*/, []];
                            }
                            return [2 /*return*/, parser_1.makeCollections(json['songLists'] || [])];
                    }
                });
            });
        };
        MiguMusicApi.prototype.playLog = function (songId, seek) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, false];
                });
            });
        };
        MiguMusicApi.prototype.resizeImageUrl = function (url, size) {
            return size_1.resizeImageUrl(url, size, function (url, size) { return url + "?" + size + "x" + size; });
        };
        MiguMusicApi.prototype.fromURL = function (input) {
            return __awaiter(this, void 0, void 0, function () {
                var chunks, items, chunks_1, chunks_1_1, chunk, m, originId, type, matchList, matchList_1, matchList_1_1, _a, re, tp, item, _b, e_4_1;
                var e_4, _c, e_5, _d;
                return __generator(this, function (_e) {
                    switch (_e.label) {
                        case 0:
                            chunks = input.split(' ');
                            items = [];
                            _e.label = 1;
                        case 1:
                            _e.trys.push([1, 14, 15, 16]);
                            chunks_1 = __values(chunks), chunks_1_1 = chunks_1.next();
                            _e.label = 2;
                        case 2:
                            if (!!chunks_1_1.done) return [3 /*break*/, 13];
                            chunk = chunks_1_1.value;
                            m = void 0;
                            originId = void 0;
                            type = void 0;
                            matchList = [
                                // song
                                [/song\/([\da-zA-Z]+)/, 'song'],
                                // artist
                                [/artist\/(\d+)/, 'artist'],
                                // album
                                [/album\/(\d+)/, 'album'],
                                // playlist
                                [/playlist\/(\d+)/, 'collection'],
                            ];
                            try {
                                for (matchList_1 = (e_5 = void 0, __values(matchList)), matchList_1_1 = matchList_1.next(); !matchList_1_1.done; matchList_1_1 = matchList_1.next()) {
                                    _a = __read(matchList_1_1.value, 2), re = _a[0], tp = _a[1];
                                    m = re.exec(chunk);
                                    if (m) {
                                        originId = m[1];
                                        type = tp;
                                        break;
                                    }
                                }
                            }
                            catch (e_5_1) { e_5 = { error: e_5_1 }; }
                            finally {
                                try {
                                    if (matchList_1_1 && !matchList_1_1.done && (_d = matchList_1.return)) _d.call(matchList_1);
                                }
                                finally { if (e_5) throw e_5.error; }
                            }
                            if (!originId) return [3 /*break*/, 12];
                            item = void 0;
                            _b = type;
                            switch (_b) {
                                case 'song': return [3 /*break*/, 3];
                                case 'artist': return [3 /*break*/, 5];
                                case 'album': return [3 /*break*/, 7];
                                case 'collection': return [3 /*break*/, 9];
                            }
                            return [3 /*break*/, 11];
                        case 3: return [4 /*yield*/, this.song(originId)];
                        case 4:
                            item = _e.sent();
                            items.push(item);
                            return [3 /*break*/, 12];
                        case 5: return [4 /*yield*/, this.artist(originId)];
                        case 6:
                            item = _e.sent();
                            items.push(item);
                            return [3 /*break*/, 12];
                        case 7: return [4 /*yield*/, this.album(originId)];
                        case 8:
                            item = _e.sent();
                            items.push(item);
                            return [3 /*break*/, 12];
                        case 9: return [4 /*yield*/, this.collection(originId)];
                        case 10:
                            item = _e.sent();
                            items.push(item);
                            return [3 /*break*/, 12];
                        case 11: return [3 /*break*/, 12];
                        case 12:
                            chunks_1_1 = chunks_1.next();
                            return [3 /*break*/, 2];
                        case 13: return [3 /*break*/, 16];
                        case 14:
                            e_4_1 = _e.sent();
                            e_4 = { error: e_4_1 };
                            return [3 /*break*/, 16];
                        case 15:
                            try {
                                if (chunks_1_1 && !chunks_1_1.done && (_c = chunks_1.return)) _c.call(chunks_1);
                            }
                            finally { if (e_4) throw e_4.error; }
                            return [7 /*endfinally*/];
                        case 16: return [2 /*return*/, items];
                    }
                });
            });
        };
        MiguMusicApi.HEADERS_AUDIO = {
            'Connection': 'keep-alive',
            'Accept': '*/*',
            'X-Requested-With': 'XMLHttpRequest',
            'User-Agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/78.0.3904.97 Safari/537.36',
            'Referer': 'http://music.migu.cn/v3/music/player/audio',
            'Accept-Encoding': 'gzip, deflate',
            'Accept-Language': 'en-US,en;q=0.9,zh-CN;q=0.8,zh-TW;q=0.7,zh;q=0.6,ja;q=0.5',
        };
        MiguMusicApi.HEADERS_h5 = {
            'Connection': 'keep-alive',
            'Accept': 'application/json, text/javascript, */*; q=0.01',
            'X-Requested-With': 'XMLHttpRequest',
            'User-Agent': 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/78.0.3904.97 Mobile Safari/537.36',
            'Referer': 'http://m.music.migu.cn/v3',
            'Accept-Encoding': 'gzip, deflate',
            'Accept-Language': 'en-US,en;q=0.9,zh-CN;q=0.8,zh-TW;q=0.7,zh;q=0.6,ja;q=0.5',
            'Content-Type': 'application/json; charset=utf-8',
        };
        MiguMusicApi.HEADERS_WEB = {
            'Connection': 'keep-alive',
            'Accept': '*/*',
            'X-Requested-With': 'XMLHttpRequest',
            'User-Agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/78.0.3904.97 Safari/537.36',
            'Referer': 'http://music.migu.cn/v3/',
            'Accept-Encoding': 'gzip, deflate',
            'Accept-Language': 'en-US,en;q=0.9,zh-CN;q=0.8,zh-TW;q=0.7,zh;q=0.6,ja;q=0.5',
        };
        MiguMusicApi.BASICURL = 'http://music.migu.cn/';
        MiguMusicApi.BASICURL_H5 = 'http://m.music.migu.cn/';
        MiguMusicApi.NODE_MAP = {
            audio: 'v3/api/music/audioPlayer/getPlayInfo',
            song: 'v3/api/music/audioPlayer/songs',
            song_h5: 'migu/remoting/cms_detail_tag',
            album: 'migu/remoting/cms_album_detail_tag',
            albumSongs: 'v3/api/music/audioPlayer/songs',
            collection: 'migu/remoting/playlist_query_tag',
            collectionSongs: 'v3/music/playlist',
            artist: 'migu/remoting/cms_artist_detail_tag',
            artistSongs: 'v3/music/artist',
            artistAlbums: 'v3/music/artist',
            search: 'migu/remoting/scr_search_tag',
        };
        return MiguMusicApi;
    }());
    exports.MiguMusicApi = MiguMusicApi;
});
