var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
define(["require", "exports", "assert", "process", "mocha", "chord/music/netease/api", "chord/music/netease/crypto"], function (require, exports, assert, process, mocha_1, api_1, crypto_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    var neteaseApi = new api_1.NeteaseMusicApi();
    var IN_CI = process.env.IN_CI;
    mocha_1.suite('music/netease/NeteaseMusicApi', function () {
        /**
         * Net requests have some probability to be fail,
         * so we test these requests at local, missing at CI
        */
        if (IN_CI)
            return;
        mocha_1.test('toAES', function () {
            crypto_1.encrypt({ a: 1 });
        });
        mocha_1.test('audios', function () {
            return __awaiter(this, void 0, void 0, function () {
                var id, audios;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            id = '108795';
                            return [4 /*yield*/, neteaseApi.audios(id)];
                        case 1:
                            audios = _a.sent();
                            assert.equal(audios.length > 0, true);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('songsAudios', function () {
            return __awaiter(this, void 0, void 0, function () {
                var songsAudios;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, neteaseApi.songsAudios(['185868', '1309814820'])];
                        case 1:
                            songsAudios = _a.sent();
                            assert.equal(songsAudios.length, 2);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('song', function () {
            return __awaiter(this, void 0, void 0, function () {
                var id, song;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            id = '546769020';
                            return [4 /*yield*/, neteaseApi.song(id)];
                        case 1:
                            song = _a.sent();
                            assert.equal(song.songOriginalId, id);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('album', function () {
            return __awaiter(this, void 0, void 0, function () {
                var id, album;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            id = '18893';
                            return [4 /*yield*/, neteaseApi.album(id)];
                        case 1:
                            album = _a.sent();
                            assert.equal(album.albumOriginalId, id);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('artist', function () {
            return __awaiter(this, void 0, void 0, function () {
                var id, artist;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            id = '10563';
                            return [4 /*yield*/, neteaseApi.artist(id)];
                        case 1:
                            artist = _a.sent();
                            assert.equal(artist.artistOriginalId, id);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('artistAlbums', function () {
            return __awaiter(this, void 0, void 0, function () {
                var id, albums;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            id = '10563';
                            return [4 /*yield*/, neteaseApi.artistAlbums(id, 0, 1)];
                        case 1:
                            albums = _a.sent();
                            assert.equal(albums.length, 1);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('collection', function () {
            return __awaiter(this, void 0, void 0, function () {
                var id, collection;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            id = '2309425946';
                            return [4 /*yield*/, neteaseApi.collection(id)];
                        case 1:
                            collection = _a.sent();
                            assert.equal(collection.collectionOriginalId, id);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('searchSongs', function () {
            return __awaiter(this, void 0, void 0, function () {
                var keyword, songs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            keyword = 'linkin';
                            return [4 /*yield*/, neteaseApi.searchSongs(keyword, 0, 1)];
                        case 1:
                            songs = _a.sent();
                            assert.equal(songs.length, 1);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('searchAlbums', function () {
            return __awaiter(this, void 0, void 0, function () {
                var keyword, albums;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            keyword = 'linkin';
                            return [4 /*yield*/, neteaseApi.searchAlbums(keyword, 0, 1)];
                        case 1:
                            albums = _a.sent();
                            assert.equal(albums.length, 1);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('searchArtists', function () {
            return __awaiter(this, void 0, void 0, function () {
                var keyword, artists;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            keyword = 'linkin';
                            return [4 /*yield*/, neteaseApi.searchArtists(keyword, 0, 1)];
                        case 1:
                            artists = _a.sent();
                            assert.equal(artists.length, 1);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('searchCollections', function () {
            return __awaiter(this, void 0, void 0, function () {
                var keyword, collections;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            keyword = 'linkin';
                            return [4 /*yield*/, neteaseApi.searchCollections(keyword, 0, 1)];
                        case 1:
                            collections = _a.sent();
                            assert.equal(collections.length, 1);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('similarSongs', function () {
            return __awaiter(this, void 0, void 0, function () {
                var id, songs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            id = '298317';
                            return [4 /*yield*/, neteaseApi.similarSongs(id)];
                        case 1:
                            songs = _a.sent();
                            assert.equal(songs.length > 0, true);
                            return [2 /*return*/];
                    }
                });
            });
        });
        // test('similarArtists', async function() {
        // let id = '10563';
        // let artists = await neteaseApi.similarArtists(id);
        // });
        mocha_1.test('similarCollections', function () {
            return __awaiter(this, void 0, void 0, function () {
                var id, collections;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            id = '2394955929';
                            return [4 /*yield*/, neteaseApi.similarCollections(id)];
                        case 1:
                            collections = _a.sent();
                            assert.equal(collections.length > 0, true);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('songBelongsToCollections', function () {
            return __awaiter(this, void 0, void 0, function () {
                var id, collections;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            id = '546769020';
                            return [4 /*yield*/, neteaseApi.songBelongsToCollections(id)];
                        case 1:
                            collections = _a.sent();
                            assert.equal(collections.length > 0, true);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('collectionListOptions', function () {
            return __awaiter(this, void 0, void 0, function () {
                var options;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, neteaseApi.collectionListOptions()];
                        case 1:
                            options = _a.sent();
                            assert.equal(options.length > 0, true);
                            assert.equal(options[0].name, '全部歌单');
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('collectionListOptions', function () {
            return __awaiter(this, void 0, void 0, function () {
                var collections;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, neteaseApi.collectionList('全部', 'hot', 0, 1)];
                        case 1:
                            collections = _a.sent();
                            assert.equal(collections.length, 1);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('newSongs', function () {
            return __awaiter(this, void 0, void 0, function () {
                var songs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, neteaseApi.newSongs()];
                        case 1:
                            songs = _a.sent();
                            assert.equal(songs.length > 0, true);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('newAlbums', function () {
            return __awaiter(this, void 0, void 0, function () {
                var albums;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, neteaseApi.newAlbums()];
                        case 1:
                            albums = _a.sent();
                            assert.equal(albums.length > 0, true);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('newCollections', function () {
            return __awaiter(this, void 0, void 0, function () {
                var collections;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, neteaseApi.newCollections()];
                        case 1:
                            collections = _a.sent();
                            assert.equal(collections.length > 0, true);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('logined', function () {
            var ok = neteaseApi.logined();
            assert.equal(ok, false);
        });
        mocha_1.test('userProfile', function () {
            return __awaiter(this, void 0, void 0, function () {
                var id, userProfile;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            id = '103780233';
                            return [4 /*yield*/, neteaseApi.userProfile(id)];
                        case 1:
                            userProfile = _a.sent();
                            assert.equal(userProfile.userOriginalId, id);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('userFavoriteSongs', function () {
            return __awaiter(this, void 0, void 0, function () {
                var id, songs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            id = '103780233';
                            return [4 /*yield*/, neteaseApi.userFavoriteSongs(id, 0, 1)];
                        case 1:
                            songs = _a.sent();
                            assert.equal(songs.length, 1);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('userFavoriteArtists', function () {
            return __awaiter(this, void 0, void 0, function () {
                var id, artists;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            id = '103780233';
                            return [4 /*yield*/, neteaseApi.userFavoriteArtists(id, 0, 1)];
                        case 1:
                            artists = _a.sent();
                            assert.equal(artists.length, 0);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('userFavoriteCollections', function () {
            return __awaiter(this, void 0, void 0, function () {
                var id, collections;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            id = '103780233';
                            return [4 /*yield*/, neteaseApi.userFavoriteCollections(id, 0, 1)];
                        case 1:
                            collections = _a.sent();
                            assert.equal(collections.length, 2);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('userFollowers', function () {
            return __awaiter(this, void 0, void 0, function () {
                var id, followers;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            id = '103780233';
                            return [4 /*yield*/, neteaseApi.userFollowers(id, 0, 1)];
                        case 1:
                            followers = _a.sent();
                            assert.equal(followers.length, 1);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('userFollowings', function () {
            return __awaiter(this, void 0, void 0, function () {
                var id, followings;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            id = '103780233';
                            return [4 /*yield*/, neteaseApi.userFollowings(id, 0, 1)];
                        case 1:
                            followings = _a.sent();
                            assert.equal(followings.length, 1);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('recommendSongs', function () {
            return __awaiter(this, void 0, void 0, function () {
                var songs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, neteaseApi.recommendSongs(0, 1)];
                        case 1:
                            songs = _a.sent();
                            assert.equal(songs.length, 1);
                            return [2 /*return*/];
                    }
                });
            });
        });
        mocha_1.test('recommendCollections', function () {
            return __awaiter(this, void 0, void 0, function () {
                var collections;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, neteaseApi.recommendCollections(0, 1)];
                        case 1:
                            collections = _a.sent();
                            assert.equal(collections.length, 1);
                            return [2 /*return*/];
                    }
                });
            });
        });
    });
});
