var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
define(["require", "exports", "electron", "fs", "path", "chord/preference/common/chord", "chord/base/common/objects", "chord/base/common/assert", "chord/base/common/time", "chord/base/node/random", "chord/base/browser/htmlContent", "chord/base/node/crypto", "chord/music/common/origin", "chord/music/common/errors", "chord/music/common/size", "chord/base/node/cookies", "chord/base/node/url", "chord/base/node/_request", "chord/music/qq/parser", "chord/music/qq/util", "chord/music/qq/crypto", "chord/music/qq/parser", "chord/music/qq/common"], function (require, exports, electron_1, stdFs, stdPath, chord_1, objects_1, assert_1, time_1, random_1, htmlContent_1, crypto_1, origin_1, errors_1, size_1, cookies_1, url_1, _request_1, parser_1, util_1, crypto_2, parser_2, common_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.QQMusicApi = void 0;
    var ALBUM_OPTION_NAME_MAP = {
        area: '地区',
        genre: '流派',
        type: '类别',
        year: '年代',
        company: '唱片公司',
    };
    var QQMusicApi = /** @class */ (function () {
        function QQMusicApi() {
            this.cookies = {};
            this.ip_index = -1;
            this.ips = [];
            try {
                var cookiesForAudioPath = stdPath.join(chord_1.CHORD_DIR, 'cookies-for-audio.json');
                var cookiesForAudio = JSON.parse(stdFs.readFileSync(cookiesForAudioPath).toString());
                this.cookiesForAudio = cookiesForAudio[origin_1.ORIGIN.qq] || this.cookies;
            }
            catch (_a) {
                this.cookiesForAudio = this.cookies;
            }
        }
        QQMusicApi.prototype.getACSRFToken = function () {
            return this.account ? util_1.getACSRFToken(this.account.cookies) : null;
        };
        QQMusicApi.prototype.request = function (method, url, params, data, referer, cookies) {
            if (cookies === void 0) { cookies = {}; }
            return __awaiter(this, void 0, void 0, function () {
                var headers, jar, _a, _b, k, cookie, options, body;
                var e_1, _c;
                return __generator(this, function (_d) {
                    switch (_d.label) {
                        case 0:
                            if (params) {
                                url = url + '?' + url_1.querystringify(params);
                            }
                            referer = referer || 'https://y.qq.com';
                            headers = __assign(__assign({}, QQMusicApi.HEADERS), { referer: referer });
                            // Here, domains are different. Make a new CookieJar for a request.
                            if (objects_1.isEmptyObject(cookies)) {
                                cookies = this.cookies;
                            }
                            jar = cookies_1.makeCookieJar();
                            try {
                                for (_a = __values(Object.keys(cookies)), _b = _a.next(); !_b.done; _b = _a.next()) {
                                    k = _b.value;
                                    cookie = cookies_1.makeCookie(k, cookies[k]);
                                    jar.setCookie(cookie, url);
                                }
                            }
                            catch (e_1_1) { e_1 = { error: e_1_1 }; }
                            finally {
                                try {
                                    if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                                }
                                finally { if (e_1) throw e_1.error; }
                            }
                            options = {
                                method: method,
                                url: url,
                                jar: jar,
                                headers: headers,
                                body: data,
                                gzip: true,
                            };
                            return [4 /*yield*/, _request_1.request(options)];
                        case 1:
                            body = _d.sent();
                            return [2 /*return*/, body.trim().startsWith('<') || body == '' ? body : JSON.parse(body)];
                    }
                });
            });
        };
        QQMusicApi.prototype.makeguid = function () {
            // return '0';
            return Math.floor(Math.random() * 1000000000).toString();
        };
        // Deprecated. Do not use it
        // This api has been blocked.
        QQMusicApi.prototype.qqKey2 = function (guid, songMid, songMediaMid) {
            return __awaiter(this, void 0, void 0, function () {
                var params, url, json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            params = {
                                cid: '205361747',
                                guid: guid,
                                songmid: songMid,
                                filename: 'M500' + songMediaMid + '.mp3',
                                format: 'json',
                                '_': Date.now(),
                            };
                            url = QQMusicApi.NODE_MAP.qqKey;
                            return [4 /*yield*/, this.request('GET', url, params)];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, json['data']['items'][0]['vkey']];
                    }
                });
            });
        };
        // Deprecated. Do not use it
        QQMusicApi.prototype.qqKey = function (guid, songMid, songMediaMid) {
            return __awaiter(this, void 0, void 0, function () {
                var data, sign, params, url, json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            data = JSON.stringify({
                                'req': {
                                    'module': 'vkey.GetVkeyServer',
                                    'method': 'CgiGetVkey',
                                    'param': {
                                        guid: guid,
                                        'songmid': [songMid],
                                        'songtype': [0],
                                        'uin': '0',
                                        'loginflag': 1,
                                        'platform': '20'
                                    }
                                },
                                'comm': { 'uin': 0, 'format': 'json', 'ct': 24, 'cv': 0 }
                            });
                            sign = crypto_2.getSecuritySign(data);
                            params = {
                                g_tk: '5381',
                                sign: sign,
                                loginUin: '0',
                                hostUin: '0',
                                format: 'json',
                                inCharset: 'utf8',
                                outCharset: 'utf-8',
                                notice: '0',
                                platform: 'yqq.json',
                                needNewCode: '0',
                                data: data,
                            };
                            url = QQMusicApi.NODE_MAP.qqKey;
                            return [4 /*yield*/, this.request('GET', url, params)];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, json.req.data.midurlinfo[0].vkey];
                    }
                });
            });
        };
        /**
         * Uin is important for get audio url
         */
        QQMusicApi.prototype.getUinForAudio = function () {
            var uin = this.cookiesForAudio['uin'] || (this.account && this.account.user && this.account.user.userOriginalId);
            return uin || '';
        };
        // Deprecated
        QQMusicApi.prototype.getAudioServerIP = function () {
            this.ip_index = (this.ip_index + 1) % this.ips.length;
            return this.ips[this.ip_index];
        };
        // Deprecated
        QQMusicApi.prototype.getAudioURI = function () {
            var ip = this.getAudioServerIP();
            return 'http://' + ip + '/amobile.music.tc.qq.com/';
        };
        // Deprecated
        QQMusicApi.prototype.makeAudios = function (song, qqKey, guid) {
            if (!qqKey)
                return [];
            var uri = QQMusicApi.AUDIO_URI;
            return song.audios.filter(function (audio) { return !!parser_2.AUDIO_FORMAT_MAP["" + (audio.kbps || '') + audio.format]; })
                .map(function (audio) {
                audio.url = uri
                    + parser_2.AUDIO_FORMAT_MAP["" + (audio.kbps || '') + audio.format]
                    + song.songMediaMid + '.' + audio.format
                    + '?guid=' + guid
                    + '&vkey=' + qqKey
                    + '&uin=0'
                    + '&fromtag=66';
                return audio;
            });
        };
        // Deprecated
        /**
         * Get available qq music server ips
         */
        QQMusicApi.prototype.getIPs = function () {
            return __awaiter(this, void 0, void 0, function () {
                var url, cn, ips;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            url = 'https://raw.githubusercontent.com/PeterDing/chord-data/master/qq-ip-checker/qq-ips.txt';
                            return [4 /*yield*/, _request_1.htmlGet(url)];
                        case 1:
                            cn = _a.sent();
                            ips = cn.split('\n').map(function (ip) { return ip.trim() || null; }).filter(function (ip) { return ip; });
                            return [2 /*return*/, ips];
                    }
                });
            });
        };
        /**
         * Get audio url
         */
        QQMusicApi.prototype.getAudioUrl = function (songMid, songMediaMid, kbps, format) {
            return __awaiter(this, void 0, void 0, function () {
                var guid, uin, filename, data, sign, params, url, json, audioUri;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            guid = this.makeguid();
                            uin = this.getUinForAudio();
                            if (!(parser_2.AUDIO_FORMAT_MAP["" + (kbps || '') + format])) {
                                return [2 /*return*/, null];
                            }
                            filename = parser_2.AUDIO_FORMAT_MAP["" + (kbps || '') + format] + songMediaMid + '.' + format;
                            data = JSON.stringify({
                                'req_0': {
                                    'module': 'vkey.GetVkeyServer',
                                    'method': 'CgiGetVkey',
                                    'param': {
                                        'filename': [filename],
                                        guid: guid,
                                        'songmid': [songMid],
                                        'songtype': [0],
                                        uin: uin,
                                        'loginflag': 1,
                                        'platform': '20',
                                    }
                                },
                                'comm': {
                                    uin: uin,
                                    'format': 'json',
                                    'ct': 19,
                                    'cv': 0
                                }
                            });
                            sign = crypto_2.getSecuritySign(data);
                            params = {
                                sign: sign,
                                g_tk: 5381,
                                loginUin: '',
                                hostUin: 0,
                                format: 'json',
                                inCharset: 'utf8',
                                outCharset: 'utf-8¬ice=0',
                                platform: 'yqq.json',
                                needNewCode: 0,
                                data: data,
                            };
                            url = QQMusicApi.NODE_MAP.audio;
                            return [4 /*yield*/, this.request('GET', url, params, null, null, this.cookiesForAudio)];
                        case 1:
                            json = _a.sent();
                            audioUri = json.req_0.data.midurlinfo[0].purl;
                            if (audioUri) {
                                return [2 /*return*/, QQMusicApi.AUDIO_URI + audioUri];
                            }
                            else {
                                return [2 /*return*/, null];
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        QQMusicApi.prototype.audios = function (songId, supKbps) {
            return __awaiter(this, void 0, void 0, function () {
                var song, songMid, songMediaMid, audios, audios_1, audios_1_1, audio, kbps, format, audioUrl, e_2_1;
                var e_2, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0: return [4 /*yield*/, this.song(songId)];
                        case 1:
                            song = _b.sent();
                            songMid = song.songMid, songMediaMid = song.songMediaMid;
                            audios = song.audios;
                            _b.label = 2;
                        case 2:
                            _b.trys.push([2, 7, 8, 9]);
                            audios_1 = __values(audios), audios_1_1 = audios_1.next();
                            _b.label = 3;
                        case 3:
                            if (!!audios_1_1.done) return [3 /*break*/, 6];
                            audio = audios_1_1.value;
                            kbps = audio.kbps, format = audio.format;
                            if (!(audio.kbps <= supKbps)) return [3 /*break*/, 5];
                            return [4 /*yield*/, this.getAudioUrl(songMid, songMediaMid, kbps, format)];
                        case 4:
                            audioUrl = _b.sent();
                            if (audioUrl) {
                                audio.url = audioUrl;
                                return [3 /*break*/, 6];
                            }
                            _b.label = 5;
                        case 5:
                            audios_1_1 = audios_1.next();
                            return [3 /*break*/, 3];
                        case 6: return [3 /*break*/, 9];
                        case 7:
                            e_2_1 = _b.sent();
                            e_2 = { error: e_2_1 };
                            return [3 /*break*/, 9];
                        case 8:
                            try {
                                if (audios_1_1 && !audios_1_1.done && (_a = audios_1.return)) _a.call(audios_1);
                            }
                            finally { if (e_2) throw e_2.error; }
                            return [7 /*endfinally*/];
                        case 9: return [2 /*return*/, audios];
                    }
                });
            });
        };
        QQMusicApi.prototype.song = function (songId, songMid) {
            return __awaiter(this, void 0, void 0, function () {
                var data, url, json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            data = {
                                "comm": {
                                    "uin": 0,
                                    "format": "json",
                                    "inCharset": "utf-8",
                                    "outCharset": "utf-8",
                                    "notice": 0,
                                    "platform": "h5",
                                    "needNewCode": 1
                                },
                                "detail": {
                                    "module": "music.pf_song_detail_svr",
                                    "method": "get_song_detail",
                                    "param": {
                                        "song_id": songId ? parseInt(songId) : undefined,
                                        "song_mid": songMid || undefined,
                                    }
                                },
                            };
                            url = QQMusicApi.NODE_MAP.song;
                            return [4 /*yield*/, this.request('POST', url, null, JSON.stringify(data))];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, parser_1.makeSong(json['detail']['data'])];
                    }
                });
            });
        };
        QQMusicApi.prototype.lyric = function (songId, songMid) {
            return __awaiter(this, void 0, void 0, function () {
                var params, url, referer, json, lyricInfo, transInfo;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            params = {
                                '-': 'MusicJsonCallback_lrc',
                                pcachetime: Date.now(),
                                songmid: songMid,
                                g_tk: 5381,
                                loginUin: 0,
                                hostUin: 0,
                                format: 'json',
                                inCharset: 'utf8',
                                outCharset: 'utf-8',
                                notice: 0,
                                platform: 'yqq.json',
                                needNewCode: 0,
                            };
                            url = QQMusicApi.NODE_MAP.lyric;
                            referer = 'https://y.qq.com/portal/player.html';
                            return [4 /*yield*/, this.request('GET', url, params, null, referer)];
                        case 1:
                            json = _a.sent();
                            lyricInfo = htmlContent_1.decodeHtml(crypto_1.decodeBase64(json['lyric']));
                            transInfo = htmlContent_1.decodeHtml(crypto_1.decodeBase64(json['trans']));
                            return [2 /*return*/, parser_1.makeLyric(songId, lyricInfo, transInfo)];
                    }
                });
            });
        };
        QQMusicApi.prototype.album = function (albumId, albumMid) {
            return __awaiter(this, void 0, void 0, function () {
                var params, url, json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            params = {
                                albumid: albumId || undefined,
                                albummid: albumMid || undefined,
                                uin: '0',
                                format: 'json',
                                inCharset: 'utf-8',
                                outCharset: 'utf-8',
                                notice: '0',
                                platform: 'h5',
                                needNewCode: '1',
                                '_': Date.now(),
                            };
                            url = QQMusicApi.NODE_MAP.album;
                            return [4 /*yield*/, this.request('GET', url, params)];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, parser_1.makeAlbum(json['data'])];
                    }
                });
            });
        };
        QQMusicApi.prototype.artistLikeCount = function (artistMid) {
            return __awaiter(this, void 0, void 0, function () {
                var params, url, json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            params = {
                                loginUin: '0',
                                hostUin: '0',
                                format: 'json',
                                inCharset: 'utf8',
                                outCharset: 'utf-8',
                                notice: '0',
                                platform: 'yqq',
                                needNewCode: '0',
                                singermid: artistMid,
                                utf8: '1',
                            };
                            url = QQMusicApi.NODE_MAP.artistLikeCount;
                            return [4 /*yield*/, this.request('GET', url, params)];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, json.num];
                    }
                });
            });
        };
        QQMusicApi.prototype.artist = function (artistId, artistMid) {
            return __awaiter(this, void 0, void 0, function () {
                var params, url, json, artist, likeCount;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            params = {
                                singerid: artistId || undefined,
                                singermid: artistMid || undefined,
                                uin: '0',
                                format: 'json',
                                inCharset: 'utf-8',
                                outCharset: 'utf-8',
                                notice: '0',
                                platform: 'h5page',
                                needNewCode: '1',
                                order: 'listen',
                                from: 'h5',
                                num: 1,
                                begin: 0,
                                '_': Date.now(),
                            };
                            url = QQMusicApi.NODE_MAP.artist;
                            return [4 /*yield*/, this.request('GET', url, params)];
                        case 1:
                            json = _a.sent();
                            artist = parser_1.makeArtist(json['data']);
                            return [4 /*yield*/, this.artistLikeCount(artist.artistMid)];
                        case 2:
                            likeCount = _a.sent();
                            artist.likeCount = likeCount;
                            return [2 /*return*/, artist];
                    }
                });
            });
        };
        QQMusicApi.prototype.artistSongs = function (artistId, offset, limit) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var params, url, json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            params = {
                                singerid: artistId,
                                uin: '0',
                                format: 'json',
                                inCharset: 'utf-8',
                                outCharset: 'utf-8',
                                notice: '0',
                                platform: 'h5page',
                                needNewCode: '1',
                                order: 'listen',
                                from: 'h5',
                                num: limit,
                                begin: offset,
                                '_': Date.now(),
                            };
                            url = QQMusicApi.NODE_MAP.artistSongs;
                            return [4 /*yield*/, this.request('GET', url, params)];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, parser_1.makeSongs(json['data']['list'].map(function (info) { return info['musicData']; }))];
                    }
                });
            });
        };
        /**
         * WARN: `artistMid`
         */
        QQMusicApi.prototype.artistAlbums = function (artistMid, offset, limit) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var data, params, url, json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            data = JSON.stringify({
                                "singerAlbum": {
                                    "method": "get_singer_album",
                                    "param": {
                                        "singermid": artistMid,
                                        "order": "time",
                                        "begin": offset,
                                        "num": limit,
                                        "exstatus": 1
                                    },
                                    "module": "music.web_singer_info_svr"
                                }
                            });
                            params = {
                                loginUin: '0',
                                hostUin: '0',
                                format: 'json',
                                inCharset: 'utf8',
                                outCharset: 'utf-8',
                                notice: '0',
                                platform: 'yqq',
                                needNewCode: '0',
                                data: data,
                            };
                            url = QQMusicApi.NODE_MAP.artistAlbums;
                            return [4 /*yield*/, this.request('GET', url, params)];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, parser_1.makeAlbums(json['singerAlbum']['data']['list'])];
                    }
                });
            });
        };
        QQMusicApi.prototype.collectionAddons = function (collectionId) {
            return __awaiter(this, void 0, void 0, function () {
                var params, url, referer, json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            params = {
                                loginUin: '0',
                                hostUin: '0',
                                format: 'json',
                                inCharset: 'utf8',
                                outCharset: 'utf-8',
                                notice: '0',
                                platform: 'yqq',
                                needNewCode: '0',
                                cid: '322',
                                nocompress: '1',
                                disstid: collectionId,
                            };
                            url = QQMusicApi.NODE_MAP.collectionAddons;
                            referer = "https://y.qq.com/n/yqq/playlist/" + collectionId + ".html";
                            return [4 /*yield*/, this.request('GET', url, params, null, referer)];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, json];
                    }
                });
            });
        };
        QQMusicApi.prototype.collection = function (collectionId, offset, limit) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 1000; }
            return __awaiter(this, void 0, void 0, function () {
                var params, url, referer, json, collection, addons;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            params = {
                                uin: '0',
                                format: 'json',
                                inCharset: 'utf-8',
                                outCharset: 'utf-8',
                                notice: '0',
                                platform: 'h5',
                                needNewCode: '1',
                                new_format: '1',
                                pic: '500',
                                disstid: collectionId,
                                type: '1',
                                json: '1',
                                utf8: '1',
                                onlysong: '0',
                                picmid: '1',
                                nosign: '1',
                                song_begin: offset,
                                song_num: limit,
                                '_': Date.now(),
                            };
                            url = QQMusicApi.NODE_MAP.collection;
                            referer = 'https://y.qq.com/w/taoge.html?ADTAG=newyqq.taoge&id=' + collectionId;
                            return [4 /*yield*/, this.request('GET', url, params, null, referer)];
                        case 1:
                            json = _a.sent();
                            if (!json['cdlist'] || !json['cdlist'].length) {
                                return [2 /*return*/, parser_1.makeEmptyCollection(collectionId)];
                            }
                            collection = parser_1.makeCollection(json['cdlist'][0]);
                            return [4 /*yield*/, this.collectionAddons(collection.collectionOriginalId)];
                        case 2:
                            addons = _a.sent();
                            collection.userId = addons['diruin'] ? "qq|collection|" + addons['diruin'] : collection.userId;
                            collection.likeCount = addons['totalnum'];
                            return [2 /*return*/, collection];
                    }
                });
            });
        };
        QQMusicApi.prototype.searchSongs = function (keyword, offset, limit) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var params, url, json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            params = {
                                remoteplace: 'txt.yqq.song',
                                format: 'json',
                                p: offset,
                                n: limit,
                                w: keyword,
                                aggr: 1,
                                cr: 1,
                                lossless: 1,
                                flag_qc: 1,
                                new_json: 1,
                            };
                            url = QQMusicApi.NODE_MAP.searchSongs;
                            return [4 /*yield*/, this.request('GET', url, params)];
                        case 1:
                            json = _a.sent();
                            if (!json['data']) {
                                return [2 /*return*/, []];
                            }
                            return [2 /*return*/, parser_1.makeSongs(json['data']['song']['list'])];
                    }
                });
            });
        };
        QQMusicApi.prototype.searchAlbums = function (keyword, offset, limit) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var params, url, json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            params = {
                                platform: 'yqq',
                                ct: 24,
                                qqmusic_ver: 1298,
                                remoteplace: 'txt.yqq.album',
                                format: 'json',
                                p: offset,
                                n: limit,
                                w: keyword,
                                lossless: 0,
                                aggr: 0,
                                sem: 10,
                                t: 8,
                                catZhida: 1,
                            };
                            url = QQMusicApi.NODE_MAP.searchAlbums;
                            return [4 /*yield*/, this.request('GET', url, params)];
                        case 1:
                            json = _a.sent();
                            if (!json['data']) {
                                return [2 /*return*/, []];
                            }
                            return [2 /*return*/, parser_1.makeAlbums(json['data']['album']['list'])];
                    }
                });
            });
        };
        QQMusicApi.prototype.searchCollections = function (keyword, offset, limit) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var params, url, json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            params = {
                                remoteplace: 'txt.yqq.playlist',
                                flag_qc: '0',
                                page_no: offset,
                                num_per_page: limit,
                                query: keyword,
                                loginUin: '0',
                                hostUin: '0',
                                format: 'json',
                                inCharset: 'utf8',
                                outCharset: 'utf-8',
                                notice: '0',
                                platform: 'yqq',
                                needNewCode: '0',
                            };
                            url = QQMusicApi.NODE_MAP.searchCollections;
                            return [4 /*yield*/, this.request('GET', url, params)];
                        case 1:
                            json = _a.sent();
                            if (!json['data']) {
                                return [2 /*return*/, []];
                            }
                            return [2 /*return*/, parser_1.makeCollections(json['data']['list'])];
                    }
                });
            });
        };
        /**
         * Get new songs
         *
         * languageId:
         *     1: 内地
         *     2: 港台
         *     3: 欧美
         *     4: 日本
         *     5: 韩国
         */
        QQMusicApi.prototype.songList = function (languageId, offset, limit) {
            if (languageId === void 0) { languageId = 1; }
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var params, url, json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            params = {
                                g_tk: 0,
                                loginUin: 0,
                                hostUin: 0,
                                format: 'json',
                                inCharset: 'utf8',
                                outCharset: 'utf-8',
                                notice: 0,
                                platform: 'yqq.json',
                                needNewCode: 0,
                                data: JSON.stringify({
                                    comm: { ct: 24 },
                                    new_song: {
                                        method: "GetNewSong",
                                        module: "QQMusic.MusichallServer",
                                        param: {
                                            type: languageId,
                                        }
                                    },
                                }),
                            };
                            url = QQMusicApi.NODE_MAP.songList;
                            return [4 /*yield*/, this.request('GET', url, params)];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, parser_1.makeSongs(json['new_song']['data']['song_list'])];
                    }
                });
            });
        };
        QQMusicApi.prototype.albumListOptions = function () {
            return __awaiter(this, void 0, void 0, function () {
                var params, url, json, tags, options, sortOption;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            params = {
                                g_tk: 0,
                                loginUin: 0,
                                hostUin: 0,
                                format: 'json',
                                inCharset: 'utf8',
                                outCharset: 'utf-8',
                                notice: 0,
                                platform: 'yqq.json',
                                needNewCode: 0,
                                data: JSON.stringify({
                                    comm: { ct: 24 },
                                    albumlib: {
                                        param: {
                                            get_tags: 1,
                                            click_albumid: 0,
                                            year: -1,
                                            genre: -1,
                                            area: 1,
                                            sort: 2,
                                            type: -1,
                                            sin: 0,
                                            num: 1,
                                            company: -1
                                        },
                                        method: 'get_album_by_tags',
                                        module: 'music.web_album_library',
                                    },
                                }),
                            };
                            url = QQMusicApi.NODE_MAP.songList;
                            return [4 /*yield*/, this.request('GET', url, params)];
                        case 1:
                            json = _a.sent();
                            tags = json['albumlib']['data']['tags'];
                            options = Object.keys(tags).map(function (key) { return ({
                                name: ALBUM_OPTION_NAME_MAP[key],
                                type: key,
                                items: tags[key].map(function (info) { return ({
                                    id: info['id'],
                                    name: info['name'],
                                }); }),
                            }); });
                            sortOption = {
                                name: '排序',
                                type: 'sort',
                                items: [
                                    { id: 2, name: '最新' },
                                    { id: 5, name: '最热' },
                                ],
                            };
                            options.push(sortOption);
                            return [2 /*return*/, options];
                    }
                });
            });
        };
        /**
         * sort:
         *     2: 最新
         *     5: 最热
         *
         * area: 地区  // 同 xiami 的语种
         * genre: 流派  // 同 xiami 的曲风
         * type: 类别  // album 类别
         * year: 年代
         * company: 唱片公司
         */
        QQMusicApi.prototype.albumList = function (sort, areaId, genreId, typeId, yearId, companyId, offset, limit) {
            if (sort === void 0) { sort = 5; }
            if (areaId === void 0) { areaId = 0; }
            if (genreId === void 0) { genreId = -1; }
            if (typeId === void 0) { typeId = -1; }
            if (yearId === void 0) { yearId = -1; }
            if (companyId === void 0) { companyId = -1; }
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var params, url, json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            params = {
                                g_tk: 0,
                                loginUin: 0,
                                hostUin: 0,
                                format: 'json',
                                inCharset: 'utf8',
                                outCharset: 'utf-8',
                                notice: 0,
                                platform: 'yqq.json',
                                needNewCode: 0,
                                data: JSON.stringify({
                                    comm: { ct: 24 },
                                    albumlib: {
                                        param: {
                                            get_tags: 0,
                                            click_albumid: 0,
                                            sort: sort,
                                            area: areaId,
                                            genre: genreId,
                                            type: typeId,
                                            year: yearId,
                                            company: companyId,
                                            sin: offset,
                                            num: limit,
                                        },
                                        method: 'get_album_by_tags',
                                        module: 'music.web_album_library',
                                    },
                                }),
                            };
                            url = QQMusicApi.NODE_MAP.albumList;
                            return [4 /*yield*/, this.request('GET', url, params)];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, parser_1.makeAlbums(json['albumlib']['data']['list'])];
                    }
                });
            });
        };
        QQMusicApi.prototype.collectionListOrders = function () {
            return [
                { id: '3', name: '最热' },
                { id: '2', name: '最新' },
                { id: '4', name: '评分' },
            ];
        };
        QQMusicApi.prototype.collectionListOptions = function () {
            return __awaiter(this, void 0, void 0, function () {
                var params, url, json, options;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            params = {
                                g_tk: 0,
                                loginUin: 0,
                                hostUin: 0,
                                format: 'json',
                                inCharset: 'utf8',
                                outCharset: 'utf-8',
                                notice: 0,
                                platform: 'yqq.json',
                                needNewCode: 0,
                            };
                            url = QQMusicApi.NODE_MAP.collectionListOptions;
                            return [4 /*yield*/, this.request('GET', url, params)];
                        case 1:
                            json = _a.sent();
                            options = json['data']['categories'].map(function (info) { return ({
                                name: info['categoryGroupName'],
                                type: 'category',
                                items: info['items'].map(function (item) { return ({
                                    id: item['categoryId'],
                                    name: item['categoryName'],
                                }); }),
                            }); });
                            return [2 /*return*/, options];
                    }
                });
            });
        };
        /**
         * sort:
         *     2: 最新
         *     3: 最热
         *     4: 评分
         *
         *  categoryId sees this.collectionListOptions
         */
        QQMusicApi.prototype.collectionList = function (sort, categoryId, offset, limit) {
            if (sort === void 0) { sort = 3; }
            if (categoryId === void 0) { categoryId = 10000000; }
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var params, url, json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            params = {
                                picmid: 1,
                                rnd: random_1.getRandom(),
                                g_tk: 0,
                                loginUin: 0,
                                hostUin: 0,
                                format: 'json',
                                inCharset: 'utf8',
                                outCharset: 'utf-8',
                                notice: 0,
                                platform: 'yqq.json',
                                needNewCode: 0,
                                categoryId: categoryId,
                                sortId: sort,
                                sin: offset,
                                ein: limit,
                            };
                            url = QQMusicApi.NODE_MAP.collectionList;
                            return [4 /*yield*/, this.request('GET', url, params)];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, parser_1.makeCollections(json['data']['list'])];
                    }
                });
            });
        };
        QQMusicApi.prototype.artistListOptions = function () {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, common_1.ARTIST_LIST_OPTIONS];
                });
            });
        };
        /**
         * Get artists by options
         *
         * return 80 artists, default
         *
         * @param offset is just offset
         * @param limit is page number
         */
        QQMusicApi.prototype.artistList = function (area, genre, sex, index, offset, limit) {
            if (area === void 0) { area = '-100'; }
            if (genre === void 0) { genre = '-100'; }
            if (sex === void 0) { sex = '-100'; }
            if (index === void 0) { index = '-100'; }
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 1; }
            return __awaiter(this, void 0, void 0, function () {
                var data, params, url, json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            data = JSON.stringify({
                                comm: {
                                    ct: 24,
                                    cv: 0,
                                },
                                singerList: {
                                    module: "Music.SingerListServer",
                                    method: "get_singer_list",
                                    param: {
                                        area: Number.parseInt(area),
                                        genre: Number.parseInt(genre),
                                        sex: Number.parseInt(sex),
                                        index: Number.parseInt(index),
                                        sin: offset,
                                        cur_page: 1,
                                    }
                                }
                            });
                            params = {
                                g_tk: 5381,
                                loginUin: 0,
                                hostUin: 0,
                                format: 'json',
                                inCharset: 'utf8',
                                outCharset: 'utf-8',
                                notice: 0,
                                platform: 'yqq.json',
                                needNewCode: 0,
                                data: data,
                            };
                            url = QQMusicApi.NODE_MAP.artistList;
                            return [4 /*yield*/, this.request('GET', url, params)];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, parser_1.makeArtists(json['singerList']['data']['singerlist'])];
                    }
                });
            });
        };
        QQMusicApi.prototype.newSongs = function (offset, limit) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var songLists, songs, _a, _b, i, _c, _d, j, song;
                var e_3, _e, e_4, _f;
                return __generator(this, function (_g) {
                    switch (_g.label) {
                        case 0: return [4 /*yield*/, Promise.all([
                                this.songList(1),
                                this.songList(2),
                                this.songList(3),
                                this.songList(4),
                                this.songList(5),
                            ])];
                        case 1:
                            songLists = _g.sent();
                            songs = [];
                            try {
                                for (_a = __values(Array(10).keys()), _b = _a.next(); !_b.done; _b = _a.next()) {
                                    i = _b.value;
                                    try {
                                        for (_c = (e_4 = void 0, __values(Array(5).keys())), _d = _c.next(); !_d.done; _d = _c.next()) {
                                            j = _d.value;
                                            song = songLists[j][i];
                                            if (song)
                                                songs.push(song);
                                        }
                                    }
                                    catch (e_4_1) { e_4 = { error: e_4_1 }; }
                                    finally {
                                        try {
                                            if (_d && !_d.done && (_f = _c.return)) _f.call(_c);
                                        }
                                        finally { if (e_4) throw e_4.error; }
                                    }
                                }
                            }
                            catch (e_3_1) { e_3 = { error: e_3_1 }; }
                            finally {
                                try {
                                    if (_b && !_b.done && (_e = _a.return)) _e.call(_a);
                                }
                                finally { if (e_3) throw e_3.error; }
                            }
                            return [2 /*return*/, songs];
                    }
                });
            });
        };
        QQMusicApi.prototype.newAlbums = function (offset, limit) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var albumLists, albums, _a, _b, i, _c, _d, j, album;
                var e_5, _e, e_6, _f;
                return __generator(this, function (_g) {
                    switch (_g.label) {
                        case 0: return [4 /*yield*/, Promise.all([
                                this.albumList(2, 1, -1, -1, -1, -1, 0, 5),
                                this.albumList(2, 0, -1, -1, -1, -1, 0, 5),
                                this.albumList(2, 3, -1, -1, -1, -1, 0, 5),
                                this.albumList(2, 15, -1, -1, -1, -1, 0, 5),
                                this.albumList(2, 14, -1, -1, -1, -1, 0, 5),
                            ])];
                        case 1:
                            albumLists = _g.sent();
                            albums = [];
                            try {
                                for (_a = __values(Array(5).keys()), _b = _a.next(); !_b.done; _b = _a.next()) {
                                    i = _b.value;
                                    try {
                                        for (_c = (e_6 = void 0, __values(Array(5).keys())), _d = _c.next(); !_d.done; _d = _c.next()) {
                                            j = _d.value;
                                            album = albumLists[j][i];
                                            if (album)
                                                albums.push(album);
                                        }
                                    }
                                    catch (e_6_1) { e_6 = { error: e_6_1 }; }
                                    finally {
                                        try {
                                            if (_d && !_d.done && (_f = _c.return)) _f.call(_c);
                                        }
                                        finally { if (e_6) throw e_6.error; }
                                    }
                                }
                            }
                            catch (e_5_1) { e_5 = { error: e_5_1 }; }
                            finally {
                                try {
                                    if (_b && !_b.done && (_e = _a.return)) _e.call(_a);
                                }
                                finally { if (e_5) throw e_5.error; }
                            }
                            return [2 /*return*/, albums];
                    }
                });
            });
        };
        QQMusicApi.prototype.newCollections = function (offset, limit) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, this.collectionList(2, 10000000, offset, limit)];
                });
            });
        };
        /**
         * TODO: use qr code login
         */
        QQMusicApi.prototype.login = function () {
            return __awaiter(this, void 0, void 0, function () {
                var url, win, _loop_1, timeout, state_1;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            url = 'https://xui.ptlogin2.qq.com/cgi-bin/xlogin?appid=1006102&daid=384&low_login=1&pt_no_auth=1&s_url=https://y.qq.com/vip/daren_recruit/apply.html&style=40';
                            win = new electron_1.remote.BrowserWindow({
                                width: 800, height: 600,
                                webPreferences: {
                                    webSecurity: true,
                                    nodeIntegration: false,
                                    allowRunningInsecureContent: true
                                },
                            });
                            // win.webContents.openDevTools();
                            win.on('close', function () {
                                win = null;
                            });
                            win.loadURL(url);
                            // clear cache
                            win.webContents.session.clearStorageData();
                            win.show();
                            _loop_1 = function (timeout) {
                                var cookiesStr, cookies_2, userOriginalId, tmpApi, userProfile, account;
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0: 
                                        // waiting to login
                                        return [4 /*yield*/, time_1.sleep(1000)];
                                        case 1:
                                            // waiting to login
                                            _a.sent();
                                            return [4 /*yield*/, win.webContents.executeJavaScript('Promise.resolve(document.cookie)', true)];
                                        case 2:
                                            cookiesStr = _a.sent();
                                            if (!cookiesStr.includes('pt4_token')) return [3 /*break*/, 5];
                                            return [4 /*yield*/, time_1.sleep(2000)];
                                        case 3:
                                            _a.sent();
                                            cookies_2 = {};
                                            cookiesStr.split('; ').forEach(function (chunk) {
                                                var index = chunk.indexOf('=');
                                                cookies_2[chunk.slice(0, index)] = chunk.slice(index + 1);
                                            });
                                            userOriginalId = cookies_2['ptui_loginuin'] || cookies_2['uin'];
                                            tmpApi = new QQMusicApi();
                                            tmpApi.cookies = cookies_2;
                                            return [4 /*yield*/, tmpApi.userProfile(userOriginalId)];
                                        case 4:
                                            userProfile = _a.sent();
                                            account = {
                                                user: userProfile,
                                                type: 'account',
                                                cookies: cookies_2,
                                            };
                                            // close window
                                            win.close();
                                            return [2 /*return*/, { value: account }];
                                        case 5: return [2 /*return*/];
                                    }
                                });
                            };
                            timeout = 0;
                            _a.label = 1;
                        case 1:
                            if (!(timeout < 12000000)) return [3 /*break*/, 4];
                            return [5 /*yield**/, _loop_1(timeout)];
                        case 2:
                            state_1 = _a.sent();
                            if (typeof state_1 === "object")
                                return [2 /*return*/, state_1.value];
                            _a.label = 3;
                        case 3:
                            timeout += 1000;
                            return [3 /*break*/, 1];
                        case 4:
                            // Handle timeout
                            win.close();
                            throw new errors_1.LoginTimeoutError('Timeout !!!');
                    }
                });
            });
        };
        QQMusicApi.prototype.setAccount = function (account) {
            assert_1.ok(account.user.origin == origin_1.ORIGIN.qq, "[QQMusicApi.setAccount]: this account is not a qq account");
            this.cookies = __assign({}, account.cookies);
            this.account = account;
        };
        QQMusicApi.prototype.getAccount = function () {
            return this.account;
        };
        QQMusicApi.prototype.logined = function () {
            return !!this.account && !!this.account.cookies && !!this.account.cookies['pt4_token'];
        };
        QQMusicApi.prototype.userProfile = function (userMid) {
            return __awaiter(this, void 0, void 0, function () {
                var params, url, json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            params = {
                                hostUin: '0',
                                format: 'json',
                                inCharset: 'utf8',
                                outCharset: 'utf-8',
                                notice: '0',
                                platform: 'yqq',
                                needNewCode: '0',
                                cid: '205360838',
                                ct: '20',
                                userid: userMid,
                                reqfrom: '1',
                                reqtype: '0',
                            };
                            url = QQMusicApi.NODE_MAP.userProfile;
                            return [4 /*yield*/, this.request('GET', url, params)];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, parser_1.makeUserProfile(json.data)];
                    }
                });
            });
        };
        /**
         * No need to login
         */
        QQMusicApi.prototype.userFavoriteSongs = function (userMid, offset, limit) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var collections, collectionOriginalId, collection;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.userCreatedCollections(userMid, 0, 2)];
                        case 1:
                            collections = _a.sent();
                            collectionOriginalId = collections[0].collectionOriginalId;
                            return [4 /*yield*/, this.collection(collectionOriginalId, offset, limit)];
                        case 2:
                            collection = _a.sent();
                            return [2 /*return*/, collection.songs];
                    }
                });
            });
        };
        /**
         * No need to login
         */
        QQMusicApi.prototype.userFavoriteAlbums = function (userMid, offset, limit) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var account, params, url, json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            account = this.getAccount();
                            params = {
                                loginUin: account.user.userOriginalId,
                                hostUin: '0',
                                format: 'json',
                                inCharset: 'utf8',
                                outCharset: 'utf-8',
                                notice: '0',
                                platform: 'yqq',
                                needNewCode: '0',
                                ct: '20',
                                cid: '205360956',
                                userid: userMid,
                                reqtype: '2',
                                sin: offset,
                                ein: limit,
                            };
                            url = QQMusicApi.NODE_MAP.userFavoriteAlbums;
                            return [4 /*yield*/, this.request('GET', url, params)];
                        case 1:
                            json = _a.sent();
                            if (!json.data) {
                                return [2 /*return*/, []];
                            }
                            return [2 /*return*/, parser_1.makeAlbums(json.data.albumlist)];
                    }
                });
            });
        };
        /**
         * TODO: Need to logined
         */
        QQMusicApi.prototype.userFavoriteArtists = function (userMid, offset, limit) {
            if (offset === void 0) { offset = 1; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var account, params, referer, url, json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!this.logined()) {
                                throw new errors_1.NoLoginError("[QQMusicApi] Geting user's favorite artists needs to login");
                            }
                            account = this.getAccount();
                            params = {
                                utf8: '1',
                                page: offset,
                                perpage: limit,
                                uin: userMid,
                                g_tk: this.getACSRFToken(),
                                loginUin: account.user.userOriginalId,
                                hostUin: '0',
                                format: 'json',
                                inCharset: 'utf8',
                                outCharset: 'GB2312',
                                notice: '0',
                                platform: 'yqq',
                                needNewCode: '0',
                            };
                            referer = "https://y.qq.com/portal/profile.html?uin=" + userMid;
                            url = QQMusicApi.NODE_MAP.userFavoriteArtists;
                            return [4 /*yield*/, this.request('GET', url, params, null, referer)];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, parser_1.makeArtists(json.list)];
                    }
                });
            });
        };
        QQMusicApi.prototype.userFavoriteCollections = function (userMid, offset, limit) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var account, params, url, json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!this.logined()) {
                                throw new errors_1.NoLoginError("[QQMusicApi] Geting user's favorite collections needs to login");
                            }
                            account = this.getAccount();
                            params = {
                                loginUin: account.user.userOriginalId,
                                hostUin: '0',
                                format: 'json',
                                inCharset: 'utf8',
                                outCharset: 'utf-8',
                                notice: '0',
                                platform: 'yqq',
                                needNewCode: '0',
                                ct: '20',
                                cid: '205360956',
                                userid: userMid,
                                reqtype: '3',
                                sin: offset,
                                ein: limit,
                            };
                            url = QQMusicApi.NODE_MAP.userFavoriteCollections;
                            return [4 /*yield*/, this.request('GET', url, params)];
                        case 1:
                            json = _a.sent();
                            if (!json.data) {
                                return [2 /*return*/, []];
                            }
                            return [2 /*return*/, parser_1.makeCollections(json.data.cdlist)];
                    }
                });
            });
        };
        QQMusicApi.prototype.userCreatedCollections = function (userMid, offset, limit) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var account, params, url, json, userId, userName, collections;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!this.logined()) {
                                throw new errors_1.NoLoginError("[QQMusicApi] Geting user's created collections needs to login");
                            }
                            account = this.getAccount();
                            params = {
                                hostuin: userMid,
                                sin: offset,
                                size: limit,
                                loginUin: account.user.userOriginalId,
                                hostUin: '0',
                                format: 'json',
                                inCharset: 'utf8',
                                outCharset: 'utf-8',
                                notice: '0',
                                platform: 'yqq',
                                needNewCode: '0',
                            };
                            url = QQMusicApi.NODE_MAP.userCreatedCollections;
                            return [4 /*yield*/, this.request('GET', url, params)];
                        case 1:
                            json = _a.sent();
                            if (!json.data) {
                                return [2 /*return*/, []];
                            }
                            userId = 'qq|user|' + json.data['hostuin'].toString();
                            userMid = json.data['encrypt_uin'];
                            userName = json.data['hostname'];
                            collections = parser_1.makeCollections((offset == 0 ? json.data.disslist.slice(1) : json.data.disslist)
                                .filter(function (info) { return info.tid != 0; }));
                            collections.filter(function (collection) {
                                collection.userId = userId;
                                collection.userMid = userMid;
                                collection.userName = userName;
                            });
                            return [2 /*return*/, collections];
                    }
                });
            });
        };
        /**
         * TODO: Need to logined
         *
         * offset begins from 0
         *
         * followings: `is_listen = 0`
         * followers: `is_listen = 1`
         */
        QQMusicApi.prototype.userFollows = function (userMid, offset, limit, ing) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            if (ing === void 0) { ing = true; }
            return __awaiter(this, void 0, void 0, function () {
                var account, params, url, json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!this.logined()) {
                                throw new errors_1.NoLoginError("[QQMusicApi] Geting user's followings list needs to login");
                            }
                            account = this.getAccount();
                            params = {
                                utf8: '1',
                                start: offset,
                                num: limit,
                                is_listen: ing ? '0' : '1',
                                uin: userMid,
                                loginUin: account.user.userOriginalId,
                                hostUin: '0',
                                format: 'json',
                                inCharset: 'utf8',
                                outCharset: 'utf-8',
                                notice: '0',
                                platform: 'yqq',
                                needNewCode: '0',
                                g_tk: this.getACSRFToken(),
                            };
                            url = QQMusicApi.NODE_MAP.userFollow;
                            return [4 /*yield*/, this.request('GET', url, params)];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, parser_1.makeUserProfiles(json.list)];
                    }
                });
            });
        };
        QQMusicApi.prototype.userFollowings = function (userMid, offset, limit) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, this.userFollows(userMid, offset, limit, true)];
                });
            });
        };
        QQMusicApi.prototype.userFollowers = function (userMid, offset, limit) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, this.userFollows(userMid, offset, limit, false)];
                });
            });
        };
        QQMusicApi.prototype.myCreatedCollections = function () {
            return __awaiter(this, void 0, void 0, function () {
                var account, params, url, json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!this.logined()) {
                                throw new errors_1.NoLoginError('[QQMusicApi] Saving one song to favorite songs list needs to login');
                            }
                            account = this.getAccount();
                            params = {
                                g_tk: this.getACSRFToken(),
                                utf8: '1',
                                uin: account.user.userOriginalId,
                                loginUin: account.user.userOriginalId,
                                hostUin: '0',
                                format: 'json',
                                inCharset: 'utf8',
                                outCharset: 'utf-8',
                                notice: '0',
                                platform: 'yqq',
                                needNewCode: '0',
                            };
                            url = QQMusicApi.NODE_MAP.myCreatedCollections;
                            return [4 /*yield*/, this.request('GET', url, params)];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, json.list.map(function (item) {
                                    return { id: item['dirid'].toString(), name: item['dirname'].trim() };
                                })];
                    }
                });
            });
        };
        QQMusicApi.prototype.userLikeSong = function (songId, songMid) {
            return __awaiter(this, void 0, void 0, function () {
                var account, params, data, referer, url, json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!this.logined()) {
                                throw new errors_1.NoLoginError('[QQMusicApi] Saving one song to favorite songs list needs to login');
                            }
                            account = this.getAccount();
                            params = {
                                g_tk: this.getACSRFToken(),
                            };
                            data = url_1.querystringify({
                                loginUin: account.user.userOriginalId,
                                hostUin: '0',
                                format: 'json',
                                inCharset: 'utf8',
                                outCharset: 'utf-8',
                                notice: '0',
                                platform: 'yqq.post',
                                needNewCode: '0',
                                uin: account.user.userOriginalId,
                                midlist: songMid,
                                typelist: '13',
                                dirid: '201',
                                addtype: '',
                                formsender: '4',
                                source: '153',
                                r2: '0',
                                r3: '1',
                                utf8: '1',
                                g_tk: this.getACSRFToken(),
                            });
                            referer = 'https://imgcache.qq.com/music/miniportal_v4/tool/html/fp_utf8.html';
                            url = QQMusicApi.NODE_MAP.userLikeSong;
                            return [4 /*yield*/, this.request('POST', url, params, data, referer)];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, json.code == 0];
                    }
                });
            });
        };
        QQMusicApi.prototype.userLikeArtist = function (artistId, artistMid) {
            return __awaiter(this, void 0, void 0, function () {
                var account, params, referer, url, json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!this.logined()) {
                                throw new errors_1.NoLoginError('[QQMusicApi] Saving one artist needs to login');
                            }
                            account = this.getAccount();
                            params = {
                                g_tk: this.getACSRFToken(),
                                loginUin: account.user.userOriginalId,
                                hostUin: '0',
                                format: 'json',
                                inCharset: 'utf8',
                                outCharset: 'gb2312',
                                notice: '0',
                                platform: 'yqq',
                                needNewCode: '0',
                                singermid: artistMid,
                                rnd: Date.now(),
                            };
                            referer = "https://y.qq.com/n/yqq/singer/" + artistMid + ".html";
                            url = QQMusicApi.NODE_MAP.userLikeArtist;
                            return [4 /*yield*/, this.request('GET', url, params, null, referer)];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, json['code'] == 0];
                    }
                });
            });
        };
        QQMusicApi.prototype.userLikeAlbum = function (albumId, albumMid) {
            return __awaiter(this, void 0, void 0, function () {
                var account, params, data, referer, url, body;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!this.logined()) {
                                throw new errors_1.NoLoginError('[QQMusicApi] Saving one album needs to login');
                            }
                            account = this.getAccount();
                            params = {
                                g_tk: this.getACSRFToken(),
                            };
                            data = url_1.querystringify({
                                loginUin: account.user.userOriginalId,
                                hostUin: '0',
                                format: 'fs',
                                inCharset: 'GB2312',
                                outCharset: 'utf8',
                                notice: '0',
                                platform: 'yqq',
                                needNewCode: '0',
                                g_tk: this.getACSRFToken(),
                                uin: account.user.userOriginalId,
                                ordertype: '1',
                                albumid: albumId,
                                albummid: albumMid,
                                from: '1',
                                optype: '1',
                                utf8: '1',
                            });
                            referer = 'https://imgcache.qq.com/music/miniportal_v4/tool/html/fp_utf8.html';
                            url = QQMusicApi.NODE_MAP.userLikeAlbum;
                            return [4 /*yield*/, this.request('POST', url, params, data, referer)];
                        case 1:
                            body = _a.sent();
                            return [2 /*return*/, body.includes('"code":0')];
                    }
                });
            });
        };
        QQMusicApi.prototype.userLikeCollection = function (collectionId, collectionMid) {
            return __awaiter(this, void 0, void 0, function () {
                var account, params, data, referer, url, body;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!this.logined()) {
                                throw new errors_1.NoLoginError('[QQMusicApi] Saving one collection needs to login');
                            }
                            account = this.getAccount();
                            params = {
                                g_tk: this.getACSRFToken(),
                            };
                            data = url_1.querystringify({
                                loginUin: account.user.userOriginalId,
                                hostUin: '0',
                                format: 'fs',
                                inCharset: 'GB2312',
                                outCharset: 'utf8',
                                notice: '0',
                                platform: 'yqq',
                                needNewCode: '0',
                                g_tk: this.getACSRFToken(),
                                uin: account.user.userOriginalId,
                                dissid: collectionId,
                                from: '1',
                                optype: '1',
                                utf8: '1',
                            });
                            referer = 'https://imgcache.qq.com/music/miniportal_v4/tool/html/fp_utf8.html';
                            url = QQMusicApi.NODE_MAP.userLikeCollection;
                            return [4 /*yield*/, this.request('POST', url, params, data, referer)];
                        case 1:
                            body = _a.sent();
                            return [2 /*return*/, body.includes('"code":0')];
                    }
                });
            });
        };
        QQMusicApi.prototype.userLikeUserProfile = function (userId, userMid, dislike) {
            if (dislike === void 0) { dislike = false; }
            return __awaiter(this, void 0, void 0, function () {
                var account, params, data, referer, url, body;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!this.logined()) {
                                throw new errors_1.NoLoginError('[QQMusicApi] following/unfollowing one user needs to login');
                            }
                            account = this.getAccount();
                            params = {
                                g_tk: this.getACSRFToken(),
                            };
                            data = url_1.querystringify({
                                loginUin: account.user.userOriginalId,
                                hostUin: '0',
                                format: 'fs',
                                inCharset: 'GB2312',
                                outCharset: 'utf8',
                                notice: '0',
                                platform: 'yqq',
                                needNewCode: '0',
                                g_tk: this.getACSRFToken(),
                                my_uin: account.user.userOriginalId,
                                friend_uin: userId,
                                status: dislike ? '0' : '1',
                                formsender: '1',
                            });
                            referer = 'https://imgcache.qq.com/music/miniportal_v4/tool/html/fp_gbk.html';
                            url = QQMusicApi.NODE_MAP.userLikeUserProfile;
                            return [4 /*yield*/, this.request('POST', url, params, data, referer)];
                        case 1:
                            body = _a.sent();
                            return [2 /*return*/, body.includes('"code":0')];
                    }
                });
            });
        };
        QQMusicApi.prototype.userDislikeSong = function (songId, songMid) {
            return __awaiter(this, void 0, void 0, function () {
                var account, params, data, referer, url, body;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!this.logined()) {
                                throw new errors_1.NoLoginError('[QQMusicApi] Deleting one song from favorite songs list needs to login');
                            }
                            account = this.getAccount();
                            params = {
                                g_tk: this.getACSRFToken(),
                            };
                            data = url_1.querystringify({
                                loginUin: account.user.userOriginalId,
                                hostUin: '0',
                                format: 'fs',
                                inCharset: 'GB2312',
                                outCharset: 'utf8',
                                notice: '0',
                                platform: 'yqq',
                                needNewCode: '0',
                                g_tk: this.getACSRFToken(),
                                uin: account.user.userOriginalId,
                                dirid: '201',
                                ids: songId,
                                source: '103',
                                types: '3',
                                formsender: '1',
                                flag: '2',
                                from: '3',
                                utf8: '1',
                            });
                            referer = 'https://imgcache.qq.com/music/miniportal_v4/tool/html/fp_utf8.html';
                            url = QQMusicApi.NODE_MAP.userDislikeSong;
                            return [4 /*yield*/, this.request('POST', url, params, data, referer)];
                        case 1:
                            body = _a.sent();
                            return [2 /*return*/, body.includes('删除成功')];
                    }
                });
            });
        };
        QQMusicApi.prototype.userDislikeArtist = function (artist, artistMid) {
            return __awaiter(this, void 0, void 0, function () {
                var account, params, referer, url, json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!this.logined()) {
                                throw new errors_1.NoLoginError('[QQMusicApi] Deleting one artist needs to login');
                            }
                            account = this.getAccount();
                            params = {
                                g_tk: this.getACSRFToken(),
                                loginUin: account.user.userOriginalId,
                                hostUin: '0',
                                format: 'json',
                                inCharset: 'utf8',
                                outCharset: 'gb2312',
                                notice: '0',
                                platform: 'yqq',
                                needNewCode: '0',
                                singermid: artistMid,
                                rnd: Date.now(),
                            };
                            referer = "https://y.qq.com/n/yqq/singer/" + artistMid + ".html";
                            url = QQMusicApi.NODE_MAP.userDislikeArtist;
                            return [4 /*yield*/, this.request('GET', url, params, null, referer)];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, json['code'] == 0];
                    }
                });
            });
        };
        QQMusicApi.prototype.userDislikeAlbum = function (albumId, albumMid) {
            return __awaiter(this, void 0, void 0, function () {
                var account, params, data, referer, url, body;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!this.logined()) {
                                throw new errors_1.NoLoginError('[QQMusicApi] Deleting one album needs to login');
                            }
                            account = this.getAccount();
                            params = {
                                g_tk: this.getACSRFToken(),
                            };
                            data = url_1.querystringify({
                                loginUin: account.user.userOriginalId,
                                hostUin: '0',
                                format: 'fs',
                                inCharset: 'GB2312',
                                outCharset: 'utf8',
                                notice: '0',
                                platform: 'yqq',
                                needNewCode: '0',
                                g_tk: this.getACSRFToken(),
                                uin: account.user.userOriginalId,
                                ordertype: '1',
                                albumid: albumId,
                                albummid: albumMid,
                                from: '1',
                                optype: '2',
                                utf8: '1',
                            });
                            referer = 'https://imgcache.qq.com/music/miniportal_v4/tool/html/fp_utf8.html';
                            url = QQMusicApi.NODE_MAP.userDislikeAlbum;
                            return [4 /*yield*/, this.request('POST', url, params, data, referer)];
                        case 1:
                            body = _a.sent();
                            return [2 /*return*/, body.includes('"code":0')];
                    }
                });
            });
        };
        QQMusicApi.prototype.userDislikeCollection = function (collectionId, collectionMid) {
            return __awaiter(this, void 0, void 0, function () {
                var userId, params, data, referer, url, body;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!this.logined()) {
                                throw new errors_1.NoLoginError('[QQMusicApi] Deleting one collection needs to login');
                            }
                            userId = this.account.user.userOriginalId;
                            params = {
                                g_tk: this.getACSRFToken(),
                            };
                            data = url_1.querystringify({
                                loginUin: userId,
                                hostUin: '0',
                                format: 'fs',
                                inCharset: 'GB2312',
                                outCharset: 'utf8',
                                notice: '0',
                                platform: 'yqq',
                                needNewCode: '0',
                                g_tk: this.getACSRFToken(),
                                uin: userId,
                                dissid: collectionId,
                                from: '1',
                                optype: '2',
                                utf8: '1',
                            });
                            referer = 'https://imgcache.qq.com/music/miniportal_v4/tool/html/fp_utf8.html';
                            url = QQMusicApi.NODE_MAP.userDislikeCollection;
                            return [4 /*yield*/, this.request('POST', url, params, data, referer)];
                        case 1:
                            body = _a.sent();
                            return [2 /*return*/, body.includes('"code":0')];
                    }
                });
            });
        };
        QQMusicApi.prototype.userDislikeUserProfile = function (userId, userMid) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, this.userLikeUserProfile(userId, userMid, true)];
                });
            });
        };
        /**
         * QQ has not recommended songs
         */
        QQMusicApi.prototype.recommendSongs = function (offset, limit) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, []];
                });
            });
        };
        QQMusicApi.prototype.recommendCollections = function (offset, limit) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var data, params, url, json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            data = JSON.stringify({
                                recomPlaylist: {
                                    module: "playlist.HotRecommendServer",
                                    method: "get_hot_recommend",
                                    param: {
                                        cmd: 2,
                                        async: 1
                                    }
                                },
                            });
                            params = {
                                g_tk: this.getACSRFToken(),
                                loginUin: '0',
                                hostUin: '0',
                                format: 'json',
                                inCharset: 'utf8',
                                outCharset: 'utf-8',
                                notice: '0',
                                platform: 'yqq',
                                needNewCode: '0',
                                data: data,
                            };
                            url = QQMusicApi.NODE_MAP.recommendCollections;
                            return [4 /*yield*/, this.request('GET', url, params)];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, parser_1.makeCollections(json['recomPlaylist']['data']['v_hot'] || [])];
                    }
                });
            });
        };
        /**
         * QQ seems has not the api
         */
        QQMusicApi.prototype.playLog = function (songId, seek, songMid) {
            return __awaiter(this, void 0, void 0, function () {
                var params, referer, url;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!this.logined()) {
                                throw new errors_1.NoLoginError('[QQMusicApi] recording one played song needs to login');
                            }
                            params = {
                                musicid: songId,
                                isexit: 'false',
                                _r: Date.now(),
                                g_tk: this.getACSRFToken(),
                            };
                            referer = 'https://y.qq.com/portal/player.html';
                            url = QQMusicApi.NODE_MAP.playLog;
                            // return nothing;
                            return [4 /*yield*/, this.request('GET', url, params, null, referer)];
                        case 1:
                            // return nothing;
                            _a.sent();
                            return [2 /*return*/, true];
                    }
                });
            });
        };
        QQMusicApi.prototype.resizeImageUrl = function (url, size) {
            return size_1.resizeImageUrl(url, size, function (url, size) {
                if (size <= 300) {
                    return url;
                }
                else if (size > 300 && size <= 500) {
                    return url.replace('300x300', '500x500');
                }
                else if (size > 500 && size <= 800) {
                    return url.replace('300x300', '800x800');
                }
                else {
                    return url.replace('300x300', '800x800');
                }
            });
        };
        QQMusicApi.prototype.changeIP = function (audioUrl) {
            var re = /\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}/;
            var mod = re.exec(audioUrl);
            if (!!!mod) {
                var newURI = this.getAudioURI();
                return audioUrl.replace(QQMusicApi.AUDIO_URI, newURI);
            }
            var ip = mod[0];
            // remove invalid ip
            this.ips = __spread(this.ips.slice(0, this.ip_index), this.ips.slice(this.ip_index + 1));
            this.ip_index -= 1;
            var newIP = this.getAudioServerIP();
            return audioUrl.replace(ip, newIP);
        };
        QQMusicApi.prototype.fromURL = function (input) {
            return __awaiter(this, void 0, void 0, function () {
                var chunks, items, chunks_1, chunks_1_1, chunk, m, mid, originId, type, matchList, matchList_1, matchList_1_1, _a, re, tp, idType, item, _b, e_7_1;
                var e_7, _c, e_8, _d;
                return __generator(this, function (_e) {
                    switch (_e.label) {
                        case 0:
                            chunks = input.split(' ');
                            items = [];
                            _e.label = 1;
                        case 1:
                            _e.trys.push([1, 16, 17, 18]);
                            chunks_1 = __values(chunks), chunks_1_1 = chunks_1.next();
                            _e.label = 2;
                        case 2:
                            if (!!chunks_1_1.done) return [3 /*break*/, 15];
                            chunk = chunks_1_1.value;
                            m = void 0;
                            mid = void 0;
                            originId = void 0;
                            type = void 0;
                            matchList = [
                                // song
                                [/songmid=([^/#&.]+)/, 'song', 'mid'],
                                [/songid=(\d+)/, 'song', 'originId'],
                                [/song\/(\d+)_num/, 'song', 'originId'],
                                [/song\/([^/#&.]+)/, 'song', 'mid'],
                                // singer
                                [/singerid=(\d+)/, 'artist', 'originId'],
                                [/singermid=([^/#&.]+)/, 'artist', 'mid'],
                                [/singer\/([^/#&.]+)/, 'artist', 'mid'],
                                // album
                                [/album\/(\d+)_num/, 'album', 'originId'],
                                [/albumId=(\d+)/, 'album', 'originId'],
                                [/album\/([^/#&.]+)/, 'album', 'mid'],
                                // collection
                                [/taoge\/.+?&id=(\d+)/, 'collection', 'originId'],
                                [/playlist\/(\d+)/, 'collection', 'originId'],
                                [/playsquare\/([^/#&.]+)/, 'collection', 'originId'],
                                // user
                                [/profile\.html\?uin=([^/#&.]+)/, 'user', 'originId'],
                            ];
                            try {
                                for (matchList_1 = (e_8 = void 0, __values(matchList)), matchList_1_1 = matchList_1.next(); !matchList_1_1.done; matchList_1_1 = matchList_1.next()) {
                                    _a = __read(matchList_1_1.value, 3), re = _a[0], tp = _a[1], idType = _a[2];
                                    m = re.exec(chunk);
                                    if (m) {
                                        if (idType == 'mid') {
                                            mid = m[1];
                                            originId = null;
                                            type = tp;
                                        }
                                        else {
                                            mid = null;
                                            originId = m[1];
                                            type = tp;
                                        }
                                        break;
                                    }
                                }
                            }
                            catch (e_8_1) { e_8 = { error: e_8_1 }; }
                            finally {
                                try {
                                    if (matchList_1_1 && !matchList_1_1.done && (_d = matchList_1.return)) _d.call(matchList_1);
                                }
                                finally { if (e_8) throw e_8.error; }
                            }
                            if (!(mid || originId)) return [3 /*break*/, 14];
                            item = void 0;
                            _b = type;
                            switch (_b) {
                                case 'song': return [3 /*break*/, 3];
                                case 'artist': return [3 /*break*/, 5];
                                case 'album': return [3 /*break*/, 7];
                                case 'collection': return [3 /*break*/, 9];
                                case 'user': return [3 /*break*/, 11];
                            }
                            return [3 /*break*/, 13];
                        case 3: return [4 /*yield*/, this.song(originId, mid)];
                        case 4:
                            item = _e.sent();
                            items.push(item);
                            return [3 /*break*/, 14];
                        case 5: return [4 /*yield*/, this.artist(originId, mid)];
                        case 6:
                            item = _e.sent();
                            items.push(item);
                            return [3 /*break*/, 14];
                        case 7: return [4 /*yield*/, this.album(originId, mid)];
                        case 8:
                            item = _e.sent();
                            items.push(item);
                            return [3 /*break*/, 14];
                        case 9: return [4 /*yield*/, this.collection(originId)];
                        case 10:
                            item = _e.sent();
                            items.push(item);
                            return [3 /*break*/, 14];
                        case 11: return [4 /*yield*/, this.userProfile(originId)];
                        case 12:
                            item = _e.sent();
                            items.push(item);
                            return [3 /*break*/, 14];
                        case 13: return [3 /*break*/, 14];
                        case 14:
                            chunks_1_1 = chunks_1.next();
                            return [3 /*break*/, 2];
                        case 15: return [3 /*break*/, 18];
                        case 16:
                            e_7_1 = _e.sent();
                            e_7 = { error: e_7_1 };
                            return [3 /*break*/, 18];
                        case 17:
                            try {
                                if (chunks_1_1 && !chunks_1_1.done && (_c = chunks_1.return)) _c.call(chunks_1);
                            }
                            finally { if (e_7) throw e_7.error; }
                            return [7 /*endfinally*/];
                        case 18: return [2 /*return*/, items];
                    }
                });
            });
        };
        QQMusicApi.HEADERS = {
            'accept-encoding': 'gzip, deflate',
            'accept-language': 'en-US,en;q=0.9,zh-CN;q=0.8,zh;q=0.7,ja;q=0.6,zh-TW;q=0.5',
            'user-agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36',
            'accept': '*/*',
        };
        // static readonly AUDIO_URI = 'http://mobileoc.music.tc.qq.com/';
        // static readonly AUDIO_URI = 'http://streamoc.music.tc.qq.com/';
        // static readonly AUDIO_URI = 'http://223.111.154.151/amobile.music.tc.qq.com/';
        // static readonly AUDIO_URI = 'http://dl.stream.qqmusic.qq.com/';
        QQMusicApi.AUDIO_URI = 'http://isure.stream.qqmusic.qq.com/';
        QQMusicApi.NODE_MAP = {
            // qqKey: 'https://c.y.qq.com/base/fcgi-bin/fcg_musicexpress.fcg',
            qqKey: 'https://c.y.qq.com/base/fcgi-bin/fcg_music_express_mobile3.fcg',
            audio: 'https://u.y.qq.com/cgi-bin/musicu.fcg',
            song: 'https://u.y.qq.com/cgi-bin/musicu.fcg',
            // lyric: 'https://c.y.qq.com/lyric/fcgi-bin/fcg_query_lyric_yqq.fcg',
            lyric: 'https://c.y.qq.com/lyric/fcgi-bin/fcg_query_lyric_new.fcg',
            album: 'https://c.y.qq.com/v8/fcg-bin/fcg_v8_album_info_cp.fcg',
            artist: 'https://c.y.qq.com/v8/fcg-bin/fcg_v8_singer_track_cp.fcg',
            artistLikeCount: 'https://c.y.qq.com/rsc/fcgi-bin/fcg_order_singer_getnum.fcg',
            artistSongs: 'https://c.y.qq.com/v8/fcg-bin/fcg_v8_singer_track_cp.fcg',
            artistAlbums: 'https://u.y.qq.com/cgi-bin/musicu.fcg',
            collection: 'https://c.y.qq.com/qzone/fcg-bin/fcg_ucc_getcdinfo_byids_cp.fcg',
            collectionAddons: 'https://c.y.qq.com/3gmusic/fcgi-bin/3g_dir_order_uinlist',
            searchSongs: 'https://c.y.qq.com/soso/fcgi-bin/client_search_cp',
            searchAlbums: 'https://c.y.qq.com/soso/fcgi-bin/client_search_cp',
            searchCollections: 'https://c.y.qq.com/soso/fcgi-bin/client_music_search_songlist',
            songList: 'https://u.y.qq.com/cgi-bin/musicu.fcg',
            albumList: 'https://u.y.qq.com/cgi-bin/musicu.fcg',
            collectionList: 'https://c.y.qq.com/splcloud/fcgi-bin/fcg_get_diss_by_tag.fcg',
            artistList: 'https://u.y.qq.com/cgi-bin/musicu.fcg',
            collectionListOptions: 'https://c.y.qq.com/splcloud/fcgi-bin/fcg_get_diss_tag_conf.fcg',
            userProfile: 'https://c.y.qq.com/rsc/fcgi-bin/fcg_get_profile_homepage.fcg',
            userFavoriteSongs: 'https://c.y.qq.com/qzone/fcg-bin/fcg_ucc_getcdinfo_byids_cp.fcg',
            userFavoriteAlbums: 'https://c.y.qq.com/fav/fcgi-bin/fcg_get_profile_order_asset.fcg',
            userFavoriteArtists: 'https://c.y.qq.com/rsc/fcgi-bin/fcg_order_singer_getlist.fcg',
            userFavoriteCollections: 'https://c.y.qq.com/fav/fcgi-bin/fcg_get_profile_order_asset.fcg',
            userCreatedCollections: 'https://c.y.qq.com/rsc/fcgi-bin/fcg_user_created_diss',
            userFollow: 'https://c.y.qq.com/rsc/fcgi-bin/friend_follow_or_listen_list.fcg',
            myCreatedCollections: 'https://c.y.qq.com/splcloud/fcgi-bin/songlist_list.fcg',
            userLikeSong: 'https://c.y.qq.com/splcloud/fcgi-bin/fcg_music_add2songdir.fcg',
            userLikeArtist: 'https://c.y.qq.com/rsc/fcgi-bin/fcg_order_singer_add.fcg',
            userLikeAlbum: 'https://c.y.qq.com/folder/fcgi-bin/fcg_qm_order_diss.fcg',
            userLikeCollection: 'https://c.y.qq.com/folder/fcgi-bin/fcg_qm_order_diss.fcg',
            userLikeUserProfile: 'https://c.y.qq.com/rsc/fcgi-bin/add_attention_status.fcg',
            userDislikeSong: 'https://c.y.qq.com/qzone/fcg-bin/fcg_music_delbatchsong.fcg',
            userDislikeArtist: 'https://c.y.qq.com/rsc/fcgi-bin/fcg_order_singer_del.fcg',
            userDislikeAlbum: 'https://c.y.qq.com/folder/fcgi-bin/fcg_qm_order_diss.fcg',
            userDislikeCollection: 'https://c.y.qq.com/folder/fcgi-bin/fcg_qm_order_diss.fcg',
            userDislikeUserProfile: 'https://c.y.qq.com/rsc/fcgi-bin/add_attention_status.fcg',
            recommendCollections: 'https://u.y.qq.com/cgi-bin/musicu.fcg',
            newSongs: 'https://u.y.qq.com/cgi-bin/musicu.fcg',
            newAlbums: 'https://u.y.qq.com/cgi-bin/musicu.fcg',
            newCollections: 'https://c.y.qq.com/splcloud/fcgi-bin/fcg_get_diss_by_tag.fcg',
            playLog: 'https://c.y.qq.com/tplcloud/fcgi-bin/fcg_reportlsting_web.fcg',
        };
        return QQMusicApi;
    }());
    exports.QQMusicApi = QQMusicApi;
});
