var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
define(["require", "exports", "fs", "chord/base/common/objects", "chord/base/common/property", "chord/preference/api/app", "chord/preference/common/app"], function (require, exports, fs, objects_1, property_1, app_1, app_2) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.appConfiguration = exports.AppConfiguration = void 0;
    var AppConfiguration = /** @class */ (function () {
        function AppConfiguration() {
            var config;
            try {
                var appConfig = JSON.parse(fs.readFileSync(app_2.APP_CONFIGURATION_PATH).toString());
                var defaultConfig = app_1.initiateAppConfiguration();
                appConfig.origins = __assign(__assign({}, defaultConfig.origins), appConfig.origins);
                config = __assign(__assign({}, defaultConfig), appConfig);
            }
            catch (e) {
                config = app_1.initiateAppConfiguration();
            }
            this.configuration = config;
        }
        AppConfiguration.prototype.getConfig = function () {
            return objects_1.deepCopy(this.configuration);
        };
        AppConfiguration.prototype.setConfig = function (path, value) {
            property_1.setDescendentProp(this.configuration, path, objects_1.deepCopy(value));
        };
        AppConfiguration.prototype.saveConfig = function (config) {
            config = config || this.getConfig();
            fs.writeFileSync(app_2.APP_CONFIGURATION_PATH, JSON.stringify(config, null, 4), { encoding: 'utf-8' });
        };
        return AppConfiguration;
    }());
    exports.AppConfiguration = AppConfiguration;
    // Global app configuration
    exports.appConfiguration = new AppConfiguration();
});
