var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
define(["require", "exports", "fs", "chord/preference/common/app", "chord/workbench/api/common/state/mainView/searchView"], function (require, exports, fs, app_1, searchView_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.writeLocalSearchHistory = exports.readLocalSearchHistoryState = void 0;
    function readLocalSearchHistoryState() {
        var state;
        try {
            state = JSON.parse(fs.readFileSync(app_1.APP_SEARCH_HISTORY_PATH).toString());
        }
        catch (e) {
            state = searchView_1.initiateSearchHistoryState();
        }
        return state;
    }
    exports.readLocalSearchHistoryState = readLocalSearchHistoryState;
    /**
     * Write keywords to local file
     */
    function writeLocalSearchHistory() {
        var e_1, _a, e_2, _b;
        var keywords = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            keywords[_i] = arguments[_i];
        }
        var searchHistoryState = readLocalSearchHistoryState();
        var kwSet = {};
        try {
            for (var keywords_1 = __values(keywords), keywords_1_1 = keywords_1.next(); !keywords_1_1.done; keywords_1_1 = keywords_1.next()) {
                var k = keywords_1_1.value;
                kwSet[k] = true;
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (keywords_1_1 && !keywords_1_1.done && (_a = keywords_1.return)) _a.call(keywords_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        var kws = __spread(keywords);
        try {
            for (var _c = __values(searchHistoryState.keywords), _d = _c.next(); !_d.done; _d = _c.next()) {
                var k = _d.value;
                // Remove all words which are in kwSet
                if (!kwSet[k]) {
                    kws.push(k);
                    kwSet[k] = true;
                }
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (_d && !_d.done && (_b = _c.return)) _b.call(_c);
            }
            finally { if (e_2) throw e_2.error; }
        }
        searchHistoryState.keywords = kws;
        fs.writeFileSync(app_1.APP_SEARCH_HISTORY_PATH, JSON.stringify(searchHistoryState, null, 4), { encoding: 'utf-8' });
    }
    exports.writeLocalSearchHistory = writeLocalSearchHistory;
});
