define(["require", "exports", "chord/music/common/origin"], function (require, exports, origin_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.getRadioUrl = exports.getPodcastUrl = exports.getEpisodeUrl = exports.getRadioId = exports.getPodcastId = exports.getEpisodeId = exports.OriginRadioUrl = exports.OriginPodcastUrl = exports.OriginEpisodeUrl = void 0;
    var OriginEpisodeUrl;
    (function (OriginEpisodeUrl) {
        // ximalaya url at parser's code
        OriginEpisodeUrl["ximalaya"] = "";
    })(OriginEpisodeUrl = exports.OriginEpisodeUrl || (exports.OriginEpisodeUrl = {}));
    var OriginPodcastUrl;
    (function (OriginPodcastUrl) {
        // no podcast
        OriginPodcastUrl["ximalaya"] = "";
    })(OriginPodcastUrl = exports.OriginPodcastUrl || (exports.OriginPodcastUrl = {}));
    var OriginRadioUrl;
    (function (OriginRadioUrl) {
        OriginRadioUrl["ximalaya"] = "https://www.ximalaya.com/zhubo/{id}";
    })(OriginRadioUrl = exports.OriginRadioUrl || (exports.OriginRadioUrl = {}));
    function getEpisodeId(origin, id) {
        return origin_1.ORIGIN[origin] + "|episode|" + id;
    }
    exports.getEpisodeId = getEpisodeId;
    function getPodcastId(origin, id) {
        return origin_1.ORIGIN[origin] + "|podcast|" + id;
    }
    exports.getPodcastId = getPodcastId;
    function getRadioId(origin, id) {
        return origin_1.ORIGIN[origin] + "|radio|" + id;
    }
    exports.getRadioId = getRadioId;
    function getEpisodeUrl(origin, id) {
        return OriginEpisodeUrl[origin].replace('{id}', id);
    }
    exports.getEpisodeUrl = getEpisodeUrl;
    function getPodcastUrl(origin, id) {
        return OriginPodcastUrl[origin].replace('{id}', id);
    }
    exports.getPodcastUrl = getPodcastUrl;
    function getRadioUrl(origin, id) {
        return OriginRadioUrl[origin].replace('{id}', id);
    }
    exports.getRadioUrl = getRadioUrl;
});
