var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
define(["require", "exports", "chord/music/common/origin", "chord/base/node/crypto", "chord/base/common/lru", "chord/music/core/parser", "chord/base/common/algorithms", "chord/sound/ximalaya/api", "chord/sound/himalaya/api"], function (require, exports, origin_1, crypto_1, lru_1, parser_1, algorithms_1, api_1, api_2) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.soundApi = exports.Sound = void 0;
    var Sound = /** @class */ (function () {
        function Sound() {
            var ximalayaApi = new api_1.XimalayaApi();
            this.ximalayaApi = ximalayaApi;
            var himalayaApi = new api_2.HimalayaApi();
            this.himalayaApi = himalayaApi;
        }
        Sound.prototype.clean = function (origin) {
            switch (origin) {
                case origin_1.ORIGIN.ximalaya:
                    this.ximalayaApi = new api_1.XimalayaApi();
                    break;
                case origin_1.ORIGIN.himalaya:
                    this.himalayaApi = new api_2.HimalayaApi();
                    break;
                default:
                    // Here will never be occured.
                    throw new Error("[ERROR] [Sound.clean] Here will never be occured. [args]: " + origin);
            }
        };
        Sound.prototype.audios = function (episodeId, supKbps) {
            return __awaiter(this, void 0, void 0, function () {
                var h, result, originType, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            h = crypto_1.md5("sound.core.api.audios(" + episodeId + ")");
                            result = lru_1.cache30.get(h);
                            if (result)
                                return [2 /*return*/, result];
                            originType = origin_1.getOrigin(episodeId);
                            _a = originType.origin;
                            switch (_a) {
                                case origin_1.ORIGIN.ximalaya: return [3 /*break*/, 1];
                                case origin_1.ORIGIN.himalaya: return [3 /*break*/, 3];
                            }
                            return [3 /*break*/, 5];
                        case 1: return [4 /*yield*/, this.ximalayaApi.audios(originType.id, supKbps)];
                        case 2:
                            result = _b.sent();
                            return [3 /*break*/, 6];
                        case 3: return [4 /*yield*/, this.himalayaApi.audios(originType.id, supKbps)];
                        case 4:
                            result = _b.sent();
                            return [3 /*break*/, 6];
                        case 5: 
                        // Here will never be occured.
                        throw new Error("[ERROR] [Sound.audio] Here will never be occured. [args]: " + episodeId);
                        case 6:
                            lru_1.cache30.set(h, result);
                            return [2 /*return*/, result];
                    }
                });
            });
        };
        Sound.prototype.episode = function (episodeId) {
            return __awaiter(this, void 0, void 0, function () {
                var h, result, item, originType, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            h = crypto_1.md5("sound.core.api.episode(" + episodeId + ")");
                            result = lru_1.cache12.get(h);
                            result = parser_1.makeItem(result);
                            if (result)
                                return [2 /*return*/, result];
                            originType = origin_1.getOrigin(episodeId);
                            _a = originType.origin;
                            switch (_a) {
                                case origin_1.ORIGIN.ximalaya: return [3 /*break*/, 1];
                                case origin_1.ORIGIN.himalaya: return [3 /*break*/, 3];
                            }
                            return [3 /*break*/, 5];
                        case 1: return [4 /*yield*/, this.ximalayaApi.episode(originType.id)];
                        case 2:
                            item = _b.sent();
                            return [3 /*break*/, 6];
                        case 3: return [4 /*yield*/, this.himalayaApi.episode(originType.id)];
                        case 4:
                            item = _b.sent();
                            return [3 /*break*/, 6];
                        case 5: 
                        // Here will never be occured.
                        throw new Error("[ERROR] [Sound.episode] Here will never be occured. [args]: " + episodeId);
                        case 6:
                            result = parser_1.makeItem(item);
                            lru_1.cache12.set(h, result);
                            return [2 /*return*/, result];
                    }
                });
            });
        };
        Sound.prototype.podcast = function (podcastId) {
            return __awaiter(this, void 0, void 0, function () {
                var h, result, item, originType, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            h = crypto_1.md5("sound.core.api.podcast(" + podcastId + ")");
                            result = lru_1.cache12.get(h);
                            result = parser_1.makeItem(result);
                            if (result)
                                return [2 /*return*/, result];
                            originType = origin_1.getOrigin(podcastId);
                            _a = originType.origin;
                            switch (_a) {
                                case origin_1.ORIGIN.ximalaya: return [3 /*break*/, 1];
                                case origin_1.ORIGIN.himalaya: return [3 /*break*/, 3];
                            }
                            return [3 /*break*/, 5];
                        case 1: return [4 /*yield*/, this.ximalayaApi.podcast(originType.id)];
                        case 2:
                            item = _b.sent();
                            return [3 /*break*/, 6];
                        case 3: return [4 /*yield*/, this.himalayaApi.podcast(originType.id)];
                        case 4:
                            item = _b.sent();
                            return [3 /*break*/, 6];
                        case 5: 
                        // Here will never be occured.
                        throw new Error("[ERROR] [Sound.podcast] Here will never be occured. [args]: " + podcastId);
                        case 6:
                            result = parser_1.makeItem(item);
                            lru_1.cache12.set(h, result);
                            return [2 /*return*/, result];
                    }
                });
            });
        };
        Sound.prototype.podcastEpisodeCount = function (podcastId) {
            return __awaiter(this, void 0, void 0, function () {
                var h, result, item, originType, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            h = crypto_1.md5("sound.core.api.podcastEpisodeCount(" + podcastId + ")");
                            result = lru_1.cache12.get(h);
                            if (result)
                                return [2 /*return*/, result];
                            originType = origin_1.getOrigin(podcastId);
                            _a = originType.origin;
                            switch (_a) {
                                case origin_1.ORIGIN.ximalaya: return [3 /*break*/, 1];
                                case origin_1.ORIGIN.himalaya: return [3 /*break*/, 3];
                            }
                            return [3 /*break*/, 5];
                        case 1: return [4 /*yield*/, this.ximalayaApi.podcastEpisodeCount(originType.id)];
                        case 2:
                            item = _b.sent();
                            return [3 /*break*/, 6];
                        case 3: return [4 /*yield*/, this.himalayaApi.podcastEpisodeCount(originType.id)];
                        case 4:
                            item = _b.sent();
                            return [3 /*break*/, 6];
                        case 5: 
                        // Here will never be occured.
                        throw new Error("[ERROR] [Sound.podcastPages] Here will never be occured. [args]: " + podcastId);
                        case 6:
                            result = item;
                            lru_1.cache12.set(h, result);
                            return [2 /*return*/, result];
                    }
                });
            });
        };
        Sound.prototype.podcastEpisodes = function (podcastId, params, offset, limit) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var h, result, item, originType, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            h = crypto_1.md5("sound.core.api.podcastEpisodes(" + podcastId + ", " + JSON.stringify(params) + ", " + offset + ", " + limit + ")");
                            result = lru_1.cache12.get(h);
                            result = parser_1.makeItems(result);
                            if (result)
                                return [2 /*return*/, result];
                            originType = origin_1.getOrigin(podcastId);
                            _a = originType.origin;
                            switch (_a) {
                                case origin_1.ORIGIN.ximalaya: return [3 /*break*/, 1];
                                case origin_1.ORIGIN.himalaya: return [3 /*break*/, 3];
                            }
                            return [3 /*break*/, 5];
                        case 1: return [4 /*yield*/, this.ximalayaApi.podcastEpisodes(originType.id, offset + 1, params.order || '1')];
                        case 2:
                            item = _b.sent();
                            return [3 /*break*/, 6];
                        case 3: return [4 /*yield*/, this.himalayaApi.podcastEpisodes(originType.id, offset + 1, limit, params.order || '1')];
                        case 4:
                            item = _b.sent();
                            return [3 /*break*/, 6];
                        case 5: 
                        // Here will never be occured.
                        throw new Error("[ERROR] [Sound.podcastEpisodes] Here will never be occured. [args]: " + podcastId + ", " + JSON.stringify(params) + ", " + offset + ", " + limit);
                        case 6:
                            result = parser_1.makeItems(item);
                            lru_1.cache12.set(h, result);
                            return [2 /*return*/, result];
                    }
                });
            });
        };
        Sound.prototype.radio = function (radioId) {
            return __awaiter(this, void 0, void 0, function () {
                var h, result, item, originType, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            h = crypto_1.md5("sound.core.api.radio(" + radioId + ")");
                            result = lru_1.cache12.get(h);
                            result = parser_1.makeItem(result);
                            if (result)
                                return [2 /*return*/, result];
                            originType = origin_1.getOrigin(radioId);
                            _a = originType.origin;
                            switch (_a) {
                                case origin_1.ORIGIN.ximalaya: return [3 /*break*/, 1];
                                case origin_1.ORIGIN.himalaya: return [3 /*break*/, 3];
                            }
                            return [3 /*break*/, 4];
                        case 1: return [4 /*yield*/, this.ximalayaApi.radio(originType.id)];
                        case 2:
                            item = _b.sent();
                            return [3 /*break*/, 5];
                        case 3: return [2 /*return*/, null];
                        case 4: 
                        // Here will never be occured.
                        throw new Error("[ERROR] [Sound.radio] Here will never be occured. [args]: " + radioId);
                        case 5:
                            result = parser_1.makeItem(item);
                            lru_1.cache12.set(h, result);
                            return [2 /*return*/, result];
                    }
                });
            });
        };
        Sound.prototype.radioEpisodeCount = function (radioId, params) {
            return __awaiter(this, void 0, void 0, function () {
                var h, result, item, originType, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            h = crypto_1.md5("sound.core.api.radioEpisodeCount(" + radioId + ", " + JSON.stringify(params) + ")");
                            result = lru_1.cache12.get(h);
                            if (result)
                                return [2 /*return*/, result];
                            originType = origin_1.getOrigin(radioId);
                            _a = originType.origin;
                            switch (_a) {
                                case origin_1.ORIGIN.ximalaya: return [3 /*break*/, 1];
                            }
                            return [3 /*break*/, 3];
                        case 1: return [4 /*yield*/, this.ximalayaApi.radioEpisodeCount(originType.id, params.keyword || '')];
                        case 2:
                            item = _b.sent();
                            return [3 /*break*/, 4];
                        case 3: 
                        // Here will never be occured.
                        throw new Error("[ERROR] [Sound.radioEpisodeCount] Here will never be occured. [args]: " + radioId + ", " + JSON.stringify(params));
                        case 4:
                            result = item;
                            lru_1.cache12.set(h, result);
                            return [2 /*return*/, result];
                    }
                });
            });
        };
        Sound.prototype.radioEpisodes = function (radioId, params, offset, limit) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var h, result, items, originType, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            h = crypto_1.md5("sound.core.api.radioEpisodes(" + radioId + ", " + JSON.stringify(params) + ", " + offset + ", " + limit + ")");
                            result = lru_1.cache12.get(h);
                            result = parser_1.makeItems(result);
                            if (result)
                                return [2 /*return*/, result];
                            originType = origin_1.getOrigin(radioId);
                            _a = originType.origin;
                            switch (_a) {
                                case origin_1.ORIGIN.ximalaya: return [3 /*break*/, 1];
                            }
                            return [3 /*break*/, 3];
                        case 1: return [4 /*yield*/, this.ximalayaApi.radioEpisodes(originType.id, offset + 1, limit, params.order, params.keyword)];
                        case 2:
                            items = _b.sent();
                            return [3 /*break*/, 4];
                        case 3: 
                        // Here will never be occured.
                        throw new Error("[ERROR] [Sound.radioEpisodes] Here will never be occured. [args]: " + radioId + ", " + JSON.stringify(params) + ", " + offset + ", " + limit);
                        case 4:
                            result = parser_1.makeItems(items);
                            lru_1.cache12.set(h, result);
                            return [2 /*return*/, result];
                    }
                });
            });
        };
        Sound.prototype.radioFavoritePodcastCount = function (radioId, params) {
            return __awaiter(this, void 0, void 0, function () {
                var h, result, item, originType, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            h = crypto_1.md5("sound.core.api.radioFavoritePodcastCount(" + radioId + ", " + JSON.stringify(params) + ")");
                            result = lru_1.cache12.get(h);
                            if (result)
                                return [2 /*return*/, result];
                            originType = origin_1.getOrigin(radioId);
                            _a = originType.origin;
                            switch (_a) {
                                case origin_1.ORIGIN.ximalaya: return [3 /*break*/, 1];
                            }
                            return [3 /*break*/, 3];
                        case 1: return [4 /*yield*/, this.ximalayaApi.radioFavoritePodcastCount(originType.id, params.keyword)];
                        case 2:
                            item = _b.sent();
                            return [3 /*break*/, 4];
                        case 3: 
                        // Here will never be occured.
                        throw new Error("[ERROR] [Sound.radioFavoritePodcastCount] Here will never be occured. [args]: " + radioId + ", " + JSON.stringify(params));
                        case 4:
                            result = item;
                            lru_1.cache12.set(h, result);
                            return [2 /*return*/, result];
                    }
                });
            });
        };
        Sound.prototype.radioFavoritePodcasts = function (radioId, params, offset, limit) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var h, result, items, originType, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            h = crypto_1.md5("sound.core.api.radioFavoritePodcasts(" + radioId + ", " + JSON.stringify(params) + ", " + offset + ", " + limit + ")");
                            result = lru_1.cache12.get(h);
                            result = parser_1.makeItems(result);
                            if (result)
                                return [2 /*return*/, result];
                            originType = origin_1.getOrigin(radioId);
                            _a = originType.origin;
                            switch (_a) {
                                case origin_1.ORIGIN.ximalaya: return [3 /*break*/, 1];
                            }
                            return [3 /*break*/, 3];
                        case 1: return [4 /*yield*/, this.ximalayaApi.radioFavoritePodcasts(originType.id, offset + 1, limit, params.order, params.keyword)];
                        case 2:
                            items = _b.sent();
                            return [3 /*break*/, 4];
                        case 3: 
                        // Here will never be occured.
                        throw new Error("[ERROR] [Sound.radioFavoritePodcasts] Here will never be occured. [args]: " + radioId + ", " + JSON.stringify(params) + ", " + offset + ", " + limit);
                        case 4:
                            result = parser_1.makeItems(items);
                            lru_1.cache12.set(h, result);
                            return [2 /*return*/, result];
                    }
                });
            });
        };
        Sound.prototype.radioPodcastCount = function (radioId, params) {
            return __awaiter(this, void 0, void 0, function () {
                var h, result, item, originType, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            h = crypto_1.md5("sound.core.api.radioPodcastCount(" + radioId + ", " + JSON.stringify(params) + ")");
                            result = lru_1.cache12.get(h);
                            if (result)
                                return [2 /*return*/, result];
                            originType = origin_1.getOrigin(radioId);
                            _a = originType.origin;
                            switch (_a) {
                                case origin_1.ORIGIN.ximalaya: return [3 /*break*/, 1];
                            }
                            return [3 /*break*/, 3];
                        case 1: return [4 /*yield*/, this.ximalayaApi.radioPodcastCount(originType.id, params.keyword)];
                        case 2:
                            item = _b.sent();
                            return [3 /*break*/, 4];
                        case 3: 
                        // Here will never be occured.
                        throw new Error("[ERROR] [Sound.radioPodcastCount] Here will never be occured. [args]: " + radioId + ", " + JSON.stringify(params));
                        case 4:
                            result = item;
                            lru_1.cache12.set(h, result);
                            return [2 /*return*/, result];
                    }
                });
            });
        };
        Sound.prototype.radioPodcasts = function (radioId, params, offset, limit) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var h, result, items, originType, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            h = crypto_1.md5("sound.core.api.radioPodcasts(" + radioId + ", " + JSON.stringify(params) + ", " + offset + ", " + limit + ")");
                            result = lru_1.cache12.get(h);
                            result = parser_1.makeItems(result);
                            if (result)
                                return [2 /*return*/, result];
                            originType = origin_1.getOrigin(radioId);
                            _a = originType.origin;
                            switch (_a) {
                                case origin_1.ORIGIN.ximalaya: return [3 /*break*/, 1];
                            }
                            return [3 /*break*/, 3];
                        case 1: return [4 /*yield*/, this.ximalayaApi.radioPodcasts(originType.id, offset + 1, limit, params.order, params.keyword)];
                        case 2:
                            items = _b.sent();
                            return [3 /*break*/, 4];
                        case 3: 
                        // Here will never be occured.
                        throw new Error("[ERROR] [Sound.radioPodcasts] Here will never be occured. [args]: " + radioId + ", " + JSON.stringify(params) + ", " + offset + ", " + limit);
                        case 4:
                            result = parser_1.makeItems(items);
                            lru_1.cache12.set(h, result);
                            return [2 /*return*/, result];
                    }
                });
            });
        };
        Sound.prototype.radioFollowerCount = function (radioId) {
            return __awaiter(this, void 0, void 0, function () {
                var h, result, item, originType, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            h = crypto_1.md5("sound.core.api.radioFollowerCount(" + radioId + ")");
                            result = lru_1.cache12.get(h);
                            if (result)
                                return [2 /*return*/, result];
                            originType = origin_1.getOrigin(radioId);
                            _a = originType.origin;
                            switch (_a) {
                                case origin_1.ORIGIN.ximalaya: return [3 /*break*/, 1];
                            }
                            return [3 /*break*/, 3];
                        case 1: return [4 /*yield*/, this.ximalayaApi.radioFollowerCount(originType.id)];
                        case 2:
                            item = _b.sent();
                            return [3 /*break*/, 4];
                        case 3: 
                        // Here will never be occured.
                        throw new Error("[ERROR] [Sound.radioFollowerCount] Here will never be occured. [args]: " + radioId);
                        case 4:
                            result = item;
                            lru_1.cache12.set(h, result);
                            return [2 /*return*/, result];
                    }
                });
            });
        };
        Sound.prototype.radioFollowers = function (radioId, offset, limit) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var h, result, items, originType, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            h = crypto_1.md5("sound.core.api.radioFollowers(" + radioId + ", " + offset + ", " + limit + ")");
                            result = lru_1.cache12.get(h);
                            result = parser_1.makeItems(result);
                            if (result)
                                return [2 /*return*/, result];
                            originType = origin_1.getOrigin(radioId);
                            _a = originType.origin;
                            switch (_a) {
                                case origin_1.ORIGIN.ximalaya: return [3 /*break*/, 1];
                            }
                            return [3 /*break*/, 3];
                        case 1: return [4 /*yield*/, this.ximalayaApi.radioFollowers(originType.id, offset + 1, limit)];
                        case 2:
                            items = _b.sent();
                            return [3 /*break*/, 4];
                        case 3: 
                        // Here will never be occured.
                        throw new Error("[ERROR] [Sound.radioFollowers] Here will never be occured. [args]: " + radioId + ", " + offset + ", " + limit);
                        case 4:
                            result = parser_1.makeItems(items);
                            lru_1.cache12.set(h, result);
                            return [2 /*return*/, result];
                    }
                });
            });
        };
        Sound.prototype.radioFollowingCount = function (radioId) {
            return __awaiter(this, void 0, void 0, function () {
                var h, result, item, originType, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            h = crypto_1.md5("sound.core.api.radioFollowingCount(" + radioId + ")");
                            result = lru_1.cache12.get(h);
                            if (result)
                                return [2 /*return*/, result];
                            originType = origin_1.getOrigin(radioId);
                            _a = originType.origin;
                            switch (_a) {
                                case origin_1.ORIGIN.ximalaya: return [3 /*break*/, 1];
                            }
                            return [3 /*break*/, 3];
                        case 1: return [4 /*yield*/, this.ximalayaApi.radioFollowingCount(originType.id)];
                        case 2:
                            item = _b.sent();
                            return [3 /*break*/, 4];
                        case 3: 
                        // Here will never be occured.
                        throw new Error("[ERROR] [Sound.radioFollowingCount] Here will never be occured. [args]: " + radioId);
                        case 4:
                            result = item;
                            lru_1.cache12.set(h, result);
                            return [2 /*return*/, result];
                    }
                });
            });
        };
        Sound.prototype.radioFollowings = function (radioId, offset, limit) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var h, result, items, originType, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            h = crypto_1.md5("sound.core.api.radioFollowings(" + radioId + ", " + offset + ", " + limit + ")");
                            result = lru_1.cache12.get(h);
                            result = parser_1.makeItems(result);
                            if (result)
                                return [2 /*return*/, result];
                            originType = origin_1.getOrigin(radioId);
                            _a = originType.origin;
                            switch (_a) {
                                case origin_1.ORIGIN.ximalaya: return [3 /*break*/, 1];
                            }
                            return [3 /*break*/, 3];
                        case 1: return [4 /*yield*/, this.ximalayaApi.radioFollowings(originType.id, offset + 1, limit)];
                        case 2:
                            items = _b.sent();
                            return [3 /*break*/, 4];
                        case 3: 
                        // Here will never be occured.
                        throw new Error("[ERROR] [Sound.radioFollowings] Here will never be occured. [args]: " + radioId + ", " + offset + ", " + limit);
                        case 4:
                            result = parser_1.makeItems(items);
                            lru_1.cache12.set(h, result);
                            return [2 /*return*/, result];
                    }
                });
            });
        };
        Sound.prototype.podcastListOptions = function (origin) {
            return __awaiter(this, void 0, void 0, function () {
                var h, result, item, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            h = crypto_1.md5("sound.core.api.podcastListOptions(" + origin + ")");
                            result = lru_1.cache12.get(h);
                            if (result)
                                return [2 /*return*/, result];
                            _a = origin;
                            switch (_a) {
                                case origin_1.ORIGIN.ximalaya: return [3 /*break*/, 1];
                            }
                            return [3 /*break*/, 3];
                        case 1: return [4 /*yield*/, this.ximalayaApi.podcastListOptions()];
                        case 2:
                            item = _b.sent();
                            return [3 /*break*/, 4];
                        case 3: 
                        // Here will never be occured.
                        throw new Error("[ERROR] [Sound.podcastListOptions] Here will never be occured. [args]: " + origin);
                        case 4:
                            result = item;
                            lru_1.cache12.set(h, result);
                            return [2 /*return*/, result];
                    }
                });
            });
        };
        Sound.prototype.podcastOptionSubs = function (origin, params) {
            return __awaiter(this, void 0, void 0, function () {
                var h, result, item, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            h = crypto_1.md5("sound.core.api.podcastOptionSubs(" + origin + ", " + JSON.stringify(params) + ")");
                            result = lru_1.cache12.get(h);
                            if (result)
                                return [2 /*return*/, result];
                            _a = origin;
                            switch (_a) {
                                case origin_1.ORIGIN.ximalaya: return [3 /*break*/, 1];
                            }
                            return [3 /*break*/, 3];
                        case 1: return [4 /*yield*/, this.ximalayaApi.podcastOptionSubs(params.category, params.subCategory)];
                        case 2:
                            item = _b.sent();
                            return [3 /*break*/, 4];
                        case 3: 
                        // Here will never be occured.
                        throw new Error("[ERROR] [Sound.podcastOptionSubs] Here will never be occured. [args]: " + origin + ", " + JSON.stringify(params));
                        case 4:
                            result = item;
                            lru_1.cache12.set(h, result);
                            return [2 /*return*/, result];
                    }
                });
            });
        };
        Sound.prototype.podcastListCount = function (origin, params) {
            return __awaiter(this, void 0, void 0, function () {
                var h, result, item, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            h = crypto_1.md5("sound.core.api.podcastListCount(" + origin + ", " + JSON.stringify(params) + ")");
                            result = lru_1.cache12.get(h);
                            if (result)
                                return [2 /*return*/, result];
                            _a = origin;
                            switch (_a) {
                                case origin_1.ORIGIN.ximalaya: return [3 /*break*/, 1];
                            }
                            return [3 /*break*/, 3];
                        case 1: return [4 /*yield*/, this.ximalayaApi.podcastListCount(params.category, params.subCategory, params.meta)];
                        case 2:
                            item = _b.sent();
                            return [3 /*break*/, 4];
                        case 3: 
                        // Here will never be occured.
                        throw new Error("[ERROR] [Sound.podcastListCount] Here will never be occured. [args]: " + origin + ", " + JSON.stringify(params));
                        case 4:
                            result = item;
                            lru_1.cache12.set(h, result);
                            return [2 /*return*/, result];
                    }
                });
            });
        };
        Sound.prototype.podcastList = function (origin, params, offset, limit) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var h, result, items, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            h = crypto_1.md5("sound.core.api.podcastList(" + origin + ", " + JSON.stringify(params) + ", " + offset + ", " + limit + ")");
                            result = lru_1.cache12.get(h);
                            result = parser_1.makeItems(result);
                            if (result)
                                return [2 /*return*/, result];
                            _a = origin;
                            switch (_a) {
                                case origin_1.ORIGIN.ximalaya: return [3 /*break*/, 1];
                            }
                            return [3 /*break*/, 3];
                        case 1: return [4 /*yield*/, this.ximalayaApi.podcastList(params.category, params.subCategory, params.meta, params.sort, offset + 1, limit)];
                        case 2:
                            items = _b.sent();
                            return [3 /*break*/, 4];
                        case 3: 
                        // Here will never be occured.
                        throw new Error("[ERROR] [Sound.podcastList] Here will never be occured. [args]: " + origin + ", " + offset + ", " + limit + ", " + JSON.stringify(params));
                        case 4:
                            result = parser_1.makeItems(items);
                            lru_1.cache12.set(h, result);
                            return [2 /*return*/, result];
                    }
                });
            });
        };
        Sound.prototype.searchEpisodes = function (keyword, offset, limit) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var h, result, list, items;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            h = crypto_1.md5("sound.core.api.searchEpisodes(" + keyword + ", " + offset + ", " + limit + ")");
                            result = lru_1.cache12.get(h);
                            result = parser_1.makeItems(result);
                            if (result)
                                return [2 /*return*/, result];
                            return [4 /*yield*/, Promise.all([
                                    this.ximalayaApi.searchEpisodes(keyword, offset + 1, limit),
                                    this.himalayaApi.searchEpisodes(keyword, offset + 1, limit),
                                ])];
                        case 1:
                            list = _a.sent();
                            items = algorithms_1.insertMerge(list);
                            result = parser_1.makeItems(items);
                            lru_1.cache12.set(h, result);
                            return [2 /*return*/, result];
                    }
                });
            });
        };
        Sound.prototype.searchPodcasts = function (keyword, offset, limit) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var h, result, list, items;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            h = crypto_1.md5("sound.core.api.searchPodcasts(" + keyword + ", " + offset + ", " + limit + ")");
                            result = lru_1.cache12.get(h);
                            result = parser_1.makeItems(result);
                            if (result)
                                return [2 /*return*/, result];
                            return [4 /*yield*/, Promise.all([
                                    this.ximalayaApi.searchPodcasts(keyword, offset + 1, limit),
                                    this.himalayaApi.searchPodcasts(keyword, offset + 1, limit),
                                ])];
                        case 1:
                            list = _a.sent();
                            items = algorithms_1.insertMerge(list);
                            result = parser_1.makeItems(items);
                            lru_1.cache12.set(h, result);
                            return [2 /*return*/, result];
                    }
                });
            });
        };
        Sound.prototype.searchRadios = function (keyword, offset, limit) {
            if (offset === void 0) { offset = 0; }
            if (limit === void 0) { limit = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var h, result, list, items;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            h = crypto_1.md5("sound.core.api.searchRadios(" + keyword + ", " + offset + ", " + limit + ")");
                            result = lru_1.cache12.get(h);
                            result = parser_1.makeItems(result);
                            if (result)
                                return [2 /*return*/, result];
                            return [4 /*yield*/, Promise.all([
                                    this.ximalayaApi.searchRadios(keyword, offset + 1, limit)
                                ])];
                        case 1:
                            list = _a.sent();
                            items = algorithms_1.insertMerge(list);
                            result = parser_1.makeItems(items);
                            lru_1.cache12.set(h, result);
                            return [2 /*return*/, result];
                    }
                });
            });
        };
        Sound.prototype.playLog = function (episodeId, seek) {
            return __awaiter(this, void 0, void 0, function () {
                var result, originType;
                return __generator(this, function (_a) {
                    originType = origin_1.getOrigin(episodeId);
                    switch (originType.origin) {
                        case origin_1.ORIGIN.qianqian:
                        case origin_1.ORIGIN.ximalaya:
                            break;
                        default:
                            // Here will never be occured.
                            throw new Error("[ERROR] [Sound.playLog] Here will never be occured. [args]: " + episodeId + " " + seek);
                    }
                    return [2 /*return*/, result];
                });
            });
        };
        Sound.prototype.resizeImageUrl = function (origin, url, limit) {
            var item;
            switch (origin) {
                case origin_1.ORIGIN.ximalaya:
                    item = this.ximalayaApi.resizeImageUrl(url, limit);
                    break;
                case origin_1.ORIGIN.himalaya:
                    item = this.himalayaApi.resizeImageUrl(url, limit);
                    break;
                default:
                    // Here will never be occured.
                    throw new Error("[ERROR] [Sound.resizeImageUrl] Here will never be occured. [args]: " + origin + ", " + url + ", " + limit);
            }
            return item;
        };
        Sound.prototype.fromURL = function (input) {
            return __awaiter(this, void 0, void 0, function () {
                var h, result, futs, chunks, chunks_1, chunks_1_1, chunk, list;
                var e_1, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            h = crypto_1.md5("sound.core.api.fromURL(" + input + ")");
                            result = lru_1.cache12.get(h);
                            result = parser_1.makeItems(result);
                            if (result)
                                return [2 /*return*/, result];
                            futs = [];
                            chunks = input.split(' ');
                            try {
                                for (chunks_1 = __values(chunks), chunks_1_1 = chunks_1.next(); !chunks_1_1.done; chunks_1_1 = chunks_1.next()) {
                                    chunk = chunks_1_1.value;
                                    if (chunk.includes('ximalaya')) {
                                        futs.push(this.ximalayaApi.fromURL(chunk));
                                    }
                                    if (chunk.includes('himalaya')) {
                                        futs.push(this.himalayaApi.fromURL(chunk));
                                    }
                                }
                            }
                            catch (e_1_1) { e_1 = { error: e_1_1 }; }
                            finally {
                                try {
                                    if (chunks_1_1 && !chunks_1_1.done && (_a = chunks_1.return)) _a.call(chunks_1);
                                }
                                finally { if (e_1) throw e_1.error; }
                            }
                            if (futs.length == 0)
                                return [2 /*return*/, []];
                            return [4 /*yield*/, Promise.all(futs)];
                        case 1:
                            list = _b.sent();
                            result = parser_1.makeItems([].concat.apply([], __spread(list)));
                            lru_1.cache12.set(h, result);
                            return [2 /*return*/, result];
                    }
                });
            });
        };
        return Sound;
    }());
    exports.Sound = Sound;
    exports.soundApi = new Sound();
});
