var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
define(["require", "exports", "chord/base/common/time", "chord/sound/common/origin", "chord/base/node/url", "chord/sound/ximalaya/crypto"], function (require, exports, time_1, origin_1, url_1, crypto_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.makePodcastOptionSubs = exports.makePodcastListOptions = exports.makeRadios = exports.makeRadio = exports.makePodcasts = exports.makePodcast = exports.makeEpisodes = exports.makeEpisode = exports.makeAudio = exports.makeDemoAudio = void 0;
    var _origin = 'ximalaya';
    var _getEpisodeId = origin_1.getEpisodeId.bind(null, _origin);
    var _getPodcastId = origin_1.getPodcastId.bind(null, _origin);
    var _getRadioId = origin_1.getRadioId.bind(null, _origin);
    var _getRadioUrl = origin_1.getRadioUrl.bind(null, _origin);
    var DOMAIN = 'https://www.ximalaya.com';
    var IMG_DOMAIN = 'http://imagev2.xmcdn.com';
    function _makeAudio(url) {
        return {
            url: url,
            kbps: 64,
            format: 'm4a',
            size: 1,
        };
    }
    function makeDemoAudio(info) {
        var url = crypto_1.getDemoAudioUrl(info);
        if (!url)
            return null;
        return _makeAudio(url);
    }
    exports.makeDemoAudio = makeDemoAudio;
    function makeAudio(url) {
        if (!url)
            return null;
        return _makeAudio(url);
    }
    exports.makeAudio = makeAudio;
    function makeEpisode(info) {
        var episodeInfo = info['trackInfo'] || info;
        var podcastInfo = info['albumInfo'] || info;
        var radioInfo = info['userInfo'] || info;
        var episodeOriginalId = (episodeInfo['trackId'] || info['id']).toString();
        var episodeName = episodeInfo['title'] || episodeInfo['trackName'];
        var url = DOMAIN + (episodeInfo['link'] || episodeInfo['trackUrl'] || episodeInfo['url']);
        var t = url.split('/').slice(-2)[0];
        var podcastOriginalId = (podcastInfo['albumId'] || info['album_id'] || t).toString();
        var podcastName = podcastInfo['albumId'] ? (podcastInfo['title'] || info['albumTitle']) : podcastInfo['albumName'] || info['album_title'];
        var podcastCoverUrl = podcastInfo['coverPath'] || podcastInfo['trackCoverPath'] || info['cover_path'];
        podcastCoverUrl = podcastCoverUrl ? url_1.getAbsolutUrl(podcastCoverUrl, IMG_DOMAIN) : null;
        var radioOriginalId = radioInfo['uid'] || radioInfo['anchorId'] || radioInfo['anchorUid'];
        radioOriginalId = radioOriginalId ? radioOriginalId.toString() : null;
        var radioName = radioInfo['nickname'];
        var radioCoverUrl = url_1.getAbsolutUrl(radioInfo['coverPath'] || info['cover'] || info['logoPic'], IMG_DOMAIN);
        var lyricUrl = episodeInfo['lyric'];
        var tags = info['tags'] ? info['tags'].split(',').map(function (name) { return ({ name: name, id: null }); }) : null;
        var duration = episodeInfo['duration'] ? episodeInfo['duration'] * 1000
            : episodeInfo['durationAsString'] ? time_1.parseToMillisecond(episodeInfo['durationAsString']) : null;
        var audio = makeAudio(episodeInfo['src']);
        var audios = audio ? [audio] : [];
        if (info['play_path_64']) {
            audio = makeAudio(episodeInfo['play_path_64']);
            audio.kbps = 64;
            audios.push(audio);
        }
        if (info['play_path_32']) {
            audio = makeAudio(episodeInfo['play_path_32']);
            audio.kbps = 32;
            audios.push(audio);
        }
        var releaseDate = episodeInfo['lastUpdate'] ? Date.parse(episodeInfo['lastUpdate'])
            : info['updated_at'] ? info['updated_at']
                : episodeInfo['updateTime'] || episodeInfo['createTime'] || episodeInfo['createDateFormat'] || info['createTimeAsString'];
        var episode = {
            episodeId: _getEpisodeId(episodeOriginalId),
            type: 'episode',
            origin: _origin,
            episodeOriginalId: episodeOriginalId,
            url: url,
            episodeName: episodeName,
            podcastId: _getPodcastId(podcastOriginalId),
            podcastOriginalId: podcastOriginalId,
            podcastName: podcastName,
            podcastCoverUrl: podcastCoverUrl,
            radioId: _getRadioId(radioOriginalId),
            radioOriginalId: radioOriginalId,
            radioName: radioName,
            radioCoverUrl: radioCoverUrl,
            description: episodeInfo['richIntro'] || episodeInfo['intro'],
            composer: episodeInfo['compose'],
            tags: tags,
            lyricUrl: lyricUrl,
            track: episodeInfo['index'] ? episodeInfo['index'] - 1 : null,
            // millisecond
            duration: duration,
            // millisecond
            releaseDate: releaseDate,
            playCountWeb: episodeInfo['playCount'] || info['count_play'] || null,
            playCount: 0,
            likeCount: info['count_like'],
            audios: audios,
        };
        return episode;
    }
    exports.makeEpisode = makeEpisode;
    function makeEpisodes(info) {
        return (info || []).map(function (episodeInfo) { return makeEpisode(episodeInfo); });
    }
    exports.makeEpisodes = makeEpisodes;
    function makePodcast(info) {
        var podcastInfo = info['mainInfo'] || info;
        var radioInfo = info['anchorInfo'] || info['anchor'] || info;
        var episodeListInfo = info['tracksInfo'] || info;
        var metas = podcastInfo['metas'] || info;
        var podcastOriginalId = (podcastInfo['albumId'] || info['albumId'] || info['id']).toString();
        var podcastId = _getPodcastId(podcastOriginalId);
        var podcastName = podcastInfo['albumTitle'] || info['title'];
        var podcastCoverUrl = podcastInfo['cover'] || podcastInfo['coverPath'] || info['cover_path'];
        podcastCoverUrl = podcastCoverUrl ? url_1.getAbsolutUrl(podcastCoverUrl.split('!')[0], IMG_DOMAIN) : null;
        var radioOriginalId = (radioInfo['anchorId'] || radioInfo['anchorUid'] || radioInfo['uid']).toString();
        var radioId = _getRadioId(radioOriginalId);
        var radioName = radioInfo['anchorName'] || radioInfo['anchorNickName'] || radioInfo['nickname'];
        var tags = info['tags'] ? info['tags'].split(',').map(function (name) { return ({ name: name, id: null }); }) : null;
        var category = metas[0] ? metas[0]['categoryName'] : null;
        var url = category ? (DOMAIN + '/' + category + '/' + podcastOriginalId)
            : info['albumUrl'] ? (DOMAIN + info['albumUrl'])
                : info['url'] ? (DOMAIN + info['url'])
                    : info['link'] ? (DOMAIN + info['link']) : null;
        // let episodeList = episodeListInfo['tracks']; // 'tracks' can be number
        // let episodes = (episodeList && episodeList.length) ? (episodeList || []).map(j => {
        //     let episode = makeEpisode(j);
        //     episode = {
        //         ...episode,
        //         url: url + '/' + episode.episodeOriginalId,
        //         podcastOriginalId,
        //         podcastId,
        //         podcastName,
        //         podcastCoverUrl,
        //         radioOriginalId,
        //         radioId: radioId,
        //         radioName: radioName,
        //     };
        //     return episode;
        // }) : [];
        var podcast = {
            podcastId: podcastId,
            type: 'podcast',
            origin: _origin,
            podcastOriginalId: podcastOriginalId,
            url: url,
            podcastName: podcastName,
            podcastCoverUrl: podcastCoverUrl,
            radioId: radioId,
            radioName: radioName,
            description: podcastInfo['richIntro'] || podcastInfo['description'] || info['intro'],
            tags: tags,
            releaseDate: Date.parse(podcastInfo['updateDate']) || info['updated_at'] || 0,
            episodes: [],
            episodeCount: episodeListInfo['trackTotalCount'] || info['trackCount'] || info['tracks'],
            playCount: podcastInfo['playCount'] || info['play'],
            likeCount: null,
        };
        return podcast;
    }
    exports.makePodcast = makePodcast;
    function makePodcasts(info) {
        return (info || []).map(function (episodeInfo) { return makePodcast(episodeInfo); });
    }
    exports.makePodcasts = makePodcasts;
    function makeRadio(info) {
        var radioOriginalId = info['uid'].toString();
        var radioCoverUrl = url_1.getAbsolutUrl(info['cover'] || info['logoPic'] || info['coverPath'], IMG_DOMAIN);
        var radioName = info['nickName'] || info['anchorNickName'] || info['nickname'];
        var followerCount = info['fansCount'] || info['followers_counts'] || info['followerCount'];
        var followingCount = info['followingCount'] || info['followings_counts'];
        var url = _getRadioUrl(radioOriginalId);
        var radio = {
            radioId: _getRadioId(radioOriginalId),
            type: 'radio',
            origin: _origin,
            radioOriginalId: radioOriginalId,
            url: url,
            radioName: radioName,
            radioCoverUrl: radioCoverUrl,
            followerCount: followerCount,
            followingCount: followingCount,
            episodeCount: info['tracks_counts'] || info['trackCount'],
            podcastCount: info['album_counts'] || info['albumCount'],
            description: info['personalSignature'] || info['description'],
        };
        return radio;
    }
    exports.makeRadio = makeRadio;
    function makeRadios(info) {
        return (info || []).map(function (radio) { return makeRadio(radio); });
    }
    exports.makeRadios = makeRadios;
    function makePodcastListOptions(info) {
        var e_1, _a, e_2, _b;
        var options = [];
        try {
            for (var info_1 = __values(info), info_1_1 = info_1.next(); !info_1_1.done; info_1_1 = info_1.next()) {
                var i = info_1_1.value;
                try {
                    for (var _c = (e_2 = void 0, __values(i.categories)), _d = _c.next(); !_d.done; _d = _c.next()) {
                        var category = _d.value;
                        var option = {
                            id: category.id,
                            name: category.displayName,
                            type: category.name,
                            items: category.subcategories.map(function (subInfo) { return ({
                                id: subInfo.id,
                                name: subInfo.displayValue,
                                type: subInfo.code,
                                items: [],
                                info: {
                                    metaId: subInfo.metadataId,
                                    metaValue: subInfo.metadataValue,
                                    // this is category.id
                                    category: subInfo.categoryId,
                                },
                            }); }),
                        };
                        options.push(option);
                    }
                }
                catch (e_2_1) { e_2 = { error: e_2_1 }; }
                finally {
                    try {
                        if (_d && !_d.done && (_b = _c.return)) _b.call(_c);
                    }
                    finally { if (e_2) throw e_2.error; }
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (info_1_1 && !info_1_1.done && (_a = info_1.return)) _a.call(info_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return options;
    }
    exports.makePodcastListOptions = makePodcastListOptions;
    function makePodcastOptionSubs(info) {
        var e_3, _a;
        var options = [];
        var list = __spread(info.currentSubcategory.metas, info.metadata);
        try {
            for (var list_1 = __values(list), list_1_1 = list_1.next(); !list_1_1.done; list_1_1 = list_1.next()) {
                var meta = list_1_1.value;
                var option = {
                    id: meta.id,
                    name: meta.name,
                    type: 'meta',
                    items: meta.metaValues.map(function (val) { return ({
                        id: val.id,
                        name: val.name,
                        type: val.code,
                    }); }),
                };
                options.push(option);
            }
        }
        catch (e_3_1) { e_3 = { error: e_3_1 }; }
        finally {
            try {
                if (list_1_1 && !list_1_1.done && (_a = list_1.return)) _a.call(list_1);
            }
            finally { if (e_3) throw e_3.error; }
        }
        return options;
    }
    exports.makePodcastOptionSubs = makePodcastOptionSubs;
});
