define(["require", "exports"], function (require, exports) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.initiateNotificationState = exports.NOTICES = void 0;
    /**
     * Notice types
     */
    var NOTICES;
    (function (NOTICES) {
        NOTICES[NOTICES["PLAY_SONG"] = 0] = "PLAY_SONG";
        NOTICES[NOTICES["PLAY_ARTIST"] = 1] = "PLAY_ARTIST";
        NOTICES[NOTICES["PLAY_ALBUM"] = 2] = "PLAY_ALBUM";
        NOTICES[NOTICES["PLAY_COLLECTION"] = 3] = "PLAY_COLLECTION";
        NOTICES[NOTICES["PLAY_USERPROFILE"] = 4] = "PLAY_USERPROFILE";
        NOTICES[NOTICES["PLAY_LIST"] = 5] = "PLAY_LIST";
        NOTICES[NOTICES["PLAY_EPISODE"] = 6] = "PLAY_EPISODE";
        NOTICES[NOTICES["PLAY_PODCAST"] = 7] = "PLAY_PODCAST";
        NOTICES[NOTICES["PLAY_RADIO"] = 8] = "PLAY_RADIO";
        // No song can be played
        NOTICES[NOTICES["NO_SONG"] = 9] = "NO_SONG";
        // Filter songs which have no audio.
        NOTICES[NOTICES["FILTER_SONGS"] = 10] = "FILTER_SONGS";
        // Song which has no audio.
        NOTICES[NOTICES["NO_AUDIO"] = 11] = "NO_AUDIO";
        // switch to some kbps
        NOTICES[NOTICES["SWITCH_KBPS"] = 12] = "SWITCH_KBPS";
        // the audio which has this kbps is blocked by server
        NOTICES[NOTICES["BLOCKED_KBPS"] = 13] = "BLOCKED_KBPS";
        NOTICES[NOTICES["LOGIN_SUCCESS"] = 14] = "LOGIN_SUCCESS";
        NOTICES[NOTICES["LOGIN_FAIL"] = 15] = "LOGIN_FAIL";
        // Can't connect server
        NOTICES[NOTICES["SERVER_FAIL"] = 16] = "SERVER_FAIL";
        NOTICES[NOTICES["INFO"] = 17] = "INFO";
    })(NOTICES = exports.NOTICES || (exports.NOTICES = {}));
    function initiateNotificationState() {
        return { entries: [] };
    }
    exports.initiateNotificationState = initiateNotificationState;
});
