define(["require", "exports", "chord/music/common/origin", "chord/workbench/api/common/state/offset"], function (require, exports, origin_1, offset_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.setCurrectOffset = exports.makeOffsets = void 0;
    function makeOffsets(origin, offset, size) {
        /**
         * `page * size` is equal to the amount of songs which have been token.
         * `total` is equal to `page * size + amount of wonted songs`
         */
        var findPages = function (page, size, total, offsets) {
            var nowOffset = page * size;
            if (nowOffset >= total) {
                return;
            }
            // max size is 100 for xiami music
            var chunk = 100;
            while (true) {
                if ((nowOffset % chunk == 0) && (nowOffset + chunk <= total)) {
                    var _offset = offset_1.initiateOffset();
                    _offset.offset = nowOffset / chunk + 1;
                    _offset.limit = chunk;
                    offsets.push(_offset);
                    findPages(1, nowOffset + chunk, total, offsets);
                    return;
                }
                else {
                    chunk -= 10;
                }
            }
        };
        var offsets = [];
        var total;
        switch (origin) {
            case origin_1.ORIGIN.xiami:
            case origin_1.ORIGIN.migu:
            case origin_1.ORIGIN.kuwo:
                total = offset.offset * offset.limit + size;
                findPages(offset.offset, offset.limit, total, offsets);
                break;
            case origin_1.ORIGIN.netease:
            case origin_1.ORIGIN.qq:
            case origin_1.ORIGIN.qianqian:
                // TODO: user's favorites do not need offset * limit in apis
                var _offset = offset_1.initiateOffset();
                _offset.offset = offset.offset;
                _offset.limit = size;
                offsets.push(_offset);
                break;
        }
        return offsets;
    }
    exports.makeOffsets = makeOffsets;
    function setCurrectOffset(origin, offset, size) {
        var total;
        var _offset;
        switch (origin) {
            case origin_1.ORIGIN.xiami:
            case origin_1.ORIGIN.migu:
            case origin_1.ORIGIN.kuwo:
                // `offset.offset * offset.limit` is equal to the amount of songs which have been token.
                // `total` is equal to `page * size + amount of wonted songs`
                total = offset.offset * offset.limit + size;
                _offset = offset_1.initiateOffset();
                _offset.offset = total % 10 == 0 ? total / 10 : Math.floor(total / 10) + 1;
                _offset.limit = 10;
                break;
            case origin_1.ORIGIN.netease:
            case origin_1.ORIGIN.qq:
            case origin_1.ORIGIN.qianqian:
                _offset = offset_1.initiateOffset();
                _offset.offset = offset.offset + size;
                _offset.limit = 0;
                break;
        }
        return _offset;
    }
    exports.setCurrectOffset = setCurrectOffset;
});
