var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
define(["require", "exports", "chord/workbench/parts/common/component/common", "chord/music/core/api", "chord/sound/core/api", "chord/preference/configuration/app"], function (require, exports, common_1, api_1, api_2, app_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.PlayItem = exports.selectAudio = exports.addPlayItemAudiosIter = exports.addPlayItemAudios = exports.filterPlayItemWithAudios = exports.hasPlayItemAudio = exports.hasPlayItemAudioPath = void 0;
    function hasPlayItemAudioPath(playItem) {
        var e_1, _a;
        var has = false;
        try {
            for (var _b = __values(playItem.audios), _c = _b.next(); !_c.done; _c = _b.next()) {
                var audio = _c.value;
                has = !!(audio.path);
                if (has) {
                    return has;
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return has;
    }
    exports.hasPlayItemAudioPath = hasPlayItemAudioPath;
    function hasPlayItemAudio(playItem) {
        var e_2, _a;
        var has = false;
        try {
            for (var _b = __values(playItem.audios), _c = _b.next(); !_c.done; _c = _b.next()) {
                var audio = _c.value;
                has = !!(audio.url || audio.path);
                if (has) {
                    return has;
                }
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_2) throw e_2.error; }
        }
        return has;
    }
    exports.hasPlayItemAudio = hasPlayItemAudio;
    function filterPlayItemWithAudios(playItems) {
        return playItems.filter(function (playItem) { return hasPlayItemAudio(playItem); });
    }
    exports.filterPlayItemWithAudios = filterPlayItemWithAudios;
    function addPlayItemAudios(playItem, supKbps) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, _b, _c;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        supKbps = supKbps || app_1.appConfiguration.getConfig().maxKbps;
                        if (!!hasPlayItemAudio(playItem)) return [3 /*break*/, 6];
                        _a = playItem.type;
                        switch (_a) {
                            case 'song': return [3 /*break*/, 1];
                            case 'episode': return [3 /*break*/, 3];
                        }
                        return [3 /*break*/, 5];
                    case 1:
                        _b = playItem;
                        return [4 /*yield*/, api_1.musicApi.audios(playItem.songId, supKbps)];
                    case 2:
                        _b.audios = _d.sent();
                        return [3 /*break*/, 6];
                    case 3:
                        _c = playItem;
                        return [4 /*yield*/, api_2.soundApi.audios(playItem.episodeId, supKbps)];
                    case 4:
                        _c.audios = _d.sent();
                        return [3 /*break*/, 6];
                    case 5: return [3 /*break*/, 6];
                    case 6: return [2 /*return*/];
                }
            });
        });
    }
    exports.addPlayItemAudios = addPlayItemAudios;
    function addPlayItemAudiosIter(playItems) {
        return __awaiter(this, void 0, void 0, function () {
            var index, playItem;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        index = 0;
                        _a.label = 1;
                    case 1:
                        if (!(index < playItems.length)) return [3 /*break*/, 4];
                        playItem = playItems[index];
                        return [4 /*yield*/, addPlayItemAudios(playItem)];
                    case 2:
                        _a.sent();
                        if (hasPlayItemAudio(playItem)) {
                            return [2 /*return*/, playItems.slice(index)];
                        }
                        _a.label = 3;
                    case 3:
                        index += 1;
                        return [3 /*break*/, 1];
                    case 4: return [2 /*return*/, []];
                }
            });
        });
    }
    exports.addPlayItemAudiosIter = addPlayItemAudiosIter;
    /**
     * Select the audio file which is less than or equal to the given supper kbps from a list
     *
     * maximum of kbps
     * https://en.wikipedia.org/wiki/Bit_rate
     */
    function selectAudio(audios, supKbps) {
        supKbps = supKbps || app_1.appConfiguration.getConfig().maxKbps;
        if (audios.length == 0)
            return null;
        var audio = audios.filter(function (audio) {
            return (audio.url || audio.path)
                && (audio.format != 'ape') // howler does not support `ape` audio format
                && ((audio.kbps || 96) <= supKbps);
        }).sort(function (x, y) { return y.kbps - x.kbps; })[0];
        // TODO, notice no available kbps
        if (!audio)
            audio = audios[0];
        return audio;
    }
    exports.selectAudio = selectAudio;
    var PlayItem = /** @class */ (function () {
        function PlayItem(item) {
            this.inner = item;
            this.take = this.take.bind(this);
            this.id = this.id.bind(this);
            this.type = this.type.bind(this);
            this.cover = this.cover.bind(this);
            this.icon = this.icon.bind(this);
        }
        PlayItem.prototype.take = function () {
            return this.inner;
        };
        PlayItem.prototype.id = function () {
            return this.inner.songId || this.inner.episodeId;
        };
        PlayItem.prototype.type = function () {
            return this.inner.type;
        };
        PlayItem.prototype.cover = function (size) {
            var item = this.inner;
            switch (this.type()) {
                case 'song':
                    var item1 = item;
                    return item1.albumCoverPath || api_1.musicApi.resizeImageUrl(item1.origin, item1.albumCoverUrl, size);
                case 'episode':
                    var item2 = item;
                    return item2.podcastCoverPath || api_2.soundApi.resizeImageUrl(item2.origin, item2.podcastCoverUrl, size);
                default:
                    throw new Error("[ERROR] [PlayItem.cover] Here will never be occured. [inner]: " + item);
            }
        };
        PlayItem.prototype.icon = function () {
            switch (this.type()) {
                case 'song':
                    return common_1.AlbumIcon;
                case 'episode':
                    return common_1.PodcastIcon;
                default:
                    throw new Error("[ERROR] [PlayItem.icon] Here will never be occured. [inner]: " + this.type());
            }
        };
        PlayItem.prototype.name = function () {
            var item = this.inner;
            switch (this.type()) {
                case 'song':
                    return item.songName;
                case 'episode':
                    return item.episodeName;
                default:
                    throw new Error("[ERROR] [PlayItem.name] Here will never be occured. [inner]: " + this.type());
            }
        };
        PlayItem.prototype.boxId = function () {
            var item = this.inner;
            switch (this.type()) {
                case 'song':
                    return item.albumId;
                case 'episode':
                    return item.podcastId;
                default:
                    throw new Error("[ERROR] [PlayItem.boxId] Here will never be occured. [inner]: " + this.type());
            }
        };
        PlayItem.prototype.boxName = function () {
            var item = this.inner;
            switch (this.type()) {
                case 'song':
                    return item.albumName;
                case 'episode':
                    return item.podcastName;
                default:
                    throw new Error("[ERROR] [PlayItem.boxName] Here will never be occured. [inner]: " + this.type());
            }
        };
        PlayItem.prototype.ownerId = function () {
            var item = this.inner;
            switch (this.type()) {
                case 'song':
                    return item.artistId;
                case 'episode':
                    return item.radioId;
                default:
                    throw new Error("[ERROR] [PlayItem.boxName] Here will never be occured. [inner]: " + this.type());
            }
        };
        PlayItem.prototype.ownerName = function () {
            var item = this.inner;
            switch (this.type()) {
                case 'song':
                    return item.artistName;
                case 'episode':
                    return item.radioName;
                default:
                    throw new Error("[ERROR] [PlayItem.boxName] Here will never be occured. [inner]: " + this.type());
            }
        };
        return PlayItem;
    }());
    exports.PlayItem = PlayItem;
});
