define(["require", "exports", "chord/platform/utils/common/size"], function (require, exports, size_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.getUserProfileCount = exports.getLikeAndPlayCount = void 0;
    function getLikeAndPlayCount(item) {
        var likeAndPlayCount = [
            item.likeCount ? size_1.literal_number(item.likeCount) + ' like' : null,
            item.playCount ? size_1.literal_number(item.playCount) + ' play' : null,
        ].filter(function (i) { return !!i; }).join(' • ');
        return likeAndPlayCount;
    }
    exports.getLikeAndPlayCount = getLikeAndPlayCount;
    /**
     * Get user's following, follower and favorite song count
     */
    function getUserProfileCount(item) {
        var trackCount;
        var trackType;
        switch (item.type) {
            case 'userProfile':
                trackCount = item.episodeCount;
                trackType = ' songs';
                break;
            case 'radio':
                trackCount = item.episodeCount;
                trackType = ' episodes';
                break;
            default:
                break;
        }
        var userProfileCount = [
            item.followerCount ? size_1.literal_number(item.followerCount) + ' followers' : null,
            item.followingCount ? size_1.literal_number(item.followingCount) + ' following' : null,
            trackCount ? size_1.literal_number(trackCount) + trackType : null,
        ].filter(function (i) { return !!i; }).join(' • ');
        return userProfileCount;
    }
    exports.getUserProfileCount = getUserProfileCount;
});
