define(["require", "exports", "chord/platform/log/common/log", "chord/platform/utils/common/paths", "react", "react-dom", "react-redux", "redux", "chord/workbench/parts/reducer", "chord/workbench/api/node/audio", "chord/workbench/electron-browser/rootView", "chord/workbench/electron-browser/action/quit", "electron", "chord/css!./media/main", "chord/workbench/events/player"], function (require, exports, log_1, paths_1, React, ReactDOM, react_redux_1, redux_1, reducer_1, audio_1, rootView_1, quit_1, electron_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    var logger = new log_1.Logger(paths_1.filenameToNodeName(__filename));
    logger.info('electron rendering process activate');
    // Disable zoom
    // https://github.com/electron/electron/issues/3609#issuecomment-289537969
    electron_1.webFrame.setVisualZoomLevelLimits(1, 1);
    var store = redux_1.createStore(reducer_1.mainReducer);
    // Set global store
    window.store = store;
    function App() {
        return (React.createElement(react_redux_1.Provider, { store: store },
            React.createElement(rootView_1.default, null)));
    }
    ReactDOM.render(React.createElement(App, null), document.getElementById('root'));
    // configure CAudio
    audio_1.CAudio.registerStore(store);
    quit_1.handleQuit();
});
