var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports", "react", "react-redux", "chord/workbench/parts/player/browser/playerView", "chord/workbench/parts/navigation/browser/navigationView", "chord/workbench/electron-browser/media/mainBackground", "chord/workbench/parts/menu/browser/menuView", "chord/workbench/parts/mainView/browser/mainView", "chord/workbench/electron-browser/windows", "chord/base/common/platform"], function (require, exports, React, react_redux_1, playerView_1, navigationView_1, mainBackground_1, menuView_1, mainView_1, windows_1, platform_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    function closeMenu() {
        document.querySelectorAll('.react-contextmenu').forEach(function (elm) {
            var menu = elm;
            menu.style.display = 'none';
        });
    }
    /**
     * window scroll event
     */
    window.addEventListener('scroll', function () {
        closeMenu();
    });
    // Set
    // :root {
    //    --mainview-scrollbar-background: xxx
    // }
    function setScrollbarBackground(background) {
        var css = '--mainview-scrollbar-background: ' + background;
        var rules = document.styleSheets[0].rules;
        for (var index = 0; index < rules.length; index += 1) {
            var rule = rules[index];
            if (rule.selectorText == ':root') {
                rule.style.cssText = css;
                return;
            }
        }
        document.styleSheets[0].addRule(':root', css);
    }
    var RootView = /** @class */ (function (_super) {
        __extends(RootView, _super);
        function RootView(props) {
            var _this = _super.call(this, props) || this;
            _this.handleGlobalClickAndSCroll = _this.handleGlobalClickAndSCroll.bind(_this);
            return _this;
        }
        RootView.prototype.handleGlobalClickAndSCroll = function () {
            closeMenu();
        };
        RootView.prototype.render = function () {
            var _this = this;
            var viewKey = this.props.viewKey;
            var background = mainBackground_1.getMainBackground(viewKey);
            var windowsControlBar = !platform_1.isMacintosh ? React.createElement(windows_1.default, null) : null;
            if (!platform_1.isMacintosh) {
                setScrollbarBackground(background);
            }
            return (React.createElement("div", { onClick: function () { return _this.handleGlobalClickAndSCroll(); }, onScroll: function () { return _this.handleGlobalClickAndSCroll(); } },
                windowsControlBar,
                React.createElement("div", { className: 'main-background', style: { backgroundImage: background } }),
                React.createElement("div", { className: 'top-container' },
                    React.createElement(navigationView_1.NavigationView, null),
                    React.createElement(mainView_1.default, null)),
                React.createElement("div", null,
                    React.createElement(playerView_1.PlayerView, null)),
                React.createElement(menuView_1.default, null)));
        };
        return RootView;
    }(React.Component));
    function mapStateToProps(state) {
        return { viewKey: state.mainView.view };
    }
    exports.default = react_redux_1.connect(mapStateToProps)(RootView);
});
