var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports", "react", "react-redux", "chord/workbench/api/utils/statistic", "chord/music/common/size", "chord/workbench/parts/mainView/browser/action/showArtist", "chord/workbench/parts/player/browser/action/playArtist", "chord/workbench/parts/menu/browser/action/menu", "chord/workbench/parts/common/abc/card", "chord/workbench/parts/common/component/common", "chord/workbench/parts/common/component/common", "chord/workbench/parts/common/component/originIcons", "chord/music/core/api"], function (require, exports, React, react_redux_1, statistic_1, size_1, showArtist_1, playArtist_1, menu_1, card_1, common_1, common_2, originIcons_1, api_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    var ArtistItemView = /** @class */ (function (_super) {
        __extends(ArtistItemView, _super);
        function ArtistItemView(props) {
            return _super.call(this, props) || this;
        }
        ArtistItemView.prototype.render = function () {
            var _this = this;
            var artist = this.props.artist;
            var cover = artist.artistAvatarPath || api_1.musicApi.resizeImageUrl(artist.origin, artist.artistAvatarUrl, size_1.ESize.Large);
            var originIcon = originIcons_1.OriginIcon(artist.origin, 'cover-icon xiami-icon');
            var likeAndPlayCount = statistic_1.getLikeAndPlayCount(artist);
            var name = (React.createElement("span", null,
                originIcon,
                " ",
                artist.artistName));
            var infos = [
                { item: likeAndPlayCount },
            ];
            return React.createElement(card_1.Card, { name: name, cover: { item: cover, act: function () { return _this.props.handleShowArtistView(artist); } }, defaultCover: common_1.ArtistIcon, menu: function (e) { return _this.props.showArtistMenu(e, artist); }, button: { item: common_2.PlayIcon, act: function () { return _this.props.handlePlayArtist(artist); } }, infos: infos, draggable: true, shape: 'circle' });
        };
        return ArtistItemView;
    }(React.Component));
    function mapDispatchToProps(dispatch) {
        return {
            handleShowArtistView: function (artist) { return showArtist_1.handleShowArtistView(artist).then(function (act) { return dispatch(act); }); },
            handlePlayArtist: function (artist) { return playArtist_1.handlePlayArtist(artist).then(function (act) { return dispatch(act); }); },
            showArtistMenu: function (e, artist) { return dispatch(menu_1.showArtistMenu(e, artist)); },
        };
    }
    exports.default = react_redux_1.connect(null, mapDispatchToProps)(ArtistItemView);
});
