var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports", "react", "react-redux", "chord/workbench/api/utils/statistic", "chord/music/common/size", "chord/base/common/time", "chord/workbench/parts/player/browser/action/playCollection", "chord/workbench/parts/mainView/browser/action/showCollection", "chord/workbench/parts/mainView/browser/action/showUserProfile", "chord/workbench/parts/menu/browser/action/menu", "chord/workbench/parts/common/abc/card", "chord/workbench/parts/common/component/common", "chord/workbench/parts/common/component/common", "chord/workbench/parts/common/component/originIcons", "chord/music/core/api"], function (require, exports, React, react_redux_1, statistic_1, size_1, time_1, playCollection_1, showCollection_1, showUserProfile_1, menu_1, card_1, common_1, common_2, originIcons_1, api_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    /**
     * Collection item view
     *
     * This view doesn't display collection's songs
     *
     * props.collection is given by parent component
     */
    var CollectionItemView = /** @class */ (function (_super) {
        __extends(CollectionItemView, _super);
        function CollectionItemView(props) {
            return _super.call(this, props) || this;
        }
        CollectionItemView.prototype.render = function () {
            var _this = this;
            var collection = this.props.collection;
            var cover = collection.collectionCoverPath || api_1.musicApi.resizeImageUrl(collection.origin, collection.collectionCoverUrl, size_1.ESize.Large);
            var originIcon = originIcons_1.OriginIcon(collection.origin, 'cover-icon xiami-icon');
            var likeAndPlayCount = statistic_1.getLikeAndPlayCount(collection);
            var addons = (React.createElement("span", null,
                originIcon,
                " ",
                time_1.getDateYear(collection.releaseDate),
                " \u2022 ",
                collection.songCount,
                " tracks"));
            var infos = [
                {
                    item: collection.userName,
                    act: function () { return _this.props.handleShowUserProfileViewById(collection.userId, collection.userMid, collection.userName); }
                },
                { item: likeAndPlayCount },
                { item: addons },
            ];
            return React.createElement(card_1.Card, { name: collection.collectionName, cover: { item: cover, act: function () { return _this.props.handleShowCollectionView(collection); } }, defaultCover: common_1.CollectionIcon, menu: function (e) { return _this.props.showCollectionMenu(e, collection); }, button: { item: common_2.PlayIcon, act: function () { return _this.props.handlePlayCollection(collection); } }, infos: infos, draggable: true, shape: 'rectangle' });
        };
        return CollectionItemView;
    }(React.Component));
    function mapDispatchToProps(dispatch) {
        return {
            handlePlayCollection: function (collection) { return playCollection_1.handlePlayCollection(collection).then(function (act) { return dispatch(act); }); },
            handleShowCollectionView: function (collection) { return showCollection_1.handleShowCollectionView(collection).then(function (act) { return dispatch(act); }); },
            showCollectionMenu: function (e, collection) { return dispatch(menu_1.showCollectionMenu(e, collection)); },
            handleShowUserProfileViewById: function (userId, userMid, userName) { return showUserProfile_1.handleShowUserProfileViewById(userId, userMid, userName).then(function (act) { return dispatch(act); }); },
        };
    }
    exports.default = react_redux_1.connect(null, mapDispatchToProps)(CollectionItemView);
});
