var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports", "react", "react-redux", "chord/music/common/size", "chord/base/common/time", "chord/workbench/parts/common/component/common", "chord/workbench/parts/common/abc/list", "chord/workbench/parts/common/component/originIcons", "chord/workbench/parts/menu/browser/action/menu", "chord/workbench/parts/mainView/browser/action/showPodcast", "chord/workbench/parts/mainView/browser/action/showRadio", "chord/workbench/parts/player/browser/action/playOne", "chord/sound/core/api"], function (require, exports, React, react_redux_1, size_1, time_1, common_1, list_1, originIcons_1, menu_1, showPodcast_1, showRadio_1, playOne_1, api_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    var EpisodeItemView = /** @class */ (function (_super) {
        __extends(EpisodeItemView, _super);
        function EpisodeItemView(props) {
            return _super.call(this, props) || this;
        }
        EpisodeItemView.prototype.render = function () {
            var _this = this;
            var episode = this.props.episode;
            var handlePlay = this.props.handlePlay ?
                this.props.handlePlay : function () { return _this.props.handlePlayOne(episode); };
            var active = this.props.active;
            var originIcon = originIcons_1.OriginIcon(episode.origin, 'tracklist-col xiami-icon');
            var cover = episode.podcastCoverPath || api_1.soundApi.resizeImageUrl(episode.origin, episode.podcastCoverUrl, size_1.ESize.Small);
            var infos = this.props.short ? null : [
                { item: episode.radioName, act: function () { return _this.props.handleShowRadioViewById(episode.radioId); } },
                { item: episode.podcastName, act: function () { return _this.props.handleShowPodcastViewById(episode.podcastId); } },
            ];
            var leftInfos = [
                { item: time_1.getHumanDuration(episode.duration) },
                { item: originIcon },
            ];
            return React.createElement(list_1.List, { name: episode.episodeName, cover: this.props.thumb && cover, menu: function (e) { return _this.props.showEpisodeMenu(e, episode); }, defaultButton: common_1.SoundIcon, button: { item: common_1.PlayIcon, act: function () { return handlePlay(); } }, infos: infos, leftInfos: leftInfos, draggable: true, active: active });
        };
        return EpisodeItemView;
    }(React.Component));
    function mapDispatchToProps(dispatch) {
        return {
            handlePlayOne: function (episode) { return playOne_1.handlePlayOne(episode).then(function (act) { return dispatch(act); }); },
            handleShowRadioViewById: function (radioId) { return showRadio_1.handleShowRadioViewById(radioId).then(function (act) { return dispatch(act); }); },
            handleShowPodcastViewById: function (albumId) { return showPodcast_1.handleShowPodcastViewById(albumId).then(function (act) { return dispatch(act); }); },
            showEpisodeMenu: function (e, episode) { return dispatch(menu_1.showEpisodeMenu(e, episode)); },
        };
    }
    exports.default = react_redux_1.connect(null, mapDispatchToProps)(EpisodeItemView);
});
