var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
define(["require", "exports", "react", "react-redux", "chord/music/common/origin", "chord/workbench/api/utils/statistic", "chord/music/common/size", "chord/base/common/time", "chord/workbench/parts/menu/browser/action/menu", "chord/workbench/parts/player/browser/action/playPodcast", "chord/workbench/parts/mainView/browser/action/showPodcast", "chord/workbench/parts/mainView/browser/action/showRadio", "chord/workbench/events/autoLoadNextPlayItems", "chord/workbench/parts/common/abc/card", "chord/workbench/parts/common/component/common", "chord/workbench/parts/common/component/common", "chord/workbench/parts/common/component/originIcons", "chord/sound/core/api", "chord/sound/common/params"], function (require, exports, React, react_redux_1, origin_1, statistic_1, size_1, time_1, menu_1, playPodcast_1, showPodcast_1, showRadio_1, autoLoadNextPlayItems_1, card_1, common_1, common_2, originIcons_1, api_1, params_1) {
    'use strict';
    var _a;
    Object.defineProperty(exports, "__esModule", { value: true });
    var PARAMS = (_a = {},
        _a[origin_1.ORIGIN.ximalaya] = __assign(__assign({}, params_1.OFFSETS[origin_1.ORIGIN.ximalaya]), { order: '0' }),
        _a[origin_1.ORIGIN.himalaya] = __assign(__assign({}, params_1.OFFSETS[origin_1.ORIGIN.himalaya]), { order: '1' }),
        _a);
    /**
     * Podcast item view
     *
     * This view doesn't display podcast's songs
     *
     * props.podcast is given by parent component
     */
    var PodcastItemView = /** @class */ (function (_super) {
        __extends(PodcastItemView, _super);
        function PodcastItemView(props) {
            var _this = _super.call(this, props) || this;
            _this.handlePlayPodcast = _this.handlePlayPodcast.bind(_this);
            return _this;
        }
        PodcastItemView.prototype.handlePlayPodcast = function () {
            var _a = PARAMS[this.props.podcast.origin], order = _a.order, offset = _a.offset, limit = _a.limit;
            var params = {
                podcastId: this.props.podcast.podcastId,
                params: { order: order },
                offset: offset,
                limit: limit,
            };
            autoLoadNextPlayItems_1.addGlobelPlayPartForPodcast(params);
            this.props.handlePlayPodcast(this.props.podcast);
        };
        PodcastItemView.prototype.render = function () {
            var _this = this;
            var podcast = this.props.podcast;
            var cover = podcast.podcastCoverPath || api_1.soundApi.resizeImageUrl(podcast.origin, podcast.podcastCoverUrl, size_1.ESize.Large);
            var originIcon = originIcons_1.OriginIcon(podcast.origin, 'cover-icon xiami-icon');
            var likeAndPlayCount = statistic_1.getLikeAndPlayCount(podcast);
            var addons = (React.createElement("span", null,
                originIcon,
                " ",
                time_1.getDateYear(podcast.releaseDate),
                " \u2022 ",
                podcast.episodeCount,
                " tracks"));
            var infos = [
                { item: podcast.radioName, act: function () { return _this.props.handleShowRadioViewById(podcast.radioId); } },
                { item: likeAndPlayCount },
                { item: addons },
            ];
            return React.createElement(card_1.Card, { name: podcast.podcastName, cover: { item: cover, act: function () { return _this.props.handleShowPodcastView(podcast); } }, defaultCover: common_1.PodcastIcon, menu: function (e) { return _this.props.showPodcastMenu(e, podcast); }, button: { item: common_2.PlayIcon, act: this.handlePlayPodcast }, infos: infos, draggable: true, shape: 'rectangle' });
        };
        return PodcastItemView;
    }(React.Component));
    function mapDispatchToProps(dispatch) {
        return {
            handlePlayPodcast: function (podcast) { return playPodcast_1.handlePlayPodcast(podcast, []).then(function (act) { return dispatch(act); }); },
            handleShowPodcastView: function (podcast) { return showPodcast_1.handleShowPodcastView(podcast).then(function (act) { return dispatch(act); }); },
            showPodcastMenu: function (e, podcast) { return dispatch(menu_1.showPodcastMenu(e, podcast)); },
            handleShowRadioViewById: function (radioId) { return showRadio_1.handleShowRadioViewById(radioId).then(function (act) { return dispatch(act); }); },
        };
    }
    exports.default = react_redux_1.connect(null, mapDispatchToProps)(PodcastItemView);
});
