var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports", "react", "react-redux", "chord/music/common/size", "chord/base/common/time", "chord/workbench/parts/common/component/common", "chord/workbench/parts/player/browser/action/playOne", "chord/workbench/parts/mainView/browser/action/showArtist", "chord/workbench/parts/mainView/browser/action/showAlbum", "chord/workbench/parts/common/abc/list", "chord/workbench/parts/menu/browser/action/menu", "chord/workbench/parts/common/component/originIcons", "chord/music/core/api"], function (require, exports, React, react_redux_1, size_1, time_1, common_1, playOne_1, showArtist_1, showAlbum_1, list_1, menu_1, originIcons_1, api_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    var SongItemView = /** @class */ (function (_super) {
        __extends(SongItemView, _super);
        function SongItemView(props) {
            return _super.call(this, props) || this;
        }
        SongItemView.prototype.render = function () {
            var _this = this;
            var song = this.props.song;
            var handlePlay = this.props.handlePlay ?
                this.props.handlePlay : function () { return _this.props.handlePlayOne(song); };
            var active = this.props.active;
            var originIcon = originIcons_1.OriginIcon(song.origin, 'tracklist-col xiami-icon');
            var cover = song.albumCoverPath || api_1.musicApi.resizeImageUrl(song.origin, song.albumCoverUrl, size_1.ESize.Small);
            var infos = this.props.short ? null : [
                { item: song.artistName, act: function () { return _this.props.handleShowArtistViewById(song.artistId); } },
                { item: song.albumName, act: function () { return _this.props.handleShowAlbumViewById(song.albumId); } },
            ];
            var leftInfos = [
                { item: time_1.getHumanDuration(song.duration) },
                { item: originIcon },
            ];
            return React.createElement(list_1.List, { name: song.songName, cover: this.props.thumb && cover, menu: function (e) { return _this.props.showSongMenu(e, song); }, defaultButton: common_1.MusicIcon, button: { item: common_1.PlayIcon, act: function () { return handlePlay(); } }, infos: infos, leftInfos: leftInfos, draggable: true, active: active });
        };
        return SongItemView;
    }(React.Component));
    function mapDispatchToProps(dispatch) {
        return {
            handlePlayOne: function (song) { return playOne_1.handlePlayOne(song).then(function (act) { return dispatch(act); }); },
            handleShowArtistViewById: function (artistId) { return showArtist_1.handleShowArtistViewById(artistId).then(function (act) { return dispatch(act); }); },
            handleShowAlbumViewById: function (albumId) { return showAlbum_1.handleShowAlbumViewById(albumId).then(function (act) { return dispatch(act); }); },
            showSongMenu: function (e, song) { return dispatch(menu_1.showSongMenu(e, song)); },
        };
    }
    exports.default = react_redux_1.connect(null, mapDispatchToProps)(SongItemView);
});
