define(["require", "exports", "chord/library/core/library"], function (require, exports, library_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.librarySearch = void 0;
    var MAX_ID = Math.pow(2, 32) - 1;
    function librarySearch(keyword) {
        var songs = library_1.defaultLibrary.librarySongs(MAX_ID, 10, keyword);
        var artists = library_1.defaultLibrary.libraryArtists(MAX_ID, 10, keyword);
        var albums = library_1.defaultLibrary.libraryAlbums(MAX_ID, 10, keyword);
        var collections = library_1.defaultLibrary.libraryCollections(MAX_ID, 10, keyword);
        var userProfiles = library_1.defaultLibrary.libraryUserProfiles(MAX_ID, 10, keyword);
        var episodes = library_1.defaultLibrary.libraryEpisodes(MAX_ID, 10, keyword);
        var podcasts = library_1.defaultLibrary.libraryPodcasts(MAX_ID, 10, keyword);
        var radios = library_1.defaultLibrary.libraryRadios(MAX_ID, 10, keyword);
        return {
            type: 'c:mainView:libraryInput',
            act: 'c:mainView:libraryInput',
            keyword: keyword,
            songs: songs,
            albums: albums,
            artists: artists,
            collections: collections,
            userProfiles: userProfiles,
            episodes: episodes,
            podcasts: podcasts,
            radios: radios,
        };
    }
    exports.librarySearch = librarySearch;
});
