var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
define(["require", "exports", "chord/platform/log/common/log", "chord/platform/utils/common/paths", "chord/base/common/assert", "chord/music/common/origin", "chord/music/core/api", "chord/preference/configuration/user"], function (require, exports, log_1, paths_1, assert_1, origin_1, api_1, user_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.syncRemove = exports.syncAdd = void 0;
    var logger = new log_1.Logger(paths_1.filenameToNodeName(__filename));
    function syncAdd(item) {
        return __awaiter(this, void 0, void 0, function () {
            var itemId, itemMid, originType, config, _a, account, syncAddRemove;
            return __generator(this, function (_b) {
                itemId = item.type == 'userProfile' ? item['userId'] : item[item.type + "Id"];
                itemMid = item.type == 'userProfile' ? item['userMid'] : item[item.type + "Mid"];
                originType = origin_1.getOrigin(itemId);
                config = user_1.userConfiguration.getConfig();
                _a = config[originType.origin] || {}, account = _a.account, syncAddRemove = _a.syncAddRemove;
                if (account && syncAddRemove) {
                    assert_1.ok(api_1.musicApi.logined(originType.origin), '[ERROR] [syncAdd]: user configuration does not synchronize with `musicApi`');
                    logger.info('[syncAdd]:', item.type, itemId);
                    switch (item.type) {
                        case 'song':
                            return [2 /*return*/, api_1.musicApi.userLikeSong(itemId, itemMid)];
                        case 'artist':
                            return [2 /*return*/, api_1.musicApi.userLikeArtist(itemId, itemMid)];
                        case 'album':
                            return [2 /*return*/, api_1.musicApi.userLikeAlbum(itemId, itemMid)];
                        case 'collection':
                            return [2 /*return*/, api_1.musicApi.userLikeCollection(itemId, itemMid)];
                        case 'userProfile':
                            return [2 /*return*/, api_1.musicApi.userLikeUserProfile(itemId, itemMid)];
                        case 'episode':
                            return [2 /*return*/, false];
                        // return soundApi.userLikeEpisode(itemId, itemMid);
                        case 'podcast':
                            return [2 /*return*/, false];
                        // return soundApi.userLikePodcast(itemId, itemMid);
                        case 'radio':
                            return [2 /*return*/, false];
                        // return soundApi.userLikeRadio(itemId, itemMid);
                        default:
                            throw new Error("[ERROR] [syncAdd] Here will never be occured. [args]: " + JSON.stringify(item));
                    }
                }
                else {
                    return [2 /*return*/, false];
                }
                return [2 /*return*/];
            });
        });
    }
    exports.syncAdd = syncAdd;
    function syncRemove(item) {
        return __awaiter(this, void 0, void 0, function () {
            var itemId, itemMid, originType, config, _a, account, syncAddRemove;
            return __generator(this, function (_b) {
                itemId = item.type == 'userProfile' ? item['userId'] : item[item.type + "Id"];
                itemMid = item.type == 'userProfile' ? item['userMid'] : item[item.type + "Mid"];
                originType = origin_1.getOrigin(itemId);
                config = user_1.userConfiguration.getConfig();
                _a = config[originType.origin] || {}, account = _a.account, syncAddRemove = _a.syncAddRemove;
                if (account && syncAddRemove) {
                    assert_1.ok(api_1.musicApi.logined(originType.origin), '[ERROR] [syncRemove]: user configuration does not synchronize with `musicApi`');
                    logger.info('[syncRemove]:', item.type, itemId);
                    switch (item.type) {
                        case 'song':
                            return [2 /*return*/, api_1.musicApi.userDislikeSong(itemId, itemMid)];
                        case 'artist':
                            return [2 /*return*/, api_1.musicApi.userDislikeArtist(itemId, itemMid)];
                        case 'album':
                            return [2 /*return*/, api_1.musicApi.userDislikeAlbum(itemId, itemMid)];
                        case 'collection':
                            return [2 /*return*/, api_1.musicApi.userDislikeCollection(itemId, itemMid)];
                        case 'userProfile':
                            return [2 /*return*/, api_1.musicApi.userDislikeUserProfile(itemId, itemMid)];
                        case 'episode':
                            return [2 /*return*/, false];
                        // return musicApi.userDislikeEpisode(itemId, itemMid);
                        case 'podcast':
                            return [2 /*return*/, false];
                        // return musicApi.userDislikePodcast(itemId, itemMid);
                        case 'radio':
                            return [2 /*return*/, false];
                        // return musicApi.userDislikeRadio(itemId, itemMid);
                        default:
                            throw new Error("[ERROR] [syncRemove] Here will never be occured. [args]: " + JSON.stringify(item));
                    }
                }
                else {
                    return [2 /*return*/, false];
                }
                return [2 /*return*/];
            });
        });
    }
    exports.syncRemove = syncRemove;
});
