define(["require", "exports", "chord/platform/log/common/log", "chord/platform/utils/common/paths", "chord/library/core/library", "chord/workbench/parts/mainView/browser/action/plugins/syncAddRemove"], function (require, exports, log_1, paths_1, library_1, syncAddRemove_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.handleRemoveFromLibrary = void 0;
    var logger = new log_1.Logger(paths_1.filenameToNodeName(__filename));
    function handleRemoveFromLibrary(item) {
        item.like = false;
        switch (item.type) {
            case 'song':
                library_1.defaultLibrary.deleteSong(item);
                break;
            case 'artist':
                library_1.defaultLibrary.deleteArtist(item);
                break;
            case 'album':
                library_1.defaultLibrary.deleteAlbum(item);
                break;
            case 'collection':
                library_1.defaultLibrary.deleteCollection(item);
                break;
            case 'userProfile':
                library_1.defaultLibrary.deleteUserProfile(item);
                break;
            case 'episode':
                library_1.defaultLibrary.deleteEpisode(item);
                break;
            case 'podcast':
                library_1.defaultLibrary.deletePodcast(item);
                break;
            case 'radio':
                library_1.defaultLibrary.deleteRadio(item);
                break;
            default:
                logger.error('`handleRemoveFromLibrary` act: unknown item\'s type:', item.type, item);
        }
        syncAddRemove_1.syncRemove(item);
        return {
            type: 'c:mainView:removeFromLibrary',
            act: 'c:mainView:removeFromLibrary',
            item: item,
        };
    }
    exports.handleRemoveFromLibrary = handleRemoveFromLibrary;
});
