var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
define(["require", "exports", "chord/music/core/api", "chord/sound/core/api"], function (require, exports, api_1, api_2) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.searchMoreRadios = exports.searchMorePodcasts = exports.searchMoreEpisodes = exports.searchMoreCollections = exports.searchMoreArtists = exports.searchMoreAlbums = exports.searchMoreSongs = void 0;
    function searchMoreSongs(keyword, offset) {
        return __awaiter(this, void 0, void 0, function () {
            var songs;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        songs = [];
                        if (!offset.more) return [3 /*break*/, 2];
                        offset.offset += 1;
                        return [4 /*yield*/, api_1.musicApi.searchSongs(keyword, offset.offset, offset.limit)];
                    case 1:
                        songs = _a.sent();
                        _a.label = 2;
                    case 2:
                        if (songs.length == 0) {
                            offset.more = false;
                        }
                        return [2 /*return*/, {
                                type: 'c:mainView:searchMoreSongs',
                                act: 'c:mainView:searchMoreSongs',
                                keyword: keyword,
                                songs: songs,
                                songsOffset: offset,
                            }];
                }
            });
        });
    }
    exports.searchMoreSongs = searchMoreSongs;
    function searchMoreAlbums(keyword, offset) {
        return __awaiter(this, void 0, void 0, function () {
            var albums;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        albums = [];
                        if (!offset.more) return [3 /*break*/, 2];
                        offset.offset += 1;
                        return [4 /*yield*/, api_1.musicApi.searchAlbums(keyword, offset.offset, offset.limit)];
                    case 1:
                        albums = _a.sent();
                        _a.label = 2;
                    case 2:
                        if (albums.length == 0) {
                            offset.more = false;
                        }
                        return [2 /*return*/, {
                                type: 'c:mainView:searchMoreAlbums',
                                act: 'c:mainView:searchMoreAlbums',
                                keyword: keyword,
                                albums: albums,
                                albumsOffset: offset,
                            }];
                }
            });
        });
    }
    exports.searchMoreAlbums = searchMoreAlbums;
    function searchMoreArtists(keyword, offset) {
        return __awaiter(this, void 0, void 0, function () {
            var artists;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        artists = [];
                        if (!offset.more) return [3 /*break*/, 2];
                        offset.offset += 1;
                        return [4 /*yield*/, api_1.musicApi.searchArtists(keyword, offset.offset, offset.limit)];
                    case 1:
                        artists = _a.sent();
                        _a.label = 2;
                    case 2:
                        if (artists.length == 0) {
                            offset.more = false;
                        }
                        return [2 /*return*/, {
                                type: 'c:mainView:searchMoreArtists',
                                act: 'c:mainView:searchMoreArtists',
                                keyword: keyword,
                                artists: artists,
                                artistsOffset: offset,
                            }];
                }
            });
        });
    }
    exports.searchMoreArtists = searchMoreArtists;
    function searchMoreCollections(keyword, offset) {
        return __awaiter(this, void 0, void 0, function () {
            var collections;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        collections = [];
                        if (!offset.more) return [3 /*break*/, 2];
                        offset.offset += 1;
                        return [4 /*yield*/, api_1.musicApi.searchCollections(keyword, offset.offset, offset.limit)];
                    case 1:
                        collections = _a.sent();
                        _a.label = 2;
                    case 2:
                        if (collections.length == 0) {
                            offset.more = false;
                        }
                        return [2 /*return*/, {
                                type: 'c:mainView:searchMoreCollections',
                                act: 'c:mainView:searchMoreCollections',
                                keyword: keyword,
                                collections: collections,
                                collectionsOffset: offset,
                            }];
                }
            });
        });
    }
    exports.searchMoreCollections = searchMoreCollections;
    // Sound
    function searchMoreEpisodes(keyword, offset) {
        return __awaiter(this, void 0, void 0, function () {
            var episodes;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        episodes = [];
                        if (!offset.more) return [3 /*break*/, 2];
                        offset.offset += 1;
                        return [4 /*yield*/, api_2.soundApi.searchEpisodes(keyword, offset.offset, offset.limit)];
                    case 1:
                        episodes = _a.sent();
                        _a.label = 2;
                    case 2:
                        if (episodes.length == 0) {
                            offset.more = false;
                        }
                        return [2 /*return*/, {
                                type: 'c:mainView:searchMoreEpisodes',
                                act: 'c:mainView:searchMoreEpisodes',
                                keyword: keyword,
                                episodes: episodes,
                                episodesOffset: offset,
                            }];
                }
            });
        });
    }
    exports.searchMoreEpisodes = searchMoreEpisodes;
    function searchMorePodcasts(keyword, offset) {
        return __awaiter(this, void 0, void 0, function () {
            var podcasts;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        podcasts = [];
                        if (!offset.more) return [3 /*break*/, 2];
                        offset.offset += 1;
                        return [4 /*yield*/, api_2.soundApi.searchPodcasts(keyword, offset.offset, offset.limit)];
                    case 1:
                        podcasts = _a.sent();
                        _a.label = 2;
                    case 2:
                        if (podcasts.length == 0) {
                            offset.more = false;
                        }
                        return [2 /*return*/, {
                                type: 'c:mainView:searchMorePodcasts',
                                act: 'c:mainView:searchMorePodcasts',
                                keyword: keyword,
                                podcasts: podcasts,
                                podcastsOffset: offset,
                            }];
                }
            });
        });
    }
    exports.searchMorePodcasts = searchMorePodcasts;
    function searchMoreRadios(keyword, offset) {
        return __awaiter(this, void 0, void 0, function () {
            var radios;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        radios = [];
                        if (!offset.more) return [3 /*break*/, 2];
                        offset.offset += 1;
                        return [4 /*yield*/, api_2.soundApi.searchRadios(keyword, offset.offset, offset.limit)];
                    case 1:
                        radios = _a.sent();
                        _a.label = 2;
                    case 2:
                        if (radios.length == 0) {
                            offset.more = false;
                        }
                        return [2 /*return*/, {
                                type: 'c:mainView:searchMoreRadios',
                                act: 'c:mainView:searchMoreRadios',
                                keyword: keyword,
                                radios: radios,
                                radiosOffset: offset,
                            }];
                }
            });
        });
    }
    exports.searchMoreRadios = searchMoreRadios;
});
