var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
define(["require", "exports", "chord/music/common/origin", "chord/workbench/api/utils/offset", "chord/music/core/api"], function (require, exports, origin_1, offset_1, api_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.getMoreFollowings = exports.getMoreCreatedCollections = exports.getMoreFavoriteCollections = exports.getMoreFavoriteAlbums = exports.getMoreFavoriteArtists = exports.getMoreFavoriteSongs = void 0;
    // size: how many items to be get
    function getMoreFavoriteSongs(userProfile, offset, size) {
        if (size === void 0) { size = 10; }
        return __awaiter(this, void 0, void 0, function () {
            var songs, offsets, futs, songsList;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        songs = [];
                        if (!offset.more) return [3 /*break*/, 2];
                        offsets = offset_1.makeOffsets(userProfile.origin, offset, size);
                        futs = offsets.map(function (_offset) { return api_1.musicApi.userFavoriteSongs(userProfile.userId, _offset.offset, _offset.limit, userProfile.userMid); });
                        return [4 /*yield*/, Promise.all(futs)];
                    case 1:
                        songsList = _a.sent();
                        songs = songs.concat.apply(songs, __spread(songsList));
                        // user favorite songs api of netease does not support offset
                        if (userProfile.origin != origin_1.ORIGIN.netease) {
                            songs = songs.slice(0, size);
                        }
                        offset = offset_1.setCurrectOffset(userProfile.origin, offset, songs.length);
                        _a.label = 2;
                    case 2:
                        // user favorite songs api of netease does not support offset
                        if (songs.length == 0 || userProfile.origin == origin_1.ORIGIN.netease) {
                            offset.more = false;
                        }
                        return [2 /*return*/, {
                                type: 'c:mainView:getMoreUserFavoriteSongs',
                                act: 'c:mainView:getMoreUserFavoriteSongs',
                                songs: songs,
                                songsOffset: offset,
                            }];
                }
            });
        });
    }
    exports.getMoreFavoriteSongs = getMoreFavoriteSongs;
    function getMoreFavoriteArtists(userProfile, offset, size) {
        if (size === void 0) { size = 10; }
        return __awaiter(this, void 0, void 0, function () {
            var artists, offsets, futs, artistsList;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        artists = [];
                        if (!offset.more) return [3 /*break*/, 2];
                        offsets = offset_1.makeOffsets(userProfile.origin, offset, size);
                        futs = offsets.map(function (_offset) { return api_1.musicApi.userFavoriteArtists(userProfile.userId, _offset.offset, _offset.limit, userProfile.userMid); });
                        return [4 /*yield*/, Promise.all(futs)];
                    case 1:
                        artistsList = _a.sent();
                        artists = artists.concat.apply(artists, __spread(artistsList)).slice(0, size);
                        offset = offset_1.setCurrectOffset(userProfile.origin, offset, artists.length);
                        _a.label = 2;
                    case 2:
                        if (artists.length == 0) {
                            offset.more = false;
                        }
                        return [2 /*return*/, {
                                type: 'c:mainView:getMoreUserFavoriteArtists',
                                act: 'c:mainView:getMoreUserFavoriteArtists',
                                artists: artists,
                                artistsOffset: offset,
                            }];
                }
            });
        });
    }
    exports.getMoreFavoriteArtists = getMoreFavoriteArtists;
    function getMoreFavoriteAlbums(userProfile, offset, size) {
        if (size === void 0) { size = 10; }
        return __awaiter(this, void 0, void 0, function () {
            var albums, offsets, futs, albumsList;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        albums = [];
                        if (!offset.more) return [3 /*break*/, 2];
                        offsets = offset_1.makeOffsets(userProfile.origin, offset, size);
                        futs = offsets.map(function (_offset) { return api_1.musicApi.userFavoriteAlbums(userProfile.userId, _offset.offset, _offset.limit, userProfile.userMid); });
                        return [4 /*yield*/, Promise.all(futs)];
                    case 1:
                        albumsList = _a.sent();
                        albums = albums.concat.apply(albums, __spread(albumsList)).slice(0, size);
                        offset = offset_1.setCurrectOffset(userProfile.origin, offset, albums.length);
                        _a.label = 2;
                    case 2:
                        if (albums.length == 0) {
                            offset.more = false;
                        }
                        return [2 /*return*/, {
                                type: 'c:mainView:getMoreUserFavoriteAlbums',
                                act: 'c:mainView:getMoreUserFavoriteAlbums',
                                albums: albums,
                                albumsOffset: offset,
                            }];
                }
            });
        });
    }
    exports.getMoreFavoriteAlbums = getMoreFavoriteAlbums;
    function getMoreFavoriteCollections(userProfile, offset, size) {
        if (size === void 0) { size = 10; }
        return __awaiter(this, void 0, void 0, function () {
            var collections, offsets, futs, collectonsList;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        collections = [];
                        if (!offset.more) return [3 /*break*/, 2];
                        offsets = offset_1.makeOffsets(userProfile.origin, offset, size);
                        futs = offsets.map(function (_offset) { return api_1.musicApi.userFavoriteCollections(userProfile.userId, _offset.offset, _offset.limit, userProfile.userMid); });
                        return [4 /*yield*/, Promise.all(futs)];
                    case 1:
                        collectonsList = _a.sent();
                        collections = collections.concat.apply(collections, __spread(collectonsList)).slice(0, size);
                        offset = offset_1.setCurrectOffset(userProfile.origin, offset, collections.length);
                        _a.label = 2;
                    case 2:
                        if (collections.length == 0) {
                            offset.more = false;
                        }
                        return [2 /*return*/, {
                                type: 'c:mainView:getMoreUserFavoriteCollections',
                                act: 'c:mainView:getMoreUserFavoriteCollections',
                                collections: collections,
                                collectionsOffset: offset,
                            }];
                }
            });
        });
    }
    exports.getMoreFavoriteCollections = getMoreFavoriteCollections;
    function getMoreCreatedCollections(userProfile, offset, size) {
        if (size === void 0) { size = 10; }
        return __awaiter(this, void 0, void 0, function () {
            var collections, offsets, futs, collectonsList;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        collections = [];
                        if (!offset.more) return [3 /*break*/, 2];
                        offsets = offset_1.makeOffsets(userProfile.origin, offset, size);
                        futs = offsets.map(function (_offset) { return api_1.musicApi.userCreatedCollections(userProfile.userId, _offset.offset, _offset.limit, userProfile.userMid); });
                        return [4 /*yield*/, Promise.all(futs)];
                    case 1:
                        collectonsList = _a.sent();
                        collections = collections.concat.apply(collections, __spread(collectonsList)).slice(0, size);
                        offset = offset_1.setCurrectOffset(userProfile.origin, offset, collections.length);
                        _a.label = 2;
                    case 2:
                        if (collections.length == 0) {
                            offset.more = false;
                        }
                        return [2 /*return*/, {
                                type: 'c:mainView:getMoreUserCreatedCollections',
                                act: 'c:mainView:getMoreUserCreatedCollections',
                                collections: collections,
                                collectionsOffset: offset,
                            }];
                }
            });
        });
    }
    exports.getMoreCreatedCollections = getMoreCreatedCollections;
    function getMoreFollowings(userProfile, offset, size) {
        if (size === void 0) { size = 10; }
        return __awaiter(this, void 0, void 0, function () {
            var followings, offsets, futs, userProfilesList;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        followings = [];
                        if (!offset.more) return [3 /*break*/, 2];
                        offsets = offset_1.makeOffsets(userProfile.origin, offset, size);
                        futs = offsets.map(function (_offset) { return api_1.musicApi.userFollowings(userProfile.userId, _offset.offset, _offset.limit, userProfile.userMid); });
                        return [4 /*yield*/, Promise.all(futs)];
                    case 1:
                        userProfilesList = _a.sent();
                        followings = followings.concat.apply(followings, __spread(userProfilesList)).slice(0, size);
                        offset = offset_1.setCurrectOffset(userProfile.origin, offset, followings.length);
                        _a.label = 2;
                    case 2:
                        if (followings.length == 0) {
                            offset.more = false;
                        }
                        return [2 /*return*/, {
                                type: 'c:mainView:getMoreUserFollowings',
                                act: 'c:mainView:getMoreUserFollowings',
                                followings: followings,
                                followingsOffset: offset,
                            }];
                }
            });
        });
    }
    exports.getMoreFollowings = getMoreFollowings;
});
