var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
define(["require", "exports", "react", "react-redux", "chord/platform/utils/common/keys", "chord/workbench/parts/common/component/viewMoreItem", "chord/workbench/parts/common/component/albumItem", "chord/workbench/parts/mainView/browser/action/home/albums"], function (require, exports, React, react_redux_1, keys_1, viewMoreItem_1, albumItem_1, albums_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    var AlbumListView = /** @class */ (function (_super) {
        __extends(AlbumListView, _super);
        function AlbumListView(props) {
            var _this = _super.call(this, props) || this;
            _this._getAlbumsView = _this._getAlbumsView.bind(_this);
            return _this;
        }
        AlbumListView.prototype._getAlbumsView = function (size) {
            var albums = this.props.albums;
            var albumsView = albums.slice(0, size ? size : Infinity).map(function (album, index) { return (React.createElement("div", { className: 'col-xs-6 col-sm-4 col-md-3 col-lg-2 col-xl-2', key: keys_1.makeListKey(index, 'album', 'list') },
                React.createElement(albumItem_1.default, { album: album }))); });
            return albumsView;
        };
        AlbumListView.prototype.render = function () {
            var _this = this;
            var origin = this.props.origin;
            var offset = this.props.albumsOffset;
            var optionParams = this.props.optionParams;
            var albumsView = this._getAlbumsView();
            var viewMore = offset.more ? (React.createElement(viewMoreItem_1.ViewMorePlusItem, { handler: function (size) {
                    var _a;
                    return (_a = _this.props).handleGetMoreAlbums.apply(_a, __spread([origin], optionParams, [offset, size]));
                } })) : null;
            return (React.createElement("section", { className: 'artist-albums' },
                React.createElement("div", { className: 'contentSpacing' },
                    React.createElement("h1", { className: 'search-result-title', style: { textAlign: 'center', display: 'none' } }, "Albums"),
                    React.createElement("div", { className: 'container-fluid container-fluid--noSpaceAround' },
                        React.createElement("div", { className: 'align-row-wrap grid--limit row' }, albumsView)),
                    viewMore)));
        };
        return AlbumListView;
    }(React.Component));
    function mapStateToProps(state) {
        var _a = state.mainView.homeView.albumsView, origin = _a.origin, albums = _a.albums, albumsOffset = _a.albumsOffset;
        return { origin: origin, albums: albums, albumsOffset: albumsOffset };
    }
    function mapDispatchToProps(dispatch) {
        return {
            handleGetMoreAlbums: function () {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                return albums_1.handleGetMoreAlbums.apply(void 0, __spread(args)).then(function (act) { return dispatch(act); });
            },
        };
    }
    exports.default = react_redux_1.connect(mapStateToProps, mapDispatchToProps)(AlbumListView);
});
