var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
define(["require", "exports", "react", "react-redux", "chord/platform/utils/common/keys", "chord/music/common/origin", "chord/workbench/parts/common/component/buttons", "chord/workbench/parts/mainView/browser/component/home/component/albums/albumList", "chord/workbench/parts/mainView/browser/action/home/albums"], function (require, exports, React, react_redux_1, keys_1, origin_1, buttons_1, albumList_1, albums_1) {
    'use strict';
    var _a;
    Object.defineProperty(exports, "__esModule", { value: true });
    // origin function argument to AlbumListOptionsView.state
    var ARGUMENT_NAMES_MAP = (_a = {},
        _a[origin_1.ORIGIN.xiami] = {
            order: 'order',
            language: 'area',
            tag: 'genre',
            century: 'year',
            category: 'type',
        },
        _a[origin_1.ORIGIN.qq] = {
            sort: 'order',
            area: 'area',
            genre: 'genre',
            year: 'year',
            type: 'type',
            company: 'company',
        },
        _a);
    function initiateState(origin) {
        switch (origin) {
            case origin_1.ORIGIN.xiami:
                return {
                    order: '0',
                    area: '0',
                    genre: '0',
                    type: '0',
                    year: '0',
                    company: '0',
                };
            case origin_1.ORIGIN.qq:
                return {
                    order: '5',
                    area: '1',
                    genre: '-1',
                    type: '-1',
                    year: '-1',
                    company: '-1',
                };
            default:
                throw new Error("[ERROR] [AlbumListOptionsView.initiateState] Here will never be occured. [args]: " + origin);
        }
    }
    var AlbumListOptionsView = /** @class */ (function (_super) {
        __extends(AlbumListOptionsView, _super);
        function AlbumListOptionsView(props) {
            var _this = _super.call(this, props) || this;
            _this.state = initiateState(_this.props.origin);
            _this._showAlbumList = _this._showAlbumList.bind(_this);
            _this._update_argument = _this._update_argument.bind(_this);
            _this._getTitleView = _this._getTitleView.bind(_this);
            _this._getOptionView = _this._getOptionView.bind(_this);
            _this._getOptionsView = _this._getOptionsView.bind(_this);
            _this._getAlbumListOptionsView = _this._getAlbumListOptionsView.bind(_this);
            return _this;
        }
        AlbumListOptionsView.prototype._showAlbumList = function () {
            var origin = this.props.origin;
            var _a = this.state, order = _a.order, area = _a.area, genre = _a.genre, type = _a.type, year = _a.year, company = _a.company;
            this.props.handleShowAlbumListView(origin, order, area, genre, type, year, company);
        };
        AlbumListOptionsView.prototype._update_argument = function (name, value) {
            var _a;
            var origin = this.props.origin;
            var key = ARGUMENT_NAMES_MAP[origin][name];
            this.setState((_a = {}, _a[key] = value, _a));
        };
        AlbumListOptionsView.prototype._getTitleView = function (title) {
            return (React.createElement("div", { className: 'chunk-title' }, title));
        };
        AlbumListOptionsView.prototype._getOptionView = function (option) {
            var _this = this;
            var type = option.type;
            var origin = this.props.origin;
            var list = option.items.map(function (item, index) {
                var key = ARGUMENT_NAMES_MAP[origin][type];
                var active = _this.state[key] == item.id;
                var className = active ? 'chunk-item chunk-item-selected a-like cursor-pointer'
                    : 'chunk-item a-like cursor-pointer';
                return (React.createElement("div", { className: className, key: keys_1.makeListKey(index, 'album', 'option', 'item'), onClick: function () { return _this._update_argument(type, item.id); } }, item.name));
            });
            return (React.createElement("div", { className: 'chunk-container' }, list));
        };
        AlbumListOptionsView.prototype._getOptionsView = function (options) {
            var _this = this;
            var classes = options.map(function (option, index) {
                var titleView = _this._getTitleView(option.name);
                var optionView = _this._getOptionView(option);
                return (React.createElement("div", { className: 'chunk', key: keys_1.makeListKey(index, 'album', 'option') },
                    titleView,
                    optionView));
            });
            return classes;
        };
        AlbumListOptionsView.prototype._getAlbumListOptionsView = function (options) {
            var origin = this.props.origin;
            var classes = this._getOptionsView(options);
            return (React.createElement("div", { className: 'options-item' },
                React.createElement("div", { className: 'options-item-title' },
                    " ",
                    origin.toLocaleUpperCase(),
                    " "),
                React.createElement("div", { className: 'options-item-container' },
                    " ",
                    classes,
                    " ")));
        };
        AlbumListOptionsView.prototype.render = function () {
            var origin = this.props.origin;
            var options = this.props.optionsSet[origin];
            var albumListOptionsView = this._getAlbumListOptionsView(options);
            var albumListView = this.props.toShowAlbumList ? (React.createElement(albumList_1.default, { optionParams: [
                    this.state.order,
                    this.state.area,
                    this.state.genre,
                    this.state.type,
                    this.state.year,
                    this.state.company,
                ] })) : null;
            return (React.createElement("div", null,
                React.createElement("div", { className: 'options-container' },
                    albumListOptionsView,
                    React.createElement("div", { className: 'options-container-title' },
                        React.createElement(buttons_1.MiddleButton, { title: "Show Me", click: this._showAlbumList }))),
                albumListView));
        };
        return AlbumListOptionsView;
    }(React.Component));
    function mapStateToProps(state) {
        var optionsSet = state.mainView.homeView.albumsView.optionsSet;
        var toShowAlbumList = state.mainView.homeView.albumsView.albums.length > 0;
        return { optionsSet: optionsSet, toShowAlbumList: toShowAlbumList };
    }
    function mapDispatchToProps(dispatch) {
        return {
            handleShowAlbumListView: function () {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                return albums_1.handleShowAlbumListView.apply(void 0, __spread(args)).then(function (act) { return dispatch(act); });
            },
        };
    }
    exports.default = react_redux_1.connect(mapStateToProps, mapDispatchToProps)(AlbumListOptionsView);
});
