var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports", "react", "react-redux", "chord/platform/utils/common/keys", "chord/music/common/origin", "chord/workbench/parts/mainView/browser/component/home/component/artists/artistListOptions"], function (require, exports, React, react_redux_1, keys_1, origin_1, artistListOptions_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    var ArtistsView = /** @class */ (function (_super) {
        __extends(ArtistsView, _super);
        function ArtistsView(props) {
            var _this = _super.call(this, props) || this;
            _this.xiamiArtistListOptionsView =
                React.createElement(artistListOptions_1.default, { key: keys_1.makeListKey(0, 'artist', 'options'), origin: origin_1.ORIGIN.xiami, toShowArtistList: function () { return _this.props.origin == origin_1.ORIGIN.xiami; } });
            _this.neteaseArtistListOptionsView =
                React.createElement(artistListOptions_1.default, { key: keys_1.makeListKey(1, 'artist', 'options'), origin: origin_1.ORIGIN.netease, toShowArtistList: function () { return _this.props.origin == origin_1.ORIGIN.netease; } });
            _this.qqArtistListOptionsView =
                React.createElement(artistListOptions_1.default, { key: keys_1.makeListKey(2, 'artist', 'options'), origin: origin_1.ORIGIN.qq, toShowArtistList: function () { return _this.props.origin == origin_1.ORIGIN.qq; } });
            return _this;
        }
        ArtistsView.prototype.render = function () {
            var View;
            switch (this.props.view) {
                case 'options':
                    View = [
                        this.xiamiArtistListOptionsView,
                        this.neteaseArtistListOptionsView,
                        this.qqArtistListOptionsView
                    ];
                    break;
                case 'artists':
                    switch (this.props.origin) {
                        case origin_1.ORIGIN.xiami:
                            View = this.xiamiArtistListOptionsView;
                            break;
                        case origin_1.ORIGIN.netease:
                            View = this.neteaseArtistListOptionsView;
                            break;
                        case origin_1.ORIGIN.qq:
                            View = this.qqArtistListOptionsView;
                            break;
                        default:
                            throw new Error("[ArtistsView]: unknown origin: " + origin);
                    }
                    break;
                default:
                    throw new Error("[ArtistsView]: unknown view: " + this.state.view);
            }
            return View;
        };
        return ArtistsView;
    }(React.Component));
    function mapStateToProps(state) {
        return {
            view: state.mainView.homeView.artistsView.view,
            origin: state.mainView.homeView.artistsView.origin,
        };
    }
    exports.default = react_redux_1.connect(mapStateToProps)(ArtistsView);
});
