var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports", "react", "react-redux", "chord/platform/utils/common/keys", "chord/workbench/parts/common/component/viewMoreItem", "chord/workbench/parts/common/component/navMenu", "chord/workbench/parts/common/component/collectionItem", "chord/workbench/parts/mainView/browser/action/home/collections"], function (require, exports, React, react_redux_1, keys_1, viewMoreItem_1, navMenu_1, collectionItem_1, collections_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    var CollectionListView = /** @class */ (function (_super) {
        __extends(CollectionListView, _super);
        function CollectionListView(props) {
            var _this = _super.call(this, props) || this;
            _this._getOrder = _this._getOrder.bind(_this);
            _this._getOrdersView = _this._getOrdersView.bind(_this);
            _this._getCollectionsView = _this._getCollectionsView.bind(_this);
            return _this;
        }
        CollectionListView.prototype._getOrder = function (id) {
            return this.props.orders.find(function (o) { return o.id == id; });
        };
        CollectionListView.prototype._getOrdersView = function () {
            var _this = this;
            var _a = this.props, origin = _a.origin, option = _a.option, orders = _a.orders, order = _a.order;
            return React.createElement(navMenu_1.NavMenu, { namespace: 'collections-orders', thisView: order.id, views: orders.map(function (_a) {
                    var id = _a.id, name = _a.name;
                    return ({ name: name, value: id });
                }), handleClick: function (id) { _this.props.handleChangeOrder(origin, option, _this._getOrder(id)); } });
        };
        CollectionListView.prototype._getCollectionsView = function (size) {
            var collections = this.props.collections;
            var collectionsView = collections.slice(0, size ? size : Infinity).map(function (collection, index) { return (React.createElement("div", { className: 'col-xs-6 col-sm-4 col-md-3 col-lg-2 col-xl-2', key: keys_1.makeListKey(index, 'collection', 'list') },
                React.createElement(collectionItem_1.default, { collection: collection }))); });
            return collectionsView;
        };
        CollectionListView.prototype.render = function () {
            var _this = this;
            var origin = this.props.origin;
            var option = this.props.option;
            var order = this.props.order;
            var offset = this.props.collectionsOffset;
            var orderView = this._getOrdersView();
            var collectionsView = this._getCollectionsView();
            var viewMore = offset.more ? (React.createElement(viewMoreItem_1.ViewMorePlusItem, { handler: function (size) { return _this.props.handleGetMoreCollections(origin, option, order, offset, size); } })) : null;
            return (React.createElement("section", { className: 'artist-albums' },
                orderView,
                React.createElement("div", { className: 'contentSpacing' },
                    React.createElement("h1", { className: 'search-result-title', style: { textAlign: 'center', display: 'none' } }, "Collections"),
                    React.createElement("div", { className: 'container-fluid container-fluid--noSpaceAround' },
                        React.createElement("div", { className: 'align-row-wrap grid--limit row' }, collectionsView)),
                    viewMore)));
        };
        return CollectionListView;
    }(React.Component));
    function mapStateToProps(state) {
        var _a = state.mainView.homeView.collectionsView, origin = _a.origin, option = _a.option, orders = _a.orders, order = _a.order, collections = _a.collections, collectionsOffset = _a.collectionsOffset;
        return {
            origin: origin,
            option: option,
            orders: orders,
            order: order,
            collections: collections,
            collectionsOffset: collectionsOffset,
        };
    }
    function mapDispatchToProps(dispatch) {
        return {
            handleGetMoreCollections: function (origin, option, order, offset, size) {
                collections_1.handleGetMoreCollections(origin, option, order, offset, size).then(function (act) { return dispatch(act); });
            },
            handleChangeOrder: function (origin, option, order) {
                collections_1.handleShowCollectionListView(origin, option, order).then(function (act) { return dispatch(act); });
            },
        };
    }
    exports.default = react_redux_1.connect(mapStateToProps, mapDispatchToProps)(CollectionListView);
});
