var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports", "react", "react-redux", "chord/platform/utils/common/keys", "chord/music/common/origin", "chord/workbench/parts/mainView/browser/action/home/collections", "chord/css!./collections"], function (require, exports, React, react_redux_1, keys_1, origin_1, collections_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    var CollectionOptionsView = /** @class */ (function (_super) {
        __extends(CollectionOptionsView, _super);
        function CollectionOptionsView(props) {
            var _this = _super.call(this, props) || this;
            _this._getTitleView = _this._getTitleView.bind(_this);
            _this._getOptionView = _this._getOptionView.bind(_this);
            _this._getOptionsView = _this._getOptionsView.bind(_this);
            _this._getCollectionListOptionsView = _this._getCollectionListOptionsView.bind(_this);
            return _this;
        }
        CollectionOptionsView.prototype._getTitleView = function (title) {
            return (React.createElement("div", { className: 'chunk-title' }, title));
        };
        CollectionOptionsView.prototype._getOptionView = function (origin, option) {
            var _this = this;
            var list = option.items.map(function (item, index) { return (React.createElement("div", { className: 'chunk-item a-like cursor-pointer', key: keys_1.makeListKey(index, 'collection', 'option', 'item'), onClick: function () { return _this.props.handleShowCollectionListView(origin, item, null); } }, item.name)); });
            return (React.createElement("div", { className: 'chunk-container' }, list));
        };
        CollectionOptionsView.prototype._getOptionsView = function (origin, options) {
            var _this = this;
            var classes = options.map(function (option, index) {
                var titleView = _this._getTitleView(option.name);
                var optionView = _this._getOptionView(origin, option);
                return (React.createElement("div", { className: 'chunk', key: keys_1.makeListKey(index, 'collection', 'option') },
                    titleView,
                    optionView));
            });
            return classes;
        };
        CollectionOptionsView.prototype._getCollectionListOptionsView = function (origin, options) {
            var classes = this._getOptionsView(origin, options);
            return (React.createElement("div", { className: 'options-item' },
                React.createElement("div", { className: 'options-item-title' },
                    " ",
                    origin.toLocaleUpperCase(),
                    " "),
                React.createElement("div", { className: 'options-item-container' },
                    " ",
                    classes,
                    " ")));
        };
        CollectionOptionsView.prototype.render = function () {
            var xiamiCollectionListOptionsView = this._getCollectionListOptionsView(origin_1.ORIGIN.xiami, this.props.xiamiOptions);
            var neteaseCollectionListOptionsView = this._getCollectionListOptionsView(origin_1.ORIGIN.netease, this.props.neteaseOptions);
            var qqCollectionListOptionsView = this._getCollectionListOptionsView(origin_1.ORIGIN.qq, this.props.qqOptions);
            return (React.createElement("div", { className: 'options-container' },
                React.createElement("div", { className: 'options-container-title' }, "Collections"),
                xiamiCollectionListOptionsView,
                neteaseCollectionListOptionsView,
                qqCollectionListOptionsView));
        };
        return CollectionOptionsView;
    }(React.Component));
    function mapStateToProps(state) {
        var optionsSet = state.mainView.homeView.collectionsView.optionsSet;
        return {
            xiamiOptions: optionsSet[origin_1.ORIGIN.xiami],
            neteaseOptions: optionsSet[origin_1.ORIGIN.netease],
            qqOptions: optionsSet[origin_1.ORIGIN.qq],
        };
    }
    function mapDispatchToProps(dispatch) {
        return {
            handleShowCollectionListView: function (origin, option, order) {
                collections_1.handleShowCollectionListView(origin, option, order).then(function (act) { return dispatch(act); });
            },
        };
    }
    exports.default = react_redux_1.connect(mapStateToProps, mapDispatchToProps)(CollectionOptionsView);
});
