define(["require", "exports", "react", "react-redux", "chord/workbench/parts/mainView/browser/action/home/nagivation", "chord/workbench/parts/mainView/browser/action/home/recommend", "chord/workbench/parts/mainView/browser/action/home/collections", "chord/workbench/parts/mainView/browser/action/home/albums", "chord/workbench/parts/mainView/browser/action/home/artists"], function (require, exports, React, react_redux_1, nagivation_1, recommend_1, collections_1, albums_1, artists_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    // over, recommendView, newReleaseView, rankingView, entriesView, stylesView
    function NagivationMenuView(props) {
        var view = props.view;
        return (React.createElement("nav", { className: 'search-nav-container' },
            React.createElement("ul", { className: 'search-nav-ul' },
                React.createElement("li", { className: 'search-nav-li' },
                    React.createElement("div", { className: "search-nav-item link-subtle cursor-pointer " + (view == 'recommendView' ? 'search-nav-item__active' : ''), onClick: function () { return props.handleShowRecommendView(); } }, "RECOMMEND")),
                React.createElement("li", { className: 'search-nav-li' },
                    React.createElement("div", { className: "search-nav-item link-subtle cursor-pointer " + (view == 'newReleaseView' ? 'search-nav-item__active' : ''), onClick: function () { return props.changeView('newReleaseView'); } }, "NEW RELEASES")),
                React.createElement("li", { className: 'search-nav-li' },
                    React.createElement("div", { className: "search-nav-item link-subtle cursor-pointer " + (view == 'collectionsView' ? 'search-nav-item__active' : ''), onClick: function () { return props.handleShowCollectionListOptionsView(); } }, "COLLECTIONS")),
                React.createElement("li", { className: 'search-nav-li' },
                    React.createElement("div", { className: "search-nav-item link-subtle cursor-pointer " + (view == 'albumsView' ? 'search-nav-item__active' : ''), onClick: function () { return props.handleShowAlbumListOptionsView(); } }, "ALBUMS")),
                React.createElement("li", { className: 'search-nav-li' },
                    React.createElement("div", { className: "search-nav-item link-subtle cursor-pointer " + (view == 'artistsView' ? 'search-nav-item__active' : ''), onClick: function () { return props.handleShowArtistListOptionsView(); } }, "ARTISTS")))));
    }
    function mapStateToProps(state) {
        return {
            view: state.mainView.homeView.view,
        };
    }
    function mapDispatchToProps(dispatch) {
        return {
            changeView: function (view) { return dispatch(nagivation_1.changeView(view)); },
            handleShowRecommendView: function () { return recommend_1.handleShowRecommendView().then(function (act) { return dispatch(act); }); },
            handleShowCollectionListOptionsView: function () { return collections_1.handleShowCollectionListOptionsView().then(function (act) { return dispatch(act); }); },
            handleShowAlbumListOptionsView: function () { return albums_1.handleShowAlbumListOptionsView().then(function (act) { return dispatch(act); }); },
            handleShowArtistListOptionsView: function () { return dispatch(artists_1.handleShowArtistListOptionsView()); },
        };
    }
    exports.default = react_redux_1.connect(mapStateToProps, mapDispatchToProps)(NagivationMenuView);
});
