define(["require", "exports", "react", "react-redux", "chord/workbench/parts/mainView/browser/component/home/component/navigation/navigation", "chord/workbench/parts/mainView/browser/component/home/component/recommend/recommendView", "chord/workbench/parts/mainView/browser/component/home/component/newRelease/newReleaseView", "chord/workbench/parts/mainView/browser/component/home/component/collections/collections", "chord/workbench/parts/mainView/browser/component/home/component/albums/albums", "chord/workbench/parts/mainView/browser/component/home/component/artists/artists"], function (require, exports, React, react_redux_1, navigation_1, recommendView_1, newReleaseView_1, collections_1, albums_1, artists_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    function HomeView(_a) {
        var view = _a.view;
        var View;
        switch (view) {
            case 'recommendView':
                View = React.createElement(recommendView_1.default, null);
                break;
            case 'newReleaseView':
                View = React.createElement(newReleaseView_1.default, null);
                break;
            case 'collectionsView':
                View = React.createElement(collections_1.default, null);
                break;
            case 'albumsView':
                View = React.createElement(albums_1.default, null);
                break;
            case 'artistsView':
                View = React.createElement(artists_1.default, null);
                break;
            default:
                throw new Error("[HomeView]: unknown view: " + view);
        }
        return (React.createElement("div", { className: 'hw-accelerate' },
            React.createElement("section", { className: 'content' },
                React.createElement(navigation_1.default, null),
                View)));
    }
    function mapStateToProps(state) {
        return {
            view: state.mainView.homeView.view,
        };
    }
    exports.default = react_redux_1.connect(mapStateToProps)(HomeView);
});
