var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports", "react", "chord/workbench/parts/common/component/buttons", "chord/workbench/parts/common/component/select", "chord/preference/configuration/app"], function (require, exports, React, buttons_1, select_1, app_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    function Title(props) {
        return React.createElement("h1", { className: "search-result-title", style: { textAlign: 'center' } }, props.name);
    }
    var ConfigurationView = /** @class */ (function (_super) {
        __extends(ConfigurationView, _super);
        function ConfigurationView(props) {
            var _this = _super.call(this, props) || this;
            var config = app_1.appConfiguration.getConfig();
            _this.state = {
                view: 'accounts',
                proxy: config.proxy || '',
            };
            _this.saveConfig = _this.saveConfig.bind(_this);
            _this.proxyView = _this.proxyView.bind(_this);
            _this.setProxy = _this.setProxy.bind(_this);
            _this.maxKbpsView = _this.maxKbpsView.bind(_this);
            _this.setMaxKbps = _this.setMaxKbps.bind(_this);
            return _this;
        }
        ConfigurationView.prototype.saveConfig = function () {
            app_1.appConfiguration.saveConfig();
        };
        ConfigurationView.prototype.inputOnChange = function (event, key) {
            var _a;
            this.setState((_a = {},
                _a[key] = event.target.value,
                _a));
        };
        ConfigurationView.prototype.setProxy = function () {
            var proxy = this.state.proxy;
            app_1.appConfiguration.setConfig('proxy', proxy);
            this.saveConfig();
        };
        ConfigurationView.prototype.proxyView = function () {
            var _this = this;
            var config = app_1.appConfiguration.getConfig();
            var placeholder = config.proxy || 'socks5://127.0.0.1:10000';
            return (React.createElement("div", { className: 'row' },
                React.createElement(Title, { name: 'Proxy' }),
                React.createElement("div", { className: 'description' },
                    "\u4E3A\u4E86\u6B63\u5E38\u4F7F\u7528\u4F7F\u7528 Himalaya\uFF0C\u7528\u6237\u9700\u8981\u5728\u7CFB\u7EDF hosts \u6587\u4EF6\u4E2D\u6DFB\u52A0\u4E0B\u9762\u4E00\u6761:",
                    React.createElement("br", null),
                    React.createElement("code", null, "47.254.50.181 api.himalaya.com"),
                    React.createElement("br", null),
                    React.createElement("br", null),
                    "Windows \u7528\u6237\u8BBE\u7F6E hosts \u6587\u4EF6 \u89C1\uFF1A https://www.cnblogs.com/chenfei0801/p/3422985.html",
                    React.createElement("br", null),
                    "MacOS\uFF0CLinux \u7528\u6237\u7F16\u8F91 ",
                    React.createElement("code", null, "/etc/hosts"),
                    React.createElement("br", null),
                    React.createElement("br", null),
                    "\u4E2D\u56FD\u56FD\u5185\u7684\u7528\u6237\u5982\u679C\u8981\u6536\u542C\u90E8\u5206\u7684 Himalaya \u7684\u5185\u5BB9\uFF0C\u9700\u8981\u8BBE\u7F6E\u4E00\u4E2A(\u79D1\u5B66\u4E0A\u7F51)\u4EE3\u7406\u3002",
                    React.createElement("br", null),
                    "chord \u9ED8\u8BA4\u4E0D\u4F7F\u7528\u4EE3\u7406\u6765\u8BBF\u95EE\u6240\u4EE5\u7684\u97F3\u9891\u94FE\u63A5\uFF0C\u5982\u679C\u97F3\u9891\u8BF7\u6C42\u51FA\u9519\u4E14\u97F3\u9891\u94FE\u63A5\u7684\u57DF\u540D \u4E0D\u5C5E\u4E8E\u4E2D\u56FD\uFF0C\u90A3\u4E48 chord \u5C1D\u8BD5\u7528\u4EE3\u7406\u6765\u94FE\u63A5\u3002",
                    React.createElement("br", null),
                    "\u5982\u679C\u7528\u6237\u6CA1\u6709\u8BBE\u7F6E hosts \u548C \u4EE3\u7406\uFF0C\u53EF\u80FD\u65E0\u6CD5\u641C\u7D22\u5230 Himalaya \u7684\u5185\u5BB9\u3002"),
                React.createElement("form", { onSubmit: function (e) { return e.preventDefault(); }, style: { display: 'flex' } },
                    React.createElement("input", { className: "inputBox-input small", type: "text", placeholder: placeholder, value: this.state.proxy, onChange: function (e) { return _this.inputOnChange(e, 'proxy'); } }),
                    React.createElement(buttons_1.MiddleButton, { title: 'Set', click: function () { return _this.setProxy(); } }))));
        };
        ConfigurationView.prototype.setMaxKbps = function (event) {
            var kbps = event.target.value;
            app_1.appConfiguration.setConfig('maxKbps', kbps);
            this.saveConfig();
        };
        ConfigurationView.prototype.maxKbpsView = function () {
            var config = app_1.appConfiguration.getConfig();
            var options = [6000, 320, 192, 128, 96].map(function (kbps) { return ({ name: kbps + 'kbps', value: kbps, selected: config.maxKbps == kbps }); });
            var selectView = React.createElement(select_1.default, { namespace: 'configuration-maxkbps', options: options, onchange: this.setMaxKbps });
            return (React.createElement("div", { className: 'row' },
                React.createElement(Title, { name: 'Maximum Kbps' }),
                React.createElement("div", { className: 'description' }, "The Maximum Kbps for All Songs and Episodes."),
                selectView));
        };
        ConfigurationView.prototype.render = function () {
            var proxyView = this.proxyView();
            var maxKbpsView = this.maxKbpsView();
            return (React.createElement("div", { className: 'contentSpacing' },
                React.createElement("div", { className: 'container-fluid container-fluid--noSpaceAround' },
                    proxyView,
                    maxKbpsView)));
        };
        return ConfigurationView;
    }(React.Component));
    exports.default = ConfigurationView;
});
