var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports", "react", "react-redux", "chord/workbench/parts/mainView/browser/action/searchInput"], function (require, exports, React, react_redux_1, searchInput_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    var SearchInput = /** @class */ (function (_super) {
        __extends(SearchInput, _super);
        function SearchInput(props) {
            var _this = _super.call(this, props) || this;
            _this.state = {
                keyword: _this.props.keyword,
            };
            _this.handleInputChange = _this.handleInputChange.bind(_this);
            return _this;
        }
        /**
         * handle clicking of history searching
         */
        SearchInput.prototype.componentWillReceiveProps = function (nextProps) {
            if (this.state.keyword != nextProps.keyword) {
                this.setState({
                    keyword: nextProps.keyword,
                });
            }
        };
        SearchInput.prototype.handleInputChange = function (event) {
            this.setState({
                keyword: event.target.value,
            });
        };
        SearchInput.prototype.render = function () {
            var _this = this;
            return (React.createElement("div", { className: 'inputBox' },
                React.createElement("div", { className: 'contentSpacing' },
                    React.createElement("h4", { className: 'inputBox-label' }, "Search for an Artist, Song, Album, Playlist or Put some direct urls (e.g. xiami.com/song/1)"),
                    React.createElement("form", { onSubmit: function (event) { _this.props.search(_this.state.keyword); event.preventDefault(); } },
                        React.createElement("input", { className: 'inputBox-input', type: "text", placeholder: 'Start typing...', value: this.state.keyword, onChange: this.handleInputChange })))));
        };
        return SearchInput;
    }(React.Component));
    function mapStateToProps(state) {
        return {
            keyword: state.mainView.searchView.keyword,
        };
    }
    function mapDispatchToProps(dispatch) {
        return {
            search: function (keyword) { return searchInput_1.search(keyword).then(function (act) { return dispatch(act); }); },
        };
    }
    exports.default = react_redux_1.connect(mapStateToProps, mapDispatchToProps)(SearchInput);
});
