var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
define(["require", "exports", "chord/base/common/property", "chord/workbench/parts/mainView/browser/reducer/reduceMap"], function (require, exports, property_1, reduceMap_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.mainViewReducer = void 0;
    /**
     * What is view of this mainView
     */
    function handleView(act) {
        switch (act) {
            case 'c:mainView:searchView':
            case 'c:mainView:searchInput':
            case 'c:mainView:searchMoreSongs':
            case 'c:mainView:searchMoreAlbums':
            case 'c:mainView:searchMoreArtists':
            case 'c:mainView:searchMoreCollections':
            case 'c:mainView:searchMoreEpisodes':
            case 'c:mainView:searchMorePodcasts':
            case 'c:mainView:searchMoreRadios':
                return 'searchView';
            case 'c:mainView:showAlbumView':
                return 'albumView';
            case 'c:mainView:showCollectionView':
                return 'collectionView';
            case 'c:mainView:showArtistView':
            case 'c:mainView:getMoreArtistSongs':
            case 'c:mainView:getMoreArtistAlbums':
                return 'artistView';
            case 'c:mainView:libraryView':
            case 'c:mainView:libraryInput':
            case 'c:mainView:getMoreLibrarySongs':
            case 'c:mainView:getMoreLibraryArtists':
            case 'c:mainView:getMoreLibraryAlbums':
            case 'c:mainView:getMoreLibraryCollections':
            case 'c:mainView:getMoreLibraryUserProfiles':
                return 'libraryView';
            case 'c:mainView:preferenceView':
                return 'preferenceView';
            case 'c:mainView:showUserProfileView':
            case 'c:mainView:getMoreUserFavoriteSongs':
            case 'c:mainView:getMoreUserFavoriteArtists':
            case 'c:mainView:getMoreUserFavoriteAlbums':
            case 'c:mainView:getMoreUserFavoriteCollections':
            case 'c:mainView:getMoreUserCreatedCollections':
            case 'c:mainView:getMoreUserFollowings':
                return 'userProfileView';
            case 'c:mainView:showPodcastView':
                return 'podcastView';
            case 'c:mainView:showRadioView':
                return 'radioView';
            case 'c:mainView:home:navigation:changeView':
            case 'c:mainView:home:showRecommendView':
            case 'c:mainView:home:showCollectionListOptionsView':
            case 'c:mainView:home:showCollectionListView':
            case 'c:mainView:home:collections:getMoreCollections':
            case 'c:mainView:home:showAlbumListOptionsView':
            case 'c:mainView:home:showAlbumListView':
            case 'c:mainView:home:albums:getMoreAlbums':
            case 'c:mainView:home:showArtistListOptionsView':
            case 'c:mainView:home:showArtistListView':
                return 'homeView';
            case 'c:mainView:comeback':
            case 'c:mainView:addLibrarySong':
            case 'c:mainView:addLibraryArtist':
            case 'c:mainView:addLibraryAlbum':
            case 'c:mainView:addLibraryCollection':
            case 'c:mainView:addLibraryUserProfile':
            default:
                return null;
        }
    }
    function mainViewReducer(state, act) {
        var _a = reduceMap_1.map(act.act), reducer = _a.reducer, node = _a.node;
        var reducerState = property_1.getDescendentProp(state, node);
        var result = reducer(reducerState, act);
        var newState = __assign({}, state);
        newState = property_1.setDescendentProp(newState, node, result);
        var preView = newState.view;
        var view = handleView(act.act);
        newState.view = view || preView;
        return newState;
    }
    exports.mainViewReducer = mainViewReducer;
});
