define(["require", "exports", "chord/workbench/parts/mainView/browser/reducer/searchView", "chord/workbench/parts/mainView/browser/reducer/searchResult", "chord/workbench/parts/mainView/browser/reducer/showAlbum", "chord/workbench/parts/mainView/browser/reducer/showCollection", "chord/workbench/parts/mainView/browser/reducer/showArtist", "chord/workbench/parts/mainView/browser/reducer/comeback", "chord/workbench/parts/mainView/browser/reducer/artist", "chord/workbench/parts/mainView/browser/reducer/libraryResult", "chord/workbench/parts/mainView/browser/reducer/libraryResult", "chord/workbench/parts/mainView/browser/reducer/library", "chord/workbench/parts/mainView/browser/reducer/preference", "chord/workbench/parts/mainView/browser/reducer/showUserProfile", "chord/workbench/parts/mainView/browser/reducer/userProfile", "chord/workbench/parts/mainView/browser/reducer/home/nagivation", "chord/workbench/parts/mainView/browser/reducer/home/recommend", "chord/workbench/parts/mainView/browser/reducer/home/collections", "chord/workbench/parts/mainView/browser/reducer/home/albums", "chord/workbench/parts/mainView/browser/reducer/home/artists", "chord/workbench/parts/mainView/browser/reducer/showPodcast", "chord/workbench/parts/mainView/browser/reducer/showRadio"], function (require, exports, searchView_1, searchResult_1, showAlbum_1, showCollection_1, showArtist_1, comeback_1, artist_1, libraryResult_1, libraryResult_2, library_1, preference_1, showUserProfile_1, userProfile_1, nagivation_1, recommend_1, collections_1, albums_1, artists_1, showPodcast_1, showRadio_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.map = void 0;
    function map(act) {
        switch (act) {
            case 'c:mainView:searchView':
                return {
                    reducer: searchView_1.showSearchView,
                    node: 'searchView',
                };
            case 'c:mainView:searchInput':
                return {
                    reducer: searchResult_1.showSearchResult,
                    node: 'searchView',
                };
            case 'c:mainView:searchMoreSongs':
                return {
                    reducer: searchResult_1.addSearchSongs,
                    node: 'searchView.result',
                };
            case 'c:mainView:searchMoreAlbums':
                return {
                    reducer: searchResult_1.addSearchAlbums,
                    node: 'searchView.result',
                };
            case 'c:mainView:searchMoreArtists':
                return {
                    reducer: searchResult_1.addSearchArtists,
                    node: 'searchView.result',
                };
            case 'c:mainView:searchMoreCollections':
                return {
                    reducer: searchResult_1.addSearchCollections,
                    node: 'searchView.result',
                };
            case 'c:mainView:searchMoreEpisodes':
                return {
                    reducer: searchResult_1.addSearchEpisodes,
                    node: 'searchView.result',
                };
            case 'c:mainView:searchMorePodcasts':
                return {
                    reducer: searchResult_1.addSearchPodcasts,
                    node: 'searchView.result',
                };
            case 'c:mainView:searchMoreRadios':
                return {
                    reducer: searchResult_1.addSearchRadios,
                    node: 'searchView.result',
                };
            // show album view
            case 'c:mainView:showAlbumView':
                return {
                    reducer: showAlbum_1.showAlbumView,
                    node: 'albumView',
                };
            // show collection view
            case 'c:mainView:showCollectionView':
                return {
                    reducer: showCollection_1.showCollectionView,
                    node: 'collectionView',
                };
            case 'c:mainView:comeback':
                return {
                    reducer: comeback_1.comebackView,
                    node: '.',
                };
            // show artist view
            case 'c:mainView:showArtistView':
                return {
                    reducer: showArtist_1.showArtistView,
                    node: 'artistView',
                };
            // artist
            case 'c:mainView:getMoreArtistSongs':
                return {
                    reducer: artist_1.getMoreArtistSongs,
                    node: 'artistView',
                };
            case 'c:mainView:getMoreArtistAlbums':
                return {
                    reducer: artist_1.getMoreArtistAlbums,
                    node: 'artistView',
                };
            // library
            case 'c:mainView:libraryInput':
                return {
                    reducer: libraryResult_1.showLibraryResult,
                    node: 'libraryView',
                };
            case 'c:mainView:getMoreLibrarySongs':
                return {
                    reducer: libraryResult_2.getMoreLibrarySongs,
                    node: 'libraryView.result',
                };
            case 'c:mainView:getMoreLibraryArtists':
                return {
                    reducer: libraryResult_2.getMoreLibraryArtists,
                    node: 'libraryView.result',
                };
            case 'c:mainView:getMoreLibraryAlbums':
                return {
                    reducer: libraryResult_2.getMoreLibraryAlbums,
                    node: 'libraryView.result',
                };
            case 'c:mainView:getMoreLibraryCollections':
                return {
                    reducer: libraryResult_2.getMoreLibraryCollections,
                    node: 'libraryView.result',
                };
            case 'c:mainView:getMoreLibraryUserProfiles':
                return {
                    reducer: libraryResult_2.getMoreLibraryUserProfiles,
                    node: 'libraryView.result',
                };
            case 'c:mainView:getMoreLibraryEpisodes':
                return {
                    reducer: libraryResult_2.getMoreLibraryEpisodes,
                    node: 'libraryView.result',
                };
            case 'c:mainView:getMoreLibraryPodcasts':
                return {
                    reducer: libraryResult_2.getMoreLibraryPodcasts,
                    node: 'libraryView.result',
                };
            case 'c:mainView:getMoreLibraryRadios':
                return {
                    reducer: libraryResult_2.getMoreLibraryRadios,
                    node: 'libraryView.result',
                };
            case 'c:mainView:addLibrarySong':
                return {
                    reducer: library_1.addLibrarySong,
                    node: 'libraryView.result',
                };
            case 'c:mainView:addLibraryArtist':
                return {
                    reducer: library_1.addLibraryArtist,
                    node: 'libraryView.result',
                };
            case 'c:mainView:addLibraryAlbum':
                return {
                    reducer: library_1.addLibraryAlbum,
                    node: 'libraryView.result',
                };
            case 'c:mainView:addLibraryCollection':
                return {
                    reducer: library_1.addLibraryCollection,
                    node: 'libraryView.result',
                };
            case 'c:mainView:addLibraryUserProfile':
                return {
                    reducer: library_1.addLibraryUserProfile,
                    node: 'libraryView.result',
                };
            case 'c:mainView:addLibraryEpisode':
                return {
                    reducer: library_1.addLibraryEpisode,
                    node: 'libraryView.result',
                };
            case 'c:mainView:addLibraryPodcast':
                return {
                    reducer: library_1.addLibraryPodcast,
                    node: 'libraryView.result',
                };
            case 'c:mainView:addLibraryRadio':
                return {
                    reducer: library_1.addLibraryRadio,
                    node: 'libraryView.result',
                };
            case 'c:mainView:removeFromLibrary':
                return {
                    reducer: library_1.removeFromLibrary,
                    node: 'libraryView.result',
                };
            // preference
            case 'c:mainView:preferenceView':
                return {
                    reducer: preference_1.showPreference,
                    node: '.',
                };
            // user profile
            case 'c:mainView:showUserProfileView':
                return {
                    reducer: showUserProfile_1.showUserProfile,
                    node: 'userProfileView',
                };
            case 'c:mainView:getMoreUserFavoriteSongs':
                return {
                    reducer: userProfile_1.getMoreUserFavoriteSongs,
                    node: 'userProfileView',
                };
            case 'c:mainView:getMoreUserFavoriteArtists':
                return {
                    reducer: userProfile_1.getMoreUserFavoriteArtists,
                    node: 'userProfileView',
                };
            case 'c:mainView:getMoreUserFavoriteAlbums':
                return {
                    reducer: userProfile_1.getMoreUserFavoriteAlbums,
                    node: 'userProfileView',
                };
            case 'c:mainView:getMoreUserFavoriteCollections':
                return {
                    reducer: userProfile_1.getMoreUserFavoriteCollections,
                    node: 'userProfileView',
                };
            case 'c:mainView:getMoreUserCreatedCollections':
                return {
                    reducer: userProfile_1.getMoreUserCreatedCollections,
                    node: 'userProfileView',
                };
            case 'c:mainView:getMoreUserFollowings':
                return {
                    reducer: userProfile_1.getMoreUserFollowings,
                    node: 'userProfileView',
                };
            // Podcast
            case 'c:mainView:showPodcastView':
                return {
                    reducer: showPodcast_1.showPodcastView,
                    node: 'podcastView',
                };
            case 'c:mainView:showRadioView':
                return {
                    reducer: showRadio_1.showRadioView,
                    node: 'radioView',
                };
            // home view
            case 'c:mainView:home:navigation:changeView':
                return {
                    reducer: nagivation_1.changeHomeView,
                    node: 'homeView',
                };
            case 'c:mainView:home:showRecommendView':
                return {
                    reducer: recommend_1.showRecommendView,
                    node: 'homeView',
                };
            case 'c:mainView:home:showCollectionListOptionsView':
                return {
                    reducer: collections_1.showCollectionListOptions,
                    node: 'homeView',
                };
            case 'c:mainView:home:showCollectionListView':
                return {
                    reducer: collections_1.showCollectionListView,
                    node: 'homeView.collectionsView',
                };
            case 'c:mainView:home:collections:getMoreCollections':
                return {
                    reducer: collections_1.getMoreCollections,
                    node: 'homeView.collectionsView',
                };
            case 'c:mainView:home:showAlbumListOptionsView':
                return {
                    reducer: albums_1.showAlbumListOptions,
                    node: 'homeView',
                };
            case 'c:mainView:home:showAlbumListView':
                return {
                    reducer: albums_1.showAlbumList,
                    node: 'homeView',
                };
            case 'c:mainView:home:albums:getMoreAlbums':
                return {
                    reducer: albums_1.getMoreAlbums,
                    node: 'homeView.albumsView',
                };
            case 'c:mainView:home:showArtistListOptionsView':
                return {
                    reducer: artists_1.showArtistListOptions,
                    node: 'homeView',
                };
            case 'c:mainView:home:showArtistListView':
                return {
                    reducer: artists_1.showArtistList,
                    node: 'homeView',
                };
            default:
                return null;
        }
    }
    exports.map = map;
});
