var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
define(["require", "exports", "chord/base/common/assert"], function (require, exports, assert_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.addSearchRadios = exports.addSearchPodcasts = exports.addSearchEpisodes = exports.addSearchCollections = exports.addSearchArtists = exports.addSearchAlbums = exports.addSearchSongs = exports.showSearchResult = void 0;
    function showSearchResult(state, act) {
        assert_1.equal(act.act, 'c:mainView:searchInput');
        var result = __assign(__assign({}, state.result), { view: 'top', songs: act.songs, albums: act.albums, artists: act.artists, collections: act.collections, episodes: act.episodes, podcasts: act.podcasts, radios: act.radios });
        var keywords = act.keyword == state.history.keywords[0] ? __spread(state.history.keywords) : __spread([act.keyword], state.history.keywords.filter(function (keyword) { return keyword != act.keyword; }).slice(0, 999));
        var history = { keywords: keywords };
        return __assign(__assign({}, state), { view: 'searchResult', keyword: act.keyword, history: history, result: result });
    }
    exports.showSearchResult = showSearchResult;
    function addSearchSongs(state, act) {
        assert_1.equal(act.act, 'c:mainView:searchMoreSongs');
        var songsOffset = act.songsOffset;
        var songs = __spread(state.songs, act.songs);
        return __assign(__assign({}, state), { songs: songs, songsOffset: songsOffset });
    }
    exports.addSearchSongs = addSearchSongs;
    function addSearchAlbums(state, act) {
        assert_1.equal(act.act, 'c:mainView:searchMoreAlbums');
        var albumsOffset = act.albumsOffset;
        var albums = __spread(state.albums, act.albums);
        return __assign(__assign({}, state), { albums: albums, albumsOffset: albumsOffset });
    }
    exports.addSearchAlbums = addSearchAlbums;
    function addSearchArtists(state, act) {
        assert_1.equal(act.act, 'c:mainView:searchMoreArtists');
        var artistsOffset = act.artistsOffset;
        var artists = __spread(state.artists, act.artists);
        return __assign(__assign({}, state), { artists: artists, artistsOffset: artistsOffset });
    }
    exports.addSearchArtists = addSearchArtists;
    function addSearchCollections(state, act) {
        assert_1.equal(act.act, 'c:mainView:searchMoreCollections');
        var collectionsOffset = act.collectionsOffset;
        var collections = __spread(state.collections, act.collections);
        return __assign(__assign({}, state), { collections: collections, collectionsOffset: collectionsOffset });
    }
    exports.addSearchCollections = addSearchCollections;
    function addSearchEpisodes(state, act) {
        assert_1.equal(act.act, 'c:mainView:searchMoreEpisodes');
        var episodesOffset = act.episodesOffset;
        var episodes = __spread(state.episodes, act.episodes);
        return __assign(__assign({}, state), { episodes: episodes, episodesOffset: episodesOffset });
    }
    exports.addSearchEpisodes = addSearchEpisodes;
    function addSearchPodcasts(state, act) {
        assert_1.equal(act.act, 'c:mainView:searchMorePodcasts');
        var podcastsOffset = act.podcastsOffset;
        var podcasts = __spread(state.podcasts, act.podcasts);
        return __assign(__assign({}, state), { podcasts: podcasts, podcastsOffset: podcastsOffset });
    }
    exports.addSearchPodcasts = addSearchPodcasts;
    function addSearchRadios(state, act) {
        assert_1.equal(act.act, 'c:mainView:searchMoreRadios');
        var radiosOffset = act.radiosOffset;
        var radios = __spread(state.radios, act.radios);
        return __assign(__assign({}, state), { radios: radios, radiosOffset: radiosOffset });
    }
    exports.addSearchRadios = addSearchRadios;
});
