var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
define(["require", "exports", "chord/base/common/assert"], function (require, exports, assert_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.getMoreUserFollowings = exports.getMoreUserCreatedCollections = exports.getMoreUserFavoriteCollections = exports.getMoreUserFavoriteAlbums = exports.getMoreUserFavoriteArtists = exports.getMoreUserFavoriteSongs = void 0;
    function getMoreUserFavoriteSongs(state, act) {
        assert_1.equal(act.act, 'c:mainView:getMoreUserFavoriteSongs');
        var songsOffset = act.songsOffset;
        var songs = __spread(state.userProfile.songs, act.songs);
        var userProfile = __assign(__assign({}, state.userProfile), { songs: songs });
        return __assign(__assign({}, state), { userProfile: userProfile, songsOffset: songsOffset });
    }
    exports.getMoreUserFavoriteSongs = getMoreUserFavoriteSongs;
    function getMoreUserFavoriteArtists(state, act) {
        assert_1.equal(act.act, 'c:mainView:getMoreUserFavoriteArtists');
        var artistsOffset = act.artistsOffset;
        var artists = __spread(state.userProfile.artists, act.artists);
        var userProfile = __assign(__assign({}, state.userProfile), { artists: artists });
        return __assign(__assign({}, state), { userProfile: userProfile, artistsOffset: artistsOffset });
    }
    exports.getMoreUserFavoriteArtists = getMoreUserFavoriteArtists;
    function getMoreUserFavoriteAlbums(state, act) {
        assert_1.equal(act.act, 'c:mainView:getMoreUserFavoriteAlbums');
        var albumsOffset = act.albumsOffset;
        var albums = __spread(state.userProfile.albums, act.albums);
        var userProfile = __assign(__assign({}, state.userProfile), { albums: albums });
        return __assign(__assign({}, state), { userProfile: userProfile, albumsOffset: albumsOffset });
    }
    exports.getMoreUserFavoriteAlbums = getMoreUserFavoriteAlbums;
    function getMoreUserFavoriteCollections(state, act) {
        assert_1.equal(act.act, 'c:mainView:getMoreUserFavoriteCollections');
        var favoriteCollectionsOffset = act.collectionsOffset;
        var favoriteCollections = __spread(state.userProfile.favoriteCollections, act.collections);
        var userProfile = __assign(__assign({}, state.userProfile), { favoriteCollections: favoriteCollections });
        return __assign(__assign({}, state), { userProfile: userProfile, favoriteCollectionsOffset: favoriteCollectionsOffset });
    }
    exports.getMoreUserFavoriteCollections = getMoreUserFavoriteCollections;
    function getMoreUserCreatedCollections(state, act) {
        assert_1.equal(act.act, 'c:mainView:getMoreUserCreatedCollections');
        var createdCollectionsOffset = act.collectionsOffset;
        var createdCollections = __spread(state.userProfile.createdCollections, act.collections);
        var userProfile = __assign(__assign({}, state.userProfile), { createdCollections: createdCollections });
        return __assign(__assign({}, state), { userProfile: userProfile, createdCollectionsOffset: createdCollectionsOffset });
    }
    exports.getMoreUserCreatedCollections = getMoreUserCreatedCollections;
    function getMoreUserFollowings(state, act) {
        assert_1.equal(act.act, 'c:mainView:getMoreUserFollowings');
        var followingsOffset = act.followingsOffset;
        var followings = __spread(state.userProfile.followings, act.followings);
        var userProfile = __assign(__assign({}, state.userProfile), { followings: followings });
        return __assign(__assign({}, state), { userProfile: userProfile, followingsOffset: followingsOffset });
    }
    exports.getMoreUserFollowings = getMoreUserFollowings;
});
