var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports", "react", "react-redux", "chord/workbench/parts/navigation/browser/action/comback", "chord/workbench/parts/common/component/common"], function (require, exports, React, react_redux_1, comback_1, common_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    var Comeback = /** @class */ (function (_super) {
        __extends(Comeback, _super);
        function Comeback(props) {
            var _this = _super.call(this, props) || this;
            _this.stack = [_this.makeRecord(_this.props.view)];
            _this.handleComeback = _this.handleComeback.bind(_this);
            return _this;
        }
        Comeback.prototype.makeRecord = function (view) {
            return {
                view: view,
                pageYOffset: window.pageYOffset,
            };
        };
        Comeback.prototype.handleComeback = function () {
            var stack = this.stack;
            var currentRecord = stack.pop();
            var preRecord = stack[stack.length - 1];
            var preView = preRecord ? preRecord.view || 'searchView' : 'searchView';
            var preYOffset = currentRecord ? currentRecord.pageYOffset || 0 : 0;
            this.props.comeback(preView);
            // Come back to pre-page offset
            // window.scroll(0, preYOffset);
            //
            // Does not use setTimeout, use process.nextTick
            // setTimeout(() => window.scroll(0, preYOffset), 50);
            process.nextTick(function () { return window.scroll(0, preYOffset); });
        };
        Comeback.prototype.componentWillReceiveProps = function (nextProps) {
            var stack = this.stack;
            var nextView = nextProps.view;
            if (stack.length != 0 && stack[stack.length - 1].view == nextView) {
                return;
            }
            stack.push(this.makeRecord(nextView));
        };
        Comeback.prototype.render = function () {
            return (React.createElement("div", { className: 'navBar-item navBar-item--with-icon-left cursor-pointer', onClick: this.handleComeback },
                React.createElement("div", { className: 'link-subtle navBar-link ellipsis-one-line' },
                    React.createElement("span", { className: "navbar-link__text" }, '\u00A0'),
                    common_1.ComebackIcon)));
        };
        return Comeback;
    }(React.Component));
    function mapStateToProps(state) {
        return {
            view: state.mainView.view,
        };
    }
    function mapDispatchToProps(dispatch) {
        return {
            comeback: function (preView) { return dispatch(comback_1.comeback(preView)); },
        };
    }
    exports.default = react_redux_1.connect(mapStateToProps, mapDispatchToProps)(Comeback);
});
