var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
define(["require", "exports", "chord/base/node/random", "chord/workbench/api/common/state/player", "chord/workbench/api/utils/playItem", "chord/workbench/parts/player/browser/action/playList"], function (require, exports, random_1, player_1, playItem_1, playList_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.handleForward = exports.handlePlayPause = exports.handleRewind = void 0;
    var SHUFFLE_SONG_ID_LIST = [];
    function shuffleIndex() {
        var playList = window.store.getState().player.playList;
        if (SHUFFLE_SONG_ID_LIST.length == 0) {
            SHUFFLE_SONG_ID_LIST = random_1.getRandomSample(__spread(Array(playList.length).keys()), playList.length);
        }
        var index = SHUFFLE_SONG_ID_LIST.pop();
        if (index >= playList.length) {
            SHUFFLE_SONG_ID_LIST.length = 0;
            return shuffleIndex();
        }
        return index;
    }
    function handleRewind() {
        return __awaiter(this, void 0, void 0, function () {
            var player, index_1, state, index;
            return __generator(this, function (_a) {
                player = window.store.getState().player;
                if (player.shuffle) {
                    index_1 = shuffleIndex();
                    return [2 /*return*/, playList_1.handlePlay(index_1)];
                }
                state = window.store.getState();
                index = Math.max(state.player.index - 1, 0);
                return [2 /*return*/, playList_1.handlePlay(index)];
            });
        });
    }
    exports.handleRewind = handleRewind;
    function handlePlayPause() {
        return __awaiter(this, void 0, void 0, function () {
            var state, index, playItem;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        state = window.store.getState();
                        index = state.player.index || 0;
                        playItem = state.player.playList[index];
                        if (!playItem) return [3 /*break*/, 2];
                        // directly change playItem which is in state
                        return [4 /*yield*/, playItem_1.addPlayItemAudios(playItem)];
                    case 1:
                        // directly change playItem which is in state
                        _a.sent();
                        _a.label = 2;
                    case 2: return [2 /*return*/, {
                            type: 'c:player:playPause',
                            act: 'c:player:playPause',
                        }];
                }
            });
        });
    }
    exports.handlePlayPause = handlePlayPause;
    function handleForward() {
        return __awaiter(this, void 0, void 0, function () {
            var player, index_2, state, index;
            return __generator(this, function (_a) {
                player = window.store.getState().player;
                if (player.shuffle) {
                    index_2 = shuffleIndex();
                    return [2 /*return*/, playList_1.handlePlay(index_2)];
                }
                state = window.store.getState();
                switch (player.repeat) {
                    case player_1.RepeatKind.No:
                        index = Math.max(state.player.index + 1, 0);
                        break;
                    case player_1.RepeatKind.Repeat:
                        index = Math.max(state.player.index + 1, 0);
                        index = index % state.player.playList.length;
                        break;
                    case player_1.RepeatKind.RepeatOne:
                        index = Math.max(state.player.index, 0);
                        break;
                }
                return [2 /*return*/, playList_1.handlePlay(index)];
            });
        });
    }
    exports.handleForward = handleForward;
});
