var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
define(["require", "exports", "chord/workbench/api/common/state/player", "chord/workbench/api/utils/playItem", "chord/workbench/parts/notification/action/notice"], function (require, exports, player_1, playItem_1, notice_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.handlePlay = void 0;
    function handlePlay(index) {
        return __awaiter(this, void 0, void 0, function () {
            var state, playList, playItem, nextPlayItems, nextPlayItems_1, nextPlayItems_1_1, item;
            var e_1, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        state = window.store.getState();
                        playList = state.player.playList;
                        if (!(index >= playList.length && window.playPart)) return [3 /*break*/, 2];
                        return [4 /*yield*/, window.playPart.nextPart()];
                    case 1:
                        nextPlayItems = _b.sent();
                        if (nextPlayItems.length > 0) {
                            try {
                                for (nextPlayItems_1 = __values(nextPlayItems), nextPlayItems_1_1 = nextPlayItems_1.next(); !nextPlayItems_1_1.done; nextPlayItems_1_1 = nextPlayItems_1.next()) {
                                    item = nextPlayItems_1_1.value;
                                    // directly add item to state
                                    playList.push(item);
                                }
                            }
                            catch (e_1_1) { e_1 = { error: e_1_1 }; }
                            finally {
                                try {
                                    if (nextPlayItems_1_1 && !nextPlayItems_1_1.done && (_a = nextPlayItems_1.return)) _a.call(nextPlayItems_1);
                                }
                                finally { if (e_1) throw e_1.error; }
                            }
                        }
                        _b.label = 2;
                    case 2:
                        if (!(index < playList.length)) return [3 /*break*/, 5];
                        // directly change playItem which is in state
                        playItem = playList[index];
                        if (!playItem) return [3 /*break*/, 4];
                        return [4 /*yield*/, playItem_1.addPlayItemAudios(playItem)];
                    case 3:
                        _b.sent();
                        if (playItem_1.hasPlayItemAudio(playItem)) {
                            return [3 /*break*/, 5];
                        }
                        // Notice the disable PlayItem
                        notice_1.noticePlayItem(playItem);
                        // Handle repeat
                        switch (state.player.repeat) {
                            case player_1.RepeatKind.No:
                                index = Math.max(index + 1, 0);
                                break;
                            case player_1.RepeatKind.Repeat:
                                index = Math.max(index + 1, 0);
                                index = index % state.player.playList.length;
                                break;
                            case player_1.RepeatKind.RepeatOne:
                                index = null;
                                break;
                        }
                        if (index === null) {
                            return [3 /*break*/, 5];
                        }
                        if (state.player.shuffle) {
                            index = index % state.player.playList.length;
                        }
                        return [3 /*break*/, 2];
                    case 4: return [3 /*break*/, 5];
                    case 5: return [2 /*return*/, {
                            type: 'c:player:play',
                            act: 'c:player:play',
                            index: index,
                        }];
                }
            });
        });
    }
    exports.handlePlay = handlePlay;
});
