define(["require", "exports", "chord/workbench/api/utils/playItem"], function (require, exports, playItem_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.switchKbps = void 0;
    /**
     * Switch playItem's audio to one which of kbps is equal less to @param kbps
     *
     * If kbps is -1, we switch to 2nd audio in audios
     */
    function switchKbps(kbps) {
        var store = window.store;
        var state = store.getState();
        var playList = state.player.playList;
        var index = state.player.index;
        var playItem = playList[index];
        var audio = playItem_1.selectAudio(playItem.audios);
        var audios = playItem.audios.filter(function (a) { return a.kbps <= audio.kbps; });
        if (kbps == -1) {
            audios = audios.slice(1);
        }
        else {
            audios = audios.filter(function (audio) { return audio.kbps <= kbps; });
        }
        if (audios.length == 0) {
            return false;
        }
        ;
        kbps = audios[0].kbps;
        playItem.audios = audios;
        return true;
    }
    exports.switchKbps = switchKbps;
});
