var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports", "react", "react-redux", "chord/workbench/api/common/state/player", "chord/workbench/parts/player/browser/action/control"], function (require, exports, React, react_redux_1, player_1, control_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.Controller = void 0;
    var Controller = /** @class */ (function (_super) {
        __extends(Controller, _super);
        function Controller(props) {
            var _this = _super.call(this, props) || this;
            _this.state = { shuffle: false, repeat: player_1.RepeatKind.No };
            _this.handleShuffle = _this.handleShuffle.bind(_this);
            _this.handleRepeat = _this.handleRepeat.bind(_this);
            return _this;
        }
        Controller.prototype.handleShuffle = function () {
            var player = window.store.getState().player;
            this.setState(function (state) {
                var shuffle = !state.shuffle;
                var repeat = shuffle ? player_1.RepeatKind.No : state.repeat;
                player.shuffle = shuffle;
                player.repeat = repeat;
                return { shuffle: shuffle, repeat: repeat };
            });
        };
        Controller.prototype.handleRepeat = function () {
            var player = window.store.getState().player;
            this.setState(function (state) {
                var repeat = (state.repeat + 1) % 3;
                var shuffle = repeat != player_1.RepeatKind.No ? false : state.shuffle;
                player.shuffle = shuffle;
                player.repeat = repeat;
                return { shuffle: shuffle, repeat: repeat };
            });
        };
        Controller.prototype.render = function () {
            var status = this.props.playing ? 'pause' : 'play';
            var shuffle = this.state.shuffle;
            var repeat = this.state.repeat;
            var repeatIcon = 'spoticon-repeat-16';
            if (repeat == player_1.RepeatKind.RepeatOne) {
                repeatIcon = 'spoticon-repeatonce-16';
            }
            var repeatActive = repeat != player_1.RepeatKind.No ? 'active' : 'disabled';
            return (React.createElement("div", { className: 'player-controls__buttons' },
                React.createElement("button", { className: "control-button spoticon-shuffle-16 control-button--" + (shuffle ? 'active' : 'disabled') + " cursor-pointer", onClick: this.handleShuffle }),
                React.createElement("button", { className: 'control-button spoticon-rewind-16 cursor-pointer', onClick: this.props.rewind }),
                React.createElement("button", { className: "control-button spoticon-" + status + "-16 control-button--circled cursor-pointer", onClick: this.props.playPause }),
                React.createElement("button", { className: 'control-button spoticon-forward-16 cursor-pointer', onClick: this.props.forward }),
                React.createElement("button", { className: "control-button " + repeatIcon + " control-button--" + repeatActive + " cursor-pointer", onClick: this.handleRepeat })));
        };
        return Controller;
    }(React.Component));
    exports.Controller = Controller;
    function mapStateToProps(state) {
        return {
            playing: state.player.playing,
        };
    }
    function mapDispatchToProps(dispatch) {
        return {
            rewind: function () { return control_1.handleRewind().then(function (act) { return dispatch(act); }); },
            playPause: function () { return control_1.handlePlayPause().then(function (act) { return dispatch(act); }); },
            forward: function () { return control_1.handleForward().then(function (act) { return dispatch(act); }); },
        };
    }
    exports.default = react_redux_1.connect(mapStateToProps, mapDispatchToProps)(Controller);
});
