var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports", "react", "react-redux", "chord/workbench/parts/mainView/browser/action/addLibraryItem", "chord/workbench/parts/mainView/browser/action/removeFromLibrary", "chord/library/core/library"], function (require, exports, React, react_redux_1, addLibraryItem_1, removeFromLibrary_1, library_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    var LikeButton = /** @class */ (function (_super) {
        __extends(LikeButton, _super);
        function LikeButton(props) {
            var _this = _super.call(this, props) || this;
            _this.handleLibraryActFunc = _this.handleLibraryActFunc.bind(_this);
            return _this;
        }
        LikeButton.prototype.handleLibraryActFunc = function (playItem) {
            var handleLibraryActFunc = playItem.like ? this.props.handleRemoveFromLibrary
                : (playItem.type == 'song') ? this.props.handleAddLibrarySong : this.props.handleAddLibraryEpisode;
            playItem.like = !playItem.like;
            handleLibraryActFunc(playItem);
            this.forceUpdate();
        };
        LikeButton.prototype.render = function () {
            var _this = this;
            var playItem = this.props.playItem;
            if (!playItem)
                return null;
            var like = library_1.defaultLibrary.exists(playItem);
            playItem.like = like;
            var likeIconClass = like ? 'spoticon-heart-active-16' : 'spoticon-heart-16';
            return (React.createElement("button", { className: "control-button " + likeIconClass + " cursor-pointer", onClick: function () { return _this.handleLibraryActFunc(playItem); } }));
        };
        return LikeButton;
    }(React.Component));
    function mapStateToProps(state) {
        return {
            playItem: state.player.playList.length ? state.player.playList[state.player.index] : null,
        };
    }
    function mapDispatchToProps(dispatch) {
        return {
            handleAddLibrarySong: function (song) { return dispatch(addLibraryItem_1.handleAddLibrarySong(song)); },
            handleAddLibraryEpisode: function (episode) { return dispatch(addLibraryItem_1.handleAddLibraryEpisode(episode)); },
            handleRemoveFromLibrary: function (item) { return dispatch(removeFromLibrary_1.handleRemoveFromLibrary(item)); },
        };
    }
    exports.default = react_redux_1.connect(mapStateToProps, mapDispatchToProps)(LikeButton);
});
