var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports", "react", "react-redux", "chord/music/common/size", "chord/workbench/api/utils/playItem", "chord/css!../media/songInfo"], function (require, exports, React, react_redux_1, size_1, playItem_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.SongInfo = exports.Cover = void 0;
    var Cover = /** @class */ (function (_super) {
        __extends(Cover, _super);
        function Cover(props) {
            return _super.call(this, props) || this;
        }
        Cover.prototype.render = function () {
            if (!this.props.song)
                return null;
            var item = new playItem_1.PlayItem(this.props.song);
            var cover = item.cover(size_1.ESize.Small);
            return (React.createElement("span", { draggable: true },
                React.createElement("div", { className: 'player__cover-art' },
                    React.createElement("div", { className: "cover-art", style: { width: '56px', height: '56px', background: 'none' }, onClick: this.props.onclick },
                        React.createElement("div", null,
                            React.createElement("div", { className: "cover-art-image cover-art-image-loaded", style: { backgroundImage: "url(\"" + cover + "\")" } }))))));
        };
        return Cover;
    }(React.Component));
    var SongInfo = /** @class */ (function (_super) {
        __extends(SongInfo, _super);
        function SongInfo(props) {
            return _super.call(this, props) || this;
        }
        SongInfo.prototype.render = function () {
            if (!this.props.song)
                return null;
            var item = new playItem_1.PlayItem(this.props.song);
            var itemName = item.name(), ownerName = item.ownerName();
            return (React.createElement("div", { className: 'track-info ellipsis-one-line' },
                React.createElement("div", { className: 'track-info__name ellipsis-one-line' },
                    React.createElement("span", null, itemName)),
                React.createElement("div", { className: 'track-info__artists ellipsis-one-line' },
                    React.createElement("span", null, ownerName))));
        };
        return SongInfo;
    }(React.Component));
    function mapStateToProps(state) {
        if (state.player.index == null) {
            return { song: null };
        }
        if (state.player.playList.length != 0) {
            var song = state.player.playList[state.player.index];
            return { song: song };
        }
        else {
            return { song: null };
        }
    }
    var componentCreator = react_redux_1.connect(mapStateToProps);
    var _Cover = componentCreator(Cover);
    exports.Cover = _Cover;
    var _SongInfo = componentCreator(SongInfo);
    exports.SongInfo = _SongInfo;
});
