var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
define(["require", "exports", "chord/base/common/assert", "chord/workbench/api/node/audio", "chord/workbench/api/utils/playItem"], function (require, exports, assert_1, audio_1, playItem_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.forward = exports.playPause = exports.rewind = void 0;
    function rewind(state, act) {
        assert_1.equal(act.act, 'c:player:rewind');
        if (state.index != null && state.index > 0) {
            // stop current audio
            if (audio_1.CAudio.hasAudio()) {
                audio_1.CAudio.stop();
            }
            var index = state.index - 1;
            var playItem = state.playList[index];
            // new audio
            // TODO: read kbps configuration
            var audio = playItem_1.selectAudio(playItem.audios);
            var audioUrl = audio.path || audio.url;
            audio_1.CAudio.makeAudio(audioUrl, (new playItem_1.PlayItem(playItem)).id());
            // play now
            audio_1.CAudio.play();
            audio_1.CAudio.volume(state.volume);
            return __assign(__assign({}, state), { playing: true, index: index, kbps: audio.kbps });
        }
        return __assign({}, state);
    }
    exports.rewind = rewind;
    function playPause(state, act) {
        assert_1.equal(act.act, 'c:player:playPause');
        if (audio_1.CAudio.hasAudio()) {
            var playing = false;
            if (audio_1.CAudio.playing()) {
                audio_1.CAudio.pause();
            }
            else {
                audio_1.CAudio.play();
                audio_1.CAudio.volume(state.volume);
                playing = true;
            }
            return __assign(__assign({}, state), { playing: playing });
        }
        else {
            // plays index's playItem
            if (state.playList.length != 0) {
                var index = state.index || 0;
                var playItem = state.playList[index];
                // new audio
                // TODO: read kbps configuration
                var audio = playItem_1.selectAudio(playItem.audios);
                var audioUrl = audio.path || audio.url;
                audio_1.CAudio.makeAudio(audioUrl, (new playItem_1.PlayItem(playItem)).id());
                // play now
                audio_1.CAudio.play();
                audio_1.CAudio.volume(state.volume);
                return __assign(__assign({}, state), { playing: true, index: index, kbps: audio.kbps });
            }
            return __assign(__assign({}, state), { playing: false });
        }
    }
    exports.playPause = playPause;
    function forward(state, act) {
        assert_1.equal(act.act, 'c:player:forward');
        if (state.index < state.playList.length - 1) {
            // stop current audio
            if (audio_1.CAudio.hasAudio()) {
                audio_1.CAudio.stop();
            }
            var index = state.index + 1;
            var playItem = state.playList[index];
            // new audio
            // TODO: read kbps configuration
            var audio = playItem_1.selectAudio(playItem.audios);
            var audioUrl = audio.path || audio.url;
            audio_1.CAudio.makeAudio(audioUrl, (new playItem_1.PlayItem(playItem)).id());
            // play now
            audio_1.CAudio.play();
            audio_1.CAudio.volume(state.volume);
            return __assign(__assign({}, state), { playing: true, index: index, kbps: audio.kbps });
        }
        var playing = audio_1.CAudio.hasAudio() ? audio_1.CAudio.playing() : false;
        return __assign(__assign({}, state), { playing: playing });
    }
    exports.forward = forward;
});
