var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
define(["require", "exports", "chord/base/common/assert", "chord/workbench/api/node/audio", "chord/workbench/api/utils/playItem", "chord/workbench/api/utils/playItem", "chord/workbench/events/autoLoadNextPlayItems"], function (require, exports, assert_1, audio_1, playItem_1, playItem_2, autoLoadNextPlayItems_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.playAudio = void 0;
    function playAudio(state, act) {
        assert_1.equal(act.act, 'c:player:play');
        var index = act.index;
        if (!(index == state.index && audio_1.CAudio.hasAudio() && audio_1.CAudio.playing())) {
            var playItem = state.playList[index];
            if (playItem) {
                // remove auto-load next playing items for song
                if (playItem.type == 'song')
                    autoLoadNextPlayItems_1.removeGlobelPlayPart();
                // TODO: read kbps configuration
                var audio = playItem_2.selectAudio(playItem.audios);
                var audioUrl = audio.path || audio.url;
                audio_1.CAudio.makeAudio(audioUrl, (new playItem_1.PlayItem(playItem)).id());
                // play now
                audio_1.CAudio.play();
                audio_1.CAudio.volume(state.volume);
                return __assign(__assign({}, state), { playing: true, index: index, kbps: audio.kbps });
            }
        }
        var playing = audio_1.CAudio.hasAudio() ? audio_1.CAudio.playing() : false;
        return __assign(__assign({}, state), { playing: playing });
    }
    exports.playAudio = playAudio;
});
