define(["require", "exports", "chord/workbench/parts/player/browser/reducer/audioSeek", "chord/workbench/parts/player/browser/reducer/control", "chord/workbench/parts/player/browser/reducer/playList", "chord/workbench/parts/player/browser/reducer/playOne", "chord/workbench/parts/player/browser/reducer/playMany", "chord/workbench/parts/player/browser/reducer/playArtist", "chord/workbench/parts/player/browser/reducer/playAlbum", "chord/workbench/parts/player/browser/reducer/playCollection", "chord/workbench/parts/player/browser/reducer/playUser", "chord/workbench/parts/player/browser/reducer/volume", "chord/workbench/parts/player/browser/reducer/addToQueue"], function (require, exports, audioSeek_1, control_1, playList_1, playOne_1, playMany_1, playArtist_1, playAlbum_1, playCollection_1, playUser_1, volume_1, addToQueue_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.map = void 0;
    function map(act) {
        switch (act) {
            case 'c:player:play':
                return {
                    reducer: playList_1.playAudio,
                    node: '.',
                };
            case 'c:player:playOne':
                return {
                    reducer: playOne_1.playOne,
                    node: '.',
                };
            case 'c:player:playMany':
                return {
                    reducer: playMany_1.playMany,
                    node: '.',
                };
            case 'c:player:playArtist':
                return {
                    reducer: playArtist_1.playArtist,
                    node: '.',
                };
            case 'c:player:playAlbum':
                return {
                    reducer: playAlbum_1.playAlbum,
                    node: '.',
                };
            case 'c:player:playCollection':
                return {
                    reducer: playCollection_1.playCollection,
                    node: '.',
                };
            case 'c:player:playUserFavoriteSongs':
                return {
                    reducer: playUser_1.playUserFavoriteSongs,
                    node: '.',
                };
            case 'c:player:volume':
                return {
                    reducer: volume_1.changeVolume,
                    node: '.',
                };
            case 'c:player:seek':
                return {
                    reducer: audioSeek_1.audioSeek,
                    node: '.'
                };
            case 'c:player:rewind':
                return {
                    reducer: control_1.rewind,
                    node: '.',
                };
            case 'c:player:playPause':
                return {
                    reducer: control_1.playPause,
                    node: '.',
                };
            case 'c:player:forward':
                return {
                    reducer: control_1.forward,
                    node: '.',
                };
            case 'c:player:addToQueue':
                return {
                    reducer: addToQueue_1.addToQueue,
                    node: '.',
                };
            default:
                return null;
        }
    }
    exports.map = map;
});
